      subroutine boost(g,v,p)
c----------------------------------------------------------------------c
c Returns a four vector p boosted back to the frame of velocity v
c
c Input: g - Lorentz gamma factor,
c        v - velocity of the frame,
c        p - four momentum before boost. 
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 3 July, 2001; modiffied on 
c----------------------------------------------------------------------c

      implicit none
      integer, parameter :: dp=kind(1.d0)

      real(dp) :: g,v(3),p(0:3),p0,pv

      pv=dot_product(v,p(1:))
      p0=p(0)
      p(0)=g*(p0+pv)
      p(1:)=p(1:)+g*(g*pv/(g+1.d0)+p0)*v

      end
