      subroutine carlos(f,ndim,ncall,int,sigma)
c----------------------------------------------------------------------c
c The Monte Carlo integration routine
c
c Input: f - integrand,
c        ndim - No. of dimensions,
c        ncall - max. number of calls.
c Output:
c        int - integral,
c        sigma = sqrt(variance/ncall) - standard deviation.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 21 Feb, 2002; modiffied on 6 March, 2002; 20 March, 2002
c----------------------------------------------------------------------c

      use drivec
      use distribs

      implicit none

      integer, parameter :: dp=kind(1.d0)
      integer :: ndim,ncall
      real(dp) :: f,int,sigma

      integer :: i,j
      real(dp) :: var,a,a2
      real :: x(ndim),rand


      int=0.d0
      var=0.d0

      do i=1,ncall

c Choose the kinematics:

       if (iscan == 0) then
ckk>
c        call random_number(rand)
        call ranlux(rand,1)
ckk<
        do j=1,nkin
         if (dble(rand) < xmc(j)) then
          ikin=j
          exit
         end if
        end do
       end if

c Generate random argument:

ckk>
c       call random_number(x)
        call ranlux(x,ndim)
ckk<

       a=f(dble(x))

       a2=a*a
       int=int+a
       var=var+a2

c Distributions:

      if (idis == 1 .and. iscan == 0) then
       do j=1,ndist
        if (ibin(j) > 0) then
         di(ibin(j),j)=di(ibin(j),j)+a
        end if
       end do
      end if

      end do

      int=int/ncall
      var=var/ncall

      var=var-int*int
      sigma=sqrt(abs(var)/ncall)

      if (idis == 1 .and. iscan == 0) then
       di=di/ncall
      end if

      end

