      subroutine couplsma(e,sw2,mw,mh,
     &                    gll,guu,gdd,
     &                    znnm,znnp,zllm,zllp,zuum,zuup,zddm,zddp,
     &                    wff,
     &                    gww,zww,
     &                    ggww,gzww,zzww,wwww,
     &                    csff,c3ff,chff,
     &                    csaw,cszw,chww,chzz,
     &                    cass,czss,cw3s,cwhs,cz3h,
     &                    chss)
c----------------------------------------------------------------------c
c Returns the standard model couplings between fermions and gauge bosons
c and gauge bosons between gauge bosons
c 
c Input: e - electric charge,
c        sw2 - complex electroweak mixing parameter.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 13 November, 2000; modified 1 November, 2001
c----------------------------------------------------------------------c

      implicit none

      complex(8) :: e,sw2,mw,mh,
     &              gll,guu,gdd,
     &              znnm,znnp,zllm,zllp,zuum,zuup,zddm,zddp,
     &              wff,
     &              gww,zww,
     &              ggww,gzww,zzww,wwww,
     &              csff,c3ff,chff,
     &              csaw,cszw,chww,chzz,
     &              cass,czss,cw3s,cwhs,cz3h,
     &              chss

      complex(8) :: sw,cw2,cw
      complex(8), parameter :: ocom=(0.d0,0.d0)

      sw=sqrt(sw2)
      cw2=1.d0-sw2
      cw=sqrt(cw2)

c Photon couplings to fermions:

      gll=-e                                 !  gll=e
      guu=2.d0/3.d0*e                        !  guu=-2.d0/3.d0*e
      gdd=-1.d0/3.d0*e                       !  gdd=1.d0/3.d0*e

c Z boson couplings to fermions:

      znnm=1.d0/(2.d0*sw*cw)*e
      znnp=ocom

      zllm=-(1.d0-2.d0*sw2)/(2.d0*sw*cw)*e
      zllp=sw/cw*e

      zuum=(1.d0-4.d0/3.d0*sw2)/(2.d0*sw*cw)*e
      zuup=-2.d0/3.d0*sw/cw*e

      zddp=sw/cw/3.d0*e
      zddm=-(1.d0-2.d0/3.d0*sw2)/(2.d0*sw*cw)*e

c W boson coupling to fermions:

      wff=e/sqrt(2.d0)/sw

c Triple gauge boson couplings:

      gww=-e                                 !  gww=e
      zww=-cw/sw*e

c Quartic gauge boson couplings:

      ggww=e**2
      gzww=cw/sw*e**2                        !  gzww=-cw/sw*e**2
      zzww=cw2/sw2*e**2
      wwww=-1.d0/sw2*e**2

c Scalar-fermion couplings:

      csff=e/(sqrt(2.d0)*sw*mw)
      c3ff=-e/(2.d0*sw*mw)                   ! e/(2.d0*sw*mw)
      chff=-e/(2.d0*sw*mw)

c Scalar-gauge boson couplings:

      csaw=e*mw                              ! csaw=-e*mw
ckk>
c      cszw=e*mw*sw/cw                       ! cszw=-e*mw*sw/cw
      cszw=-e*mw*sw/cw 
ckk<
      chww=e*mw/sw
      chzz=e*mw/sw/cw**2

c Outgoing phi-(p1), incoming phi-(p2):

      cass=-e                                ! cass=e
ckk>
c      czss=-e*(sw**2-cw**2)/(2.d0*sw*cw)
      czss=e*(sw**2-cw**2)/(2.d0*sw*cw)
ckk<

c Outgoing phi3(p1), incoming phi-(p2):

      cw3s=e/(2.d0*sw)                       ! cw3s=-e/(2.d0*sw)

c Outgoing H(p1), incoming phi-(p2):

      cwhs=-e/(2.d0*sw)

c Outgoing phi3(p1), incoming H(p2):

      cz3h=e/(2.d0*sw*cw)                    ! cz3h=-e/(2.d0*sw*cw)

c Triple scalar couplings:

      chss=-e*mh**2/(2.d0*sw*mw)

      end


