      real(kind(1.d0)) function cross(x)
c----------------------------------------------------------------------c
c The unpolarized cross section as a function called by carlos
c
c Input:  x(10) - random numbers supplied by carlos
c
c Physical parameters are transfered through the common blocks /inprms/
c and /cbrems/.
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 24 February, 1998, modiffied on 27 March, 1998; 5 March, 2001
c----------------------------------------------------------------------c

      use drivec
      use cutvalues
      use inprms
      use mathprms 
      use helproc
      use parproc
      use gaugepar
      use distribs
ckk>
c      use topapprox
ckk<
      implicit none
      integer, parameter :: dp=kind(1.d0)

      real(dp) :: x(10)
      real(dp), dimension(0:3) :: p1,p2,p3,p4,p5,p6,p7,
     &                           p0,p30,p40,p50,p60
      real(dp), dimension(0:4) :: ps1,ps2,ps3,ps4,ps5,ps6,ps7,ps0,
     &                           ps30,ps40,ps50,ps60

      real(dp) :: dlips,flux,mat2,mat2ww,s34,eeffffgs,cbr,srr,
     &            s34r,dlinv

      real :: rand

      integer :: i,j,id,ikin0

      real(dp), dimension(1:3) :: pv34

      real(dp) :: mat2m,crossm,sudmn,sudmng,stbtn,stbtng

      integer :: ifirst=1,iwrite=1

      save

c      if (imad == 1) then
c      if (ifirst == 1) then
c        call initialize
c       ifirst=0
c      end if
c      end if

      if (irad < 2) then

       if (ikin == 1) then
         call kineeffff(0,1,iw34,iw56,ecm,mw,gamw,mw,gamw,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 2) then
         call kineeffff(0,0,0,2,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 3) then
         call kineeffff(0,0,0,2,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 4) then
         call kineeffff(0,0,2,2,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 5) then
         call kineeffff(0,0,1,1,ecm,mz,gamz,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 6) then
         call kineeffff(1,1,iw34,0,ecm,mw,gamw,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 7) then
         call kineeffff(0,1,1,0,ecm,mw,gamw,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 8) then
         call kineeffff(0,0,0,1,ecm,zero,zero,mw,gamw,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 9) then
         call kineeffff(0,0,1,2,ecm,mz,gamz,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 10) then
         call kineeffff(0,0,1,2,ecm,mz,gamz,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 11) then
         call kineeffff(2,0,iw34,0,ecm,mw,gamw,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,
     &              p6,ps6,m6,p4,ps4,m4,p3,ps3,m3,dl(ikin),flux)
       else if (ikin == 12) then
         call kineeffff(0,0,1,1,ecm,mz,gamz,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,
     &              p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 13) then
         call kineeffff(1,0,1,0,ecm,mz,gamz,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 14) then
         call kineeffff(2,0,1,0,ecm,mz,gamz,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p4,ps4,m4,p5,ps5,m5,dl(ikin),flux)
       else if (ikin == 15) then
         call kineeffff(1,0,2,0,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 16) then
         call kineeffff(2,0,2,0,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p4,ps4,m4,p5,ps5,m5,dl(ikin),flux)
       else if (ikin == 17) then
         call kineeffff(0,0,1,1,ecm,mh,gamhig,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p4,ps4,m4,p5,ps5,m5,dl(ikin),flux)
       else if (ikin == 18) then
         call kineeffff(0,0,1,1,ecm,mz,gamz,mh,gamhig,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p4,ps4,m4,p5,ps5,m5,dl(ikin),flux)
       else if (ikin == 19) then
         call kineetbff(1,1,ecm,mt,gamt,mw,gamw,x,
     &                  p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &                  p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 20) then
         call kineetbff(0,2,ecm,zero,zero,zero,zero,x,
     &                  p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &                  p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 21) then
         call kineetbff(0,2,ecm,zero,zero,zero,zero,x,
     &                  p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,
     &                  p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 22) then
         call kineetbff(0,2,ecm,zero,zero,zero,zero,x,
     &                  p1,ps1,m1,p2,ps2,m2,p6,ps6,m6,
     &                  p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 23) then
         call kineetbff(0,2,ecm,zero,zero,zero,zero,x,
     &                  p1,ps1,m1,p2,ps2,m2,p4,ps4,m4,
     &                  p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 24) then
         call kineeffff(0,0,2,0,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 25) then
         call kineeffff(0,1,2,0,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 26) then
         call kineeffff(0,2,2,0,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 27) then
         call kineeffff(0,1,2,2,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 28) then
         call kineeffff(0,2,2,2,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 29) then
         call kineeffff(0,1,2,1,ecm,zero,zero,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 30) then
         call kineeffff(0,2,2,1,ecm,zero,zero,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 31) then
         call kineeffff(0,1,1,2,ecm,mz,gamz,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 32) then
         call kineeffff(0,2,1,2,ecm,mz,gamz,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 33) then
         call kineeffff(0,1,1,1,ecm,mz,gamz,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
       else if (ikin == 34) then
         call kineeffff(0,2,1,1,ecm,mz,gamz,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &              p6,ps6,m6,dl(ikin),flux)
ckk
       else if (ikin == 35) then
         call kineeffff(0,0,2,0,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 36) then
         call kineeffff(0,1,2,0,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 37) then
         call kineeffff(0,2,2,0,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 38) then
         call kineeffff(0,1,2,2,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 39) then
         call kineeffff(0,2,2,2,ecm,zero,zero,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 40) then
         call kineeffff(0,1,2,1,ecm,zero,zero,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 41) then
         call kineeffff(0,2,2,1,ecm,zero,zero,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 42) then
         call kineeffff(0,1,1,2,ecm,mz,gamz,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 43) then
         call kineeffff(0,2,1,2,ecm,mz,gamz,zero,zero,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 44) then
         call kineeffff(0,1,1,1,ecm,mz,gamz,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)
       else if (ikin == 45) then
         call kineeffff(0,2,1,1,ecm,mz,gamz,mz,gamz,x,
     &              p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,
     &              p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,dl(ikin),flux)

      else
       write(*,*)'ikin =',ikin,' IS NOT ALLOWED'
      end if  ! ikin

      ikin0=ikin

      if (nid > 1) then

      ikin0=0

      if (ident == 2) then
       p0=p3
       p3=p5
       p5=p0
       ps0=ps3
       ps3=ps5
       ps5=ps0
      else if (ident == 3) then
       p0=p4
       p4=p6
       p6=p0
       ps0=ps4
       ps4=ps6
       ps6=ps0
      else if (ident == 4) then
       p0=p3
       p3=p5
       p5=p0
       ps0=ps3
       ps3=ps5
       ps5=ps0
       p0=p4
       p4=p6
       p6=p0
       ps0=ps4
       ps4=ps6
       ps6=ps0
      end if

      p30=p3
      p40=p4
      p50=p5
      p60=p6
      ps30=ps3
      ps40=ps4
      ps50=ps5
      ps60=ps6

      end if ! nid

      if (dl(ikin) > 0.d0) then

       if (icuts == 1) then
c The canonical cuts:
        call cancuts(p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,
     &               p6,ps6,p7,ps7,cross)

        if (cross == 0.d0) then
         return
        end if
       else if (icuts == 2) then
c A cut on the final electron angle:
        if (abs(ps5(1)) > cteb) then
         cross=0.d0
         return
        end if
       else if (icuts == 3) then
c A cut on the final electron and positron angle:
        if (abs(ps5(1)) > cteb) then
         cross=0.d0
         return
        else if (abs(ps4(1)) > cteb) then
         cross=0.d0
         return
        end if
       end if ! icuts

      dlinv=0.d0

      do id=1,nid

      if (ikin0 /= 1 .and. bw0(1) > 0.d0) then
       call psneeffff(0,1,iw34,iw56,ecm,mw,gamw,mw,gamw,
     &            p1,m1,p2,m2,p3,m3,p4,m4,p5,m5,p6,m6,dl(1))
       end if

      if (ikin0 /= 2 .and. bw0(2) > 0.d0) then
       call psneeffff(0,0,0,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(2))
       end if

      if (ikin0 /= 3 .and. bw0(3) > 0.d0) then
       call psneeffff(0,0,0,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(3))
       end if

      if (ikin0 /= 4 .and. bw0(4) > 0.d0) then
       call psneeffff(0,0,2,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(4))
      end if

      if (ikin0 /= 5 .and. bw0(5) > 0.d0) then
       call psneeffff(0,0,1,1,ecm,mz,gamz,mz,gamz,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(5))
      end if

      if (ikin0 /= 6 .and. bw0(6) > 0.d0) then
       call psneeffff(1,1,iw34,0,ecm,mw,gamw,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p4,m4,p5,m5,p6,m6,dl(6))
       end if

      if (ikin0 /= 7 .and. bw0(7) > 0.d0) then
       call psneeffff(0,1,1,0,ecm,mw,gamw,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p4,m4,p5,m5,p6,m6,dl(7))
       end if

      if (ikin0 /= 8 .and. bw0(8) > 0.d0) then
       call psneeffff(0,0,0,1,ecm,zero,zero,mw,gamw,
     &            p1,m1,p2,m2,p3,m3,p4,m4,p5,m5,p6,m6,dl(8))
       end if

      if (ikin0 /= 9 .and. bw0(9) > 0.d0) then
       call psneeffff(0,0,1,2,ecm,mz,gamz,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(9))
       end if

      if (ikin0 /= 10 .and. bw0(10) > 0.d0) then
       call psneeffff(0,0,1,2,ecm,mz,gamz,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(10))
       end if

      if (ikin0 /= 11 .and. bw0(11) > 0.d0) then
       call psneeffff(2,0,iw34,0,ecm,mw,gamw,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p6,m6,p4,m4,p3,m3,dl(11))
       end if

      if (ikin0 /= 12 .and. bw0(12) > 0.d0) then
       call psneeffff(0,0,1,1,ecm,mz,gamz,mz,gamz,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(12))
      end if

      if (ikin0 /= 13 .and. bw0(13) > 0.d0) then
       call psneeffff(1,0,1,0,ecm,mz,gamz,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(13))
       end if

      if (ikin0 /= 14 .and. bw0(14) > 0.d0) then
       call psneeffff(2,0,1,0,ecm,mz,gamz,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,dl(14))
       end if

      if (ikin0 /= 15 .and. bw0(15) > 0.d0) then
       call psneeffff(1,0,2,0,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(15))
       end if

      if (ikin0 /= 16 .and. bw0(16) > 0.d0) then
       call psneeffff(2,0,2,0,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,dl(16))
       end if

      if (ikin0 /= 17 .and. bw0(17) > 0.d0) then
       call psneeffff(0,0,1,1,ecm,mh,gamhig,mz,gamz,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,dl(17))
       end if

      if (ikin0 /= 18 .and. bw0(18) > 0.d0) then
       call psneeffff(0,0,1,1,ecm,mz,gamz,mh,gamhig,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p4,m4,p5,m5,dl(18))
       end if

      if (ikin0 /= 19 .and. bw0(19) > 0.d0) then
       call psneetbff(1,1,ecm,mt,gamt,mw,gamw,
     &            p1,m1,p2,m2,p3,m3,p4,m4,p5,m5,p6,m6,dl(19))
       end if

      if (ikin0 /= 20 .and. bw0(20) > 0.d0) then
       call psneetbff(0,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(20))
       end if

      if (ikin0 /= 21 .and. bw0(21) > 0.d0) then
       call psneetbff(0,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(21))
       end if

      if (ikin0 /= 22 .and. bw0(22) > 0.d0) then
       call psneetbff(0,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p6,m6,p3,m3,p5,m5,p4,m4,dl(22))
       end if

      if (ikin0 /= 23 .and. bw0(23) > 0.d0) then
       call psneetbff(0,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p4,m4,p5,m5,p3,m3,p6,m6,dl(23))
       end if

      if (ikin0 /= 24 .and. bw0(24) > 0.d0) then
       call psneeffff(0,0,2,0,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(24))
       end if

      if (ikin0 /= 25 .and. bw0(25) > 0.d0) then
       call psneeffff(0,1,2,0,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(25))
       end if

      if (ikin0 /= 26 .and. bw0(26) > 0.d0) then
       call psneeffff(0,2,2,0,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(26))
       end if

      if (ikin0 /= 27 .and. bw0(27) > 0.d0) then
       call psneeffff(0,1,2,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(27))
       end if

      if (ikin0 /= 28 .and. bw0(28) > 0.d0) then
       call psneeffff(0,2,2,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(28))
       end if

      if (ikin0 /= 29 .and. bw0(29) > 0.d0) then
       call psneeffff(0,1,2,1,ecm,zero,zero,mz,gamz,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(29))
       end if

      if (ikin0 /= 30 .and. bw0(30) > 0.d0) then
       call psneeffff(0,2,2,1,ecm,zero,zero,mz,gamz,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(30))
       end if

      if (ikin0 /= 31 .and. bw0(31) > 0.d0) then
       call psneeffff(0,1,1,2,ecm,mz,gamz,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(31))
       end if

      if (ikin0 /= 32 .and. bw0(32) > 0.d0) then
       call psneeffff(0,2,1,2,ecm,mz,gamz,zero,zero,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(32))
       end if

      if (ikin0 /= 33 .and. bw0(33) > 0.d0) then
       call psneeffff(0,1,1,1,ecm,mz,gamz,mz,gamz,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(33))
       end if

      if (ikin0 /= 34 .and. bw0(34) > 0.d0) then
       call psneeffff(0,2,1,1,ecm,mz,gamz,mz,gamz,
     &            p1,m1,p2,m2,p5,m5,p4,m4,p3,m3,p6,m6,dl(34))
       end if
ckk
      if (ikin0 /= 35 .and. bw0(35) > 0.d0) then
       call psneeffff(0,0,2,0,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(35))
       end if

      if (ikin0 /= 36 .and. bw0(36) > 0.d0) then
       call psneeffff(0,1,2,0,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(36))
       end if

      if (ikin0 /= 37 .and. bw0(37) > 0.d0) then
       call psneeffff(0,2,2,0,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(37))
       end if

      if (ikin0 /= 38 .and. bw0(38) > 0.d0) then
       call psneeffff(0,1,2,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(38))
       end if

      if (ikin0 /= 39 .and. bw0(39) > 0.d0) then
       call psneeffff(0,2,2,2,ecm,zero,zero,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(39))
       end if

      if (ikin0 /= 40 .and. bw0(40) > 0.d0) then
       call psneeffff(0,1,2,1,ecm,zero,zero,mz,gamz,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(40))
       end if

      if (ikin0 /= 41 .and. bw0(41) > 0.d0) then
       call psneeffff(0,2,2,1,ecm,zero,zero,mz,gamz,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(41))
       end if

      if (ikin0 /= 42 .and. bw0(42) > 0.d0) then
       call psneeffff(0,1,1,2,ecm,mz,gamz,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(42))
       end if

      if (ikin0 /= 43 .and. bw0(43) > 0.d0) then
       call psneeffff(0,2,1,2,ecm,mz,gamz,zero,zero,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(43))
       end if

      if (ikin0 /= 44 .and. bw0(44) > 0.d0) then
       call psneeffff(0,1,1,1,ecm,mz,gamz,mz,gamz,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(44))
       end if

      if (ikin0 /= 45 .and. bw0(45) > 0.d0) then
       call psneeffff(0,2,1,1,ecm,mz,gamz,mz,gamz,
     &            p1,m1,p2,m2,p3,m3,p6,m6,p5,m5,p4,m4,dl(45))
       end if

      do i=1,nkin
       if (dl(i) /= 0.d0 .and. bw0(i) > zero) then
        dlinv=dlinv+bw0(i)/abs(dl(i))
       end if
      end do

      if (nid > 1) then
       if (id == 1) then
        p3=p50
        p4=p40
        p5=p30
        p6=p60
        ikin0=0
       else if (id == 2) then
        p3=p30
        p4=p60
        p5=p50
        p6=p40
       else if (id == 3) then
        p3=p50
        p4=p60
        p5=p30
        p6=p40
       end if
      end if

      end do ! id

      if (dlinv == 0.d0) then
       cross=0.d0
       return
      else

      dlips=1.d0/dlinv

      if (nid > 1) then
       p3=p30
       p4=p40
       p5=p50
       p6=p60
      end if ! nid

      if (imad == 2) then
       mat2=1.d0
       mat2ww=1.d0
      else
      if (iproc < 11) then
       if (iarbg == 1) then
        call eeffffcc1a(iproc,iww,p1,p2,p3,p4,p5,p6,
     &                          ps1,ps2,ps3,ps4,ps5,ps6,mat2,mat2ww)
       else
        call eeffffcc1(iproc,iww,p1,p2,p3,p4,p5,p6,
     &                          ps1,ps2,ps3,ps4,ps5,ps6,mat2,mat2ww)
       end if
      else if (iproc < 14) then
       call eeffffcc2(iew,iww,p1,p2,p3,p4,p5,p6,
     &                    ps1,ps2,ps3,ps4,ps5,ps6,mat2,mat2ww)
      else if (iproc < 21) then
       if (iarbg == 1) then
        call eeffffcc1a(iproc,iww,p1,p2,p3,p4,p5,p6,
     &                          ps1,ps2,ps3,ps4,ps5,ps6,mat2,mat2ww)
       else
        call eeffffcc1(iproc,iww,p1,p2,p3,p4,p5,p6,
     &                          ps1,ps2,ps3,ps4,ps5,ps6,mat2,mat2ww)
       end if
      else if (iproc == 21) then
       call eeffffcc3(iproc,iww,p1,p2,p3,p4,p5,p6,
     &                          ps1,ps2,ps3,ps4,ps5,ps6,mat2,mat2ww)
      else if (iproc < 201) then
       call eeffffnc1(p1,p2,p3,p4,p5,p6,ps1,ps2,ps3,ps4,ps5,ps6,mat2)
      else if (iproc < 211) then
       call eeffffnc2(p1,p2,p3,p4,p5,p6,ps1,ps2,ps3,ps4,ps5,ps6,mat2)
      else if (iproc < 301) then
       call eeffffnc3(iproc,p1,p2,p3,p4,p5,p6,ps1,ps2,ps3,ps4,ps5,ps6,
     &                                                           mat2)
      else if (iproc < 401) then
       call eeffffnc4(iproc,iew,iww,p1,p2,p3,p4,p5,p6,
     &                          ps1,ps2,ps3,ps4,ps5,ps6,mat2,mat2ww)
      else if (iproc < 406) then
      call eeffffid1(iproc,p1,p2,p3,p4,p5,p6,
     &                     ps1,ps2,ps3,ps4,ps5,ps6,mat2)
      else if (iproc < 412) then
      call eeffffid2(iew,p1,p2,p3,p4,p5,p6,
     &                     ps1,ps2,ps3,ps4,ps5,ps6,mat2)
      else if (iproc == 412) then
      call eeffffid3(p1,p2,p3,p4,p5,p6,
     &                     ps1,ps2,ps3,ps4,ps5,ps6,mat2)
      end if ! iproc

      end if ! imad=2

       if (irad == 0) then
        cross=convc/flux*mat2*dlips
c         if (imad == 1) then
c          mat2m=stbtn(p1,p2,p3,p4,p5,p6)
c          crossm=bw0(ikin)*convc/flux*mat2m*dlips
c          crossm=bw0(ikin)*convc/flux*mat2m*dlips
c          write(*,*) mat2,mat2m,mat2-mat2m
c         end if ! imad

        else
         cbr=-eeffffgs(0,p1,p2,p3,p4,p5,p6,ecut)
         cross=convc/flux*cbr*mat2*dlips
        end if

        icall=icall+1

       end if

       else

        cross=0.d0
        return

       end if  !  dl(ikin) 

      else if (irad == 2) then

       if (ikin == 1) then

      if (imad == 1) then
        call kineeffffg(1,0,0,itw,iw34,iw56,ie3,ict3,
     &                 ecm,ecut,mw,gamw,mw,gamw,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else
        call kineeffffg(1,1,0,itw,iw34,iw56,ie3,ict3,
     &                 ecm,ecut,mw,gamw,mw,gamw,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      end if
      else if (ikin == 2) then
         if (imad == 1) then
          call kineeffffg(1,0,0,itw,iw34,iw56,ie3,ict3,
     &                 ecm,ecut,mw,gamw,mw,gamw,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
         else
          call kineeffffg(1,2,0,itw,iw34,iw56,ie3,ict3,
     &                 ecm,ecut,mw,gamw,mw,gamw,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
         end if
      else if (ikin == 3) then
        call kineeffffg(2,0,0,itw,iw34,iw56,ie3,ict3,
     &                 ecm,ecut,mw,gamw,mw,gamw,x,m1,m2,m4,m3,m5,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p3,ps3,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 4) then
        call kineeffffg(2,0,0,itw,iw34,iw56,ie3,ict3,
     &                 ecm,ecut,mw,gamw,mw,gamw,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 5) then
        call kineeffffg(2,0,0,itw,iw34,iw56,ie3,ict3,
     &                 ecm,ecut,mw,gamw,mw,gamw,x,m1,m2,m6,m5,m3,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p5,ps5,p3,ps3,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 6) then
        call kineeffffg(2,0,0,itw,iw34,iw56,ie3,ict3,
     &                 ecm,ecut,mw,gamw,mw,gamw,x,m1,m2,m5,m6,m3,m4,
     &                 p1,ps1,p2,ps2,p5,ps5,p6,ps6,p3,ps3,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 7) then
        call kineeffffg(1,1,0,0,2,0,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 8) then
        call kineeffffg(1,2,0,0,2,0,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 9) then
        call kineeffffg(2,0,0,0,2,0,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 10) then
        call kineeffffg(2,0,0,0,2,0,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 11) then

        call kineeffffg(2,0,0,0,2,0,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 12) then
        call kineeffffg(2,0,0,0,2,0,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 13) then
        call kineeffffg(1,1,0,0,0,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 14) then
        call kineeffffg(1,2,0,0,0,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 15) then
        call kineeffffg(2,0,0,0,0,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 16) then
        call kineeffffg(2,0,0,0,0,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 17) then
        call kineeffffg(2,0,0,0,0,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 18) then
        call kineeffffg(2,0,0,0,0,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 19) then
        call kineeffffg(1,1,0,0,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 20) then
        call kineeffffg(1,2,0,0,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 21) then
        call kineeffffg(2,0,0,0,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 22) then
        call kineeffffg(2,0,0,0,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 23) then
        call kineeffffg(2,0,0,0,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 24) then
        call kineeffffg(2,0,0,0,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 25) then
        call kineeffffg(1,1,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 26) then
        call kineeffffg(1,2,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 27) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 28) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 29) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 30) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 31) then
        call kineeffffg(1,1,1,0,iw34,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 32) then
        call kineeffffg(1,2,1,0,iw34,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 33) then
        call kineeffffg(2,0,1,0,iw34,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m4,m3,m5,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p3,ps3,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 34) then
        call kineeffffg(2,0,1,0,iw34,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 35) then
        call kineeffffg(2,0,2,0,iw34,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 36) then
        call kineeffffg(2,0,0,0,0,iw56,ie3,1,
     &                 ecm,ecut,zero,zero,mw,gamw,x,m1,m2,m5,m6,m3,m4,
     &                 p1,ps1,p2,ps2,p5,ps5,p6,ps6,p3,ps3,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 37) then
        call kineeffffg(1,1,0,0,1,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 38) then
        call kineeffffg(1,2,0,0,1,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 39) then
        call kineeffffg(2,0,0,0,1,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m4,m3,m5,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p3,ps3,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 40) then
        call kineeffffg(2,0,0,0,1,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 41) then
        call kineeffffg(2,0,0,0,1,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m6,m5,m3,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p5,ps5,p3,ps3,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 42) then
        call kineeffffg(2,0,0,0,1,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m5,m6,m3,m4,
     &                 p1,ps1,p2,ps2,p5,ps5,p6,ps6,p3,ps3,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 43) then
        call kineeffffg(1,1,0,0,0,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mw,gamw,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 44) then
        call kineeffffg(1,2,0,0,0,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mw,gamw,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 45) then
        call kineeffffg(2,0,0,0,0,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mw,gamw,x,m1,m2,m4,m3,m5,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p3,ps3,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 46) then
        call kineeffffg(2,0,0,0,0,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mw,gamw,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 47) then
        call kineeffffg(2,0,0,0,0,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mw,gamw,x,m1,m2,m6,m5,m3,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p5,ps5,p3,ps3,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 48) then
        call kineeffffg(2,0,0,0,0,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mw,gamw,x,m1,m2,m5,m6,m3,m4,
     &                 p1,ps1,p2,ps2,p5,ps5,p6,ps6,p3,ps3,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 49) then
        call kineeffffg(1,1,0,0,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 50) then
        call kineeffffg(1,2,0,0,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 51) then
        call kineeffffg(2,0,0,0,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 52) then
        call kineeffffg(2,0,0,0,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 53) then
        call kineeffffg(2,0,0,0,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 54) then
        call kineeffffg(2,0,0,0,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 55) then
        call kineeffffg(1,1,0,0,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 56) then
        call kineeffffg(1,2,0,0,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 57) then
        call kineeffffg(2,0,0,0,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 58) then
        call kineeffffg(2,0,0,0,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 59) then
        call kineeffffg(2,0,0,0,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 60) then
        call kineeffffg(2,0,0,0,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 61) then
        call kineeffffg(1,1,1,0,iw34,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m5,m6,m4,m3,
     &                 p1,ps1,p2,ps2,p5,ps5,p6,ps6,p4,ps4,p3,ps3,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 62) then
        call kineeffffg(1,2,1,0,iw34,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m5,m6,m4,m3,
     &                 p1,ps1,p2,ps2,p5,ps5,p6,ps6,p4,ps4,p3,ps3,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 63) then
        call kineeffffg(2,0,2,0,iw34,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m6,m5,m4,m3,
     &                 p1,ps1,p2,ps2,p6,ps6,p5,ps5,p4,ps4,p3,ps3,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 64) then
        call kineeffffg(2,0,2,0,iw34,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m5,m6,m4,m3,
     &                 p1,ps1,p2,ps2,p5,ps5,p6,ps6,p4,ps4,p3,ps3,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 65) then
        call kineeffffg(2,0,2,0,iw34,0,ie3,ict3,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m4,m3,m5,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p3,ps3,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 66) then
        call kineeffffg(2,0,0,0,iw34,0,ie3,1,
     &                 ecm,ecut,mw,gamw,zero,zero,x,m1,m2,m3,m4,m5,m6,
     &                 p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 67) then
        call kineeffffg(1,1,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 68) then
        call kineeffffg(1,2,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 69) then
        call kineeffffg(1,1,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mh,gamhig,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 70) then
        call kineeffffg(1,2,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mh,gamhig,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 71) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mh,gamhig,mz,gamz,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 72) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mh,gamhig,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 73) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mh,gamhig,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 74) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mh,gamhig,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 75) then
        call kineeffffg(1,1,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mh,gamhig,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 76) then
        call kineeffffg(1,2,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mh,gamhig,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 77) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mh,gamhig,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 78) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mh,gamhig,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 79) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mh,gamhig,mz,gamz,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 80) then
        call kineeffffg(2,0,0,itw,1,1,ie3,ict3,
     &                 ecm,ecut,mh,gamhig,mz,gamz,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 81) then
        call kineetbffg(1,1,1,ecm,ecut,mt,gamt,mw,gamw,x,
     &                  p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,
     &                  p5,ps5,m5,p6,ps6,m6,p7,ps7,dl(ikin),flux)
      else if (ikin == 82) then
        call kineetbffg(2,1,1,ecm,ecut,mt,gamt,mw,gamw,x,
     &                  p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,
     &                  p5,ps5,m5,p6,ps6,m6,p7,ps7,dl(ikin),flux)

ckk
      else if (ikin == 83) then
        call kineeffffg(1,1,0,1,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 84) then
        call kineeffffg(1,2,0,1,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 85) then
        call kineeffffg(2,0,0,1,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 86) then
        call kineeffffg(2,0,0,1,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 87) then

        call kineeffffg(2,0,0,1,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 88) then
        call kineeffffg(2,0,0,1,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 89) then
        call kineeffffg(1,1,0,2,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 90) then
        call kineeffffg(1,2,0,2,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 91) then
        call kineeffffg(2,0,0,2,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 92) then
        call kineeffffg(2,0,0,2,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 93) then

        call kineeffffg(2,0,0,2,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 94) then
        call kineeffffg(2,0,0,2,2,1,ie3,ict3,
     &                 ecm,ecut,zero,zero,mz,gamz,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)




      else if (ikin == 95) then
        call kineeffffg(1,1,0,1,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 96) then
        call kineeffffg(1,2,0,1,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 97) then
        call kineeffffg(2,0,0,1,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 98) then
        call kineeffffg(2,0,0,1,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 99) then

        call kineeffffg(2,0,0,1,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 100) then
        call kineeffffg(2,0,0,1,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 101) then
        call kineeffffg(1,1,0,2,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 102) then
        call kineeffffg(1,2,0,2,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 103) then
        call kineeffffg(2,0,0,2,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 104) then
        call kineeffffg(2,0,0,2,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 105) then

        call kineeffffg(2,0,0,2,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 106) then
        call kineeffffg(2,0,0,2,2,2,ie3,ict3,
     &                 ecm,ecut,zero,zero,zero,zero,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)






      else if (ikin == 107) then
        call kineeffffg(1,1,0,1,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 108) then
        call kineeffffg(1,2,0,1,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 109) then
        call kineeffffg(2,0,0,1,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 110) then
        call kineeffffg(2,0,0,1,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 111) then

        call kineeffffg(2,0,0,1,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 112) then
        call kineeffffg(2,0,0,1,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 113) then
        call kineeffffg(1,1,0,2,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 114) then
        call kineeffffg(1,2,0,2,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 115) then
        call kineeffffg(2,0,0,2,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 116) then
        call kineeffffg(2,0,0,2,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 117) then

        call kineeffffg(2,0,0,2,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 118) then
        call kineeffffg(2,0,0,2,1,1,ie3,ict3,
     &                 ecm,ecut,mz,gamz,mz,gamz,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)




      else if (ikin == 119) then
        call kineeffffg(1,1,0,1,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 120) then
        call kineeffffg(1,2,0,1,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 121) then
        call kineeffffg(2,0,0,1,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 122) then
        call kineeffffg(2,0,0,1,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 123) then

        call kineeffffg(2,0,0,1,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 124) then
        call kineeffffg(2,0,0,1,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 125) then
        call kineeffffg(1,1,0,2,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 126) then
        call kineeffffg(1,2,0,2,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 127) then
        call kineeffffg(2,0,0,2,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m6,m3,m5,m4,
     &                 p1,ps1,p2,ps2,p6,ps6,p3,ps3,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 128) then
        call kineeffffg(2,0,0,2,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m3,m6,m5,m4,
     &                 p1,ps1,p2,ps2,p3,ps3,p6,ps6,p5,ps5,p4,ps4,p7,ps7,
     &                                                 dl(ikin),flux)
      else if (ikin == 129) then

        call kineeffffg(2,0,0,2,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m4,m5,m3,m6,
     &                 p1,ps1,p2,ps2,p4,ps4,p5,ps5,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)

      else if (ikin == 130) then
        call kineeffffg(2,0,0,2,1,2,ie3,ict3,
     &                 ecm,ecut,mz,gamz,zero,zero,x,m1,m2,m5,m4,m3,m6,
     &                 p1,ps1,p2,ps2,p5,ps5,p4,ps4,p3,ps3,p6,ps6,p7,ps7,
     &                                                 dl(ikin),flux)















      else
        write(*,*)'ikin =',ikin,' IS NOT ALLOWED'
      end if  ! ikin

      ikin0=ikin

      if (nid > 1) then

      ikin0=0

      if (ident == 2) then
       p0=p5
       p5=p3
       p3=p0
       ps0=ps5
       ps5=ps3
       ps3=ps0
      else if (ident == 3) then
       p0=p6
       p6=p4
       p4=p0
       ps0=ps6
       ps6=ps4
       ps4=ps0
      else if (ident == 4) then
       p0=p5
       p5=p3
       p3=p0
       ps0=ps5
       ps5=ps3
       ps3=ps0
       p0=p6
       p6=p4
       p4=p0
       ps0=ps6
       ps6=ps4
       ps4=ps0
      end if

      p30=p3
      p40=p4
      p50=p5
      p60=p6
      ps30=ps3
      ps40=ps4
      ps50=ps5
      ps60=ps6

      end if ! nid

      if (dl(ikin) > 0.d0) then

       if (icuts == 1) then
c The canonical cuts:
        call cancuts(p1,ps1,p2,ps2,p3,ps3,p4,ps4,p5,ps5,
     &               p6,ps6,p7,ps7,cross)
        if (cross == 0.d0) then
         return
        end if
       else if (icuts == 2) then
c A cut on the final electron angle:
        if (abs(ps5(1)) > cteb) then
         cross=0.d0
         return
        end if
       else if (icuts == 3) then
c A cut on the final electron and positron angle:
        if (abs(ps5(1)) > cteb) then
         cross=0.d0
         return
        else if (abs(ps4(1)) > cteb) then
         cross=0.d0
         return
        end if
       end if ! icuts

      dlinv=0.d0

      do id=1,nid

       if (ikin0 /= 1 .and. bw(1) > zero) then
         if (imad == 1) then
          call psneeffffg(1,0,0,itw,iw34,iw56,ie3,ict3,ecm,ecut,mw,gamw,
     &                  mw,gamw,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(1))
         else
          call psneeffffg(1,1,0,itw,iw34,iw56,ie3,ict3,ecm,ecut,mw,gamw,
     &                  mw,gamw,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(1))
         end if
       end if ! ikin

       if (ikin0 /= 2 .and. bw(2) > zero) then
        if (imad == 1) then
         call psneeffffg(1,0,0,itw,iw34,iw56,ie3,ict3,ecm,ecut,mw,gamw,
     &                  mw,gamw,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(2))
        else
         call psneeffffg(1,2,0,itw,iw34,iw56,ie3,ict3,ecm,ecut,mw,gamw,
     &                  mw,gamw,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(2))
         end if
       end if ! ikin

      if (ikin0 /= 3 .and. bw(3) > zero) then
       call psneeffffg(2,0,0,itw,iw34,iw56,ie3,ict3,ecm,ecut,mw,gamw,
     &                  mw,gamw,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p3,ps3,m3,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(3))
       end if ! ikin
       if (ikin0 /= 4 .and. bw(4) > zero) then
        call psneeffffg(2,0,0,itw,iw34,iw56,ie3,ict3,ecm,ecut,mw,gamw,
     &                  mw,gamw,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(4))
       end if ! ikin
       if (ikin0 /= 5 .and. bw(5) > zero) then
        call psneeffffg(2,0,0,itw,iw34,iw56,ie3,ict3,ecm,ecut,mw,gamw,
     &                  mw,gamw,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p5,ps5,m5,p3,ps3,m3,p4,ps4,m4,
     &                  p7,ps7,dl(5))
       end if ! ikin
       if (ikin0 /= 6 .and. bw(6) > zero) then
        call psneeffffg(2,0,0,itw,iw34,iw56,ie3,ict3,ecm,ecut,mw,gamw,
     &                  mw,gamw,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p6,ps6,m6,p3,ps3,m3,p4,ps4,m4,
     &                  p7,ps7,dl(6))
       end if ! ikin

       if (ikin0 /= 7 .and. bw(7) > zero) then
        call psneeffffg(1,1,0,0,2,0,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(7))
       end if ! ikin

       if (ikin0 /= 8 .and. bw(8) > zero) then
        call psneeffffg(1,2,0,0,2,0,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(8))
       end if ! ikin

       if (ikin0 /= 9 .and. bw(9) > zero) then
          call psneeffffg(2,0,0,0,2,0,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(9))
       end if ! ikin

       if (ikin0 /= 10 .and. bw(10) > zero) then
         call psneeffffg(2,0,0,0,2,0,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(10))
       end if ! ikin

       if (ikin0 /= 11 .and. bw(11) > zero) then
          call psneeffffg(2,0,0,0,2,0,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(11))
       end if ! ikin

       if (ikin0 /= 12 .and. bw(12) > zero) then
          call psneeffffg(2,0,0,0,2,0,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(12))
       end if ! ikin

       if (ikin0 /= 13 .and. bw(13) > zero) then
        call psneeffffg(1,1,0,0,0,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(13))
       end if ! ikin

       if (ikin0 /= 14 .and. bw(14) > zero) then
        call psneeffffg(1,2,0,0,0,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(14))
       end if ! ikin

       if (ikin0 /= 15 .and. bw(15) > zero) then
          call psneeffffg(2,0,0,0,0,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(15))
       end if ! ikin

       if (ikin0 /= 16 .and. bw(16) > zero) then
         call psneeffffg(2,0,0,0,0,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(16))
       end if ! ikin

       if (ikin0 /= 17 .and. bw(17) > zero) then
          call psneeffffg(2,0,0,0,0,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(17))
       end if ! ikin

       if (ikin0 /= 18 .and. bw(18) > zero) then
          call psneeffffg(2,0,0,0,0,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(18))
       end if ! ikin

       if (ikin0 /= 19 .and. bw(19) > zero) then
        call psneeffffg(1,1,0,0,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(19))
       end if ! ikin

       if (ikin0 /= 20 .and. bw(20) > zero) then
        call psneeffffg(1,2,0,0,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(20))
       end if ! ikin

       if (ikin0 /= 21 .and. bw(21) > zero) then
          call psneeffffg(2,0,0,0,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(21))
       end if ! ikin

       if (ikin0 /= 22 .and. bw(22) > zero) then
         call psneeffffg(2,0,0,0,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(22))
       end if ! ikin

       if (ikin0 /= 23 .and. bw(23) > zero) then
          call psneeffffg(2,0,0,0,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(23))
       end if ! ikin

       if (ikin0 /= 24 .and. bw(24) > zero) then
          call psneeffffg(2,0,0,0,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(24))
       end if ! ikin

       if (ikin0 /= 25 .and. bw(25) > zero) then
        call psneeffffg(1,1,0,itw,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(25))
       end if ! ikin

       if (ikin0 /= 26 .and. bw(26) > zero) then
        call psneeffffg(1,2,0,itw,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(26))
       end if ! ikin

       if (ikin0 /= 27 .and. bw(27) > zero) then
          call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(27))
       end if ! ikin

       if (ikin0 /= 28 .and. bw(28) > zero) then
         call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(28))
       end if ! ikin

       if (ikin0 /= 29 .and. bw(29) > zero) then
          call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(29))
       end if ! ikin

       if (ikin0 /= 30 .and. bw(30) > zero) then
          call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(30))
       end if ! ikin

       if (ikin0 /= 31 .and. bw(31) > zero) then
        call psneeffffg(1,1,1,0,iw34,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(31))
       end if ! ikin

       if (ikin0 /= 32 .and. bw(32) > zero) then
        call psneeffffg(1,2,1,0,iw34,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(32))
       end if ! ikin

      if (ikin0 /= 33 .and. bw(33) > zero) then
       call psneeffffg(2,0,1,0,iw34,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p3,ps3,m3,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(33))
       end if ! ikin

       if (ikin0 /= 34 .and. bw(34) > zero) then
         call psneeffffg(2,0,1,0,iw34,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(34))
       end if ! ikin

       if (ikin0 /= 35 .and. bw(35) > zero) then
         call psneeffffg(2,0,2,0,iw34,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(35))
       end if ! ikin

       if (ikin0 /= 36 .and. bw(36) > zero) then
        call psneeffffg(2,0,0,0,0,iw56,ie3,1,ecm,ecut,zero,zero,mw,gamw,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p6,ps6,m6,p3,ps3,m3,p4,ps4,m4,
     &                  p7,ps7,dl(36))
       end if ! ikin

       if (ikin0 /= 37 .and. bw(37) > zero) then
          call psneeffffg(1,1,0,0,1,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(37))
       end if ! ikin

       if (ikin0 /= 38 .and. bw(38) > zero) then
         call psneeffffg(1,2,0,0,1,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(38))
       end if ! ikin

      if (ikin0 /= 39 .and. bw(39) > zero) then
       call psneeffffg(2,0,0,0,1,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p3,ps3,m3,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(39))
       end if ! ikin
       if (ikin0 /= 40 .and. bw(40) > zero) then
        call psneeffffg(2,0,0,0,1,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(40))
       end if ! ikin
       if (ikin0 /= 41 .and. bw(41) > zero) then
        call psneeffffg(2,0,0,0,1,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p5,ps5,m5,p3,ps3,m3,p4,ps4,m4,
     &                  p7,ps7,dl(41))
       end if ! ikin

       if (ikin0 /= 42 .and. bw(42) > zero) then
        call psneeffffg(2,0,0,0,1,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p6,ps6,m6,p3,ps3,m3,p4,ps4,m4,
     &                  p7,ps7,dl(42))
       end if ! ikin

       if (ikin0 /= 43 .and. bw(43) > zero) then
        call psneeffffg(1,1,0,0,0,1,ie3,ict3,ecm,ecut,zero,zero,mw,gamw,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(43))
       end if ! ikin

       if (ikin0 /= 44 .and. bw(44) > zero) then
        call psneeffffg(1,2,0,0,0,1,ie3,ict3,ecm,ecut,zero,zero,mw,gamw,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(44))
       end if ! ikin

      if (ikin0 /= 45 .and. bw(45) > zero) then
       call psneeffffg(2,0,0,0,0,1,ie3,ict3,ecm,ecut,zero,zero,mw,gamw,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p3,ps3,m3,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(45))
       end if ! ikin
       if (ikin0 /= 46 .and. bw(46) > zero) then
        call psneeffffg(2,0,0,0,0,1,ie3,ict3,ecm,ecut,zero,zero,mw,gamw,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(46))
       end if ! ikin
       if (ikin0 /= 47 .and. bw(47) > zero) then
        call psneeffffg(2,0,0,0,0,1,ie3,ict3,ecm,ecut,zero,zero,mw,gamw,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p5,ps5,m5,p3,ps3,m3,p4,ps4,m4,
     &                  p7,ps7,dl(47))
       end if ! ikin
       if (ikin0 /= 48 .and. bw(48) > zero) then
        call psneeffffg(2,0,0,0,0,1,ie3,ict3,ecm,ecut,zero,zero,mw,gamw,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p6,ps6,m6,p3,ps3,m3,p4,ps4,m4,
     &                  p7,ps7,dl(48))
       end if ! ikin

       if (ikin0 /= 49 .and. bw(49) > zero) then
        call psneeffffg(1,1,0,0,2,1,ie3,ict3,ecm,ecut,zero,zero,mz,gamz,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(49))
       end if ! ikin

       if (ikin0 /= 50 .and. bw(50) > zero) then
        call psneeffffg(1,2,0,0,2,1,ie3,ict3,ecm,ecut,zero,zero,mz,gamz,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(50))
       end if ! ikin

       if (ikin0 /= 51 .and. bw(51) > zero) then
        call psneeffffg(2,0,0,0,2,1,ie3,ict3,ecm,ecut,zero,zero,mz,gamz,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(51))
       end if ! ikin

       if (ikin0 /= 52 .and. bw(52) > zero) then
        call psneeffffg(2,0,0,0,2,1,ie3,ict3,ecm,ecut,zero,zero,mz,gamz,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(52))
       end if ! ikin

       if (ikin0 /= 53 .and. bw(53) > zero) then
        call psneeffffg(2,0,0,0,2,1,ie3,ict3,ecm,ecut,zero,zero,mz,gamz,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(53))
       end if ! ikin

       if (ikin0 /= 54 .and. bw(54) > zero) then
        call psneeffffg(2,0,0,0,2,1,ie3,ict3,ecm,ecut,zero,zero,mz,gamz,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(54))
       end if ! ikin

       if (ikin0 /= 55 .and. bw(55) > zero) then
        call psneeffffg(1,1,0,0,1,2,ie3,ict3,ecm,ecut,mz,gamz,zero,zero,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(55))
       end if ! ikin

       if (ikin0 /= 56 .and. bw(56) > zero) then
        call psneeffffg(1,2,0,0,1,2,ie3,ict3,ecm,ecut,mz,gamz,zero,zero,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(56))
       end if ! ikin

       if (ikin0 /= 57 .and. bw(57) > zero) then
        call psneeffffg(2,0,0,0,1,2,ie3,ict3,ecm,ecut,mz,gamz,zero,zero,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(57))
       end if ! ikin

       if (ikin0 /= 58 .and. bw(58) > zero) then
        call psneeffffg(2,0,0,0,1,2,ie3,ict3,ecm,ecut,mz,gamz,zero,zero,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(58))
       end if ! ikin

       if (ikin0 /= 59 .and. bw(59) > zero) then
        call psneeffffg(2,0,0,0,1,2,ie3,ict3,ecm,ecut,mz,gamz,zero,zero,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(59))
       end if ! ikin

       if (ikin0 /= 60 .and. bw(60) > zero) then
        call psneeffffg(2,0,0,0,1,2,ie3,ict3,ecm,ecut,mz,gamz,zero,zero,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(60))
       end if ! ikin

       if (ikin0 /= 61 .and. bw(61) > zero) then
        call psneeffffg(1,1,1,0,iw34,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p6,ps6,m6,p4,ps4,m4,p3,ps3,m3,
     &                  p7,ps7,dl(61))
       end if ! ikin

       if (ikin0 /= 62 .and. bw(62) > zero) then
        call psneeffffg(1,2,1,0,iw34,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p6,ps6,m6,p4,ps4,m4,p3,ps3,m3,
     &                  p7,ps7,dl(62))
       end if ! ikin

      if (ikin0 /= 63 .and. bw(63) > zero) then
       call psneeffffg(2,0,2,0,iw34,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,
     &                  p7,ps7,dl(63))
       end if ! ikin

       if (ikin0 /= 64 .and. bw(64) > zero) then
         call psneeffffg(2,0,2,0,iw34,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p6,ps6,m6,p4,ps4,m4,p3,ps3,m3,
     &                  p7,ps7,dl(64))
       end if ! ikin

       if (ikin0 /= 65 .and. bw(65) > zero) then
         call psneeffffg(2,0,2,0,iw34,0,ie3,ict3,ecm,ecut,mw,gamw,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p3,ps3,m3,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(65))
       end if ! ikin

       if (ikin0 /= 66 .and. bw(66) > zero) then
        call psneeffffg(2,0,0,0,0,iw56,ie3,1,ecm,ecut,zero,zero,mw,gamw,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p4,ps4,m4,p5,ps5,m5,p6,ps6,m6,
     &                  p7,ps7,dl(66))
       end if ! ikin

       if (ikin0 /= 67 .and. bw(67) > zero) then
        call psneeffffg(1,1,0,itw,1,1,ie3,ict3,ecm,ecut,mz,gamz,mz,gamz,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(67))
       end if ! ikin

       if (ikin0 /= 68 .and. bw(68) > zero) then
        call psneeffffg(1,2,0,itw,1,1,ie3,ict3,ecm,ecut,mz,gamz,mz,gamz,
     &                  p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(68))
       end if ! ikin

       if (ikin0 /= 69 .and. bw(69) > zero) then
        call psneeffffg(1,1,0,itw,1,1,ie3,ict3,ecm,ecut,mh,gamhig,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(69))
       end if ! ikin

       if (ikin0 /= 70 .and. bw(70) > zero) then
        call psneeffffg(1,2,0,itw,1,1,ie3,ict3,ecm,ecut,mh,gamhig,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(70))
       end if ! ikin

       if (ikin0 /= 71 .and. bw(71) > zero) then
          call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,mh,gamhig,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(71))
       end if ! ikin

       if (ikin0 /= 72 .and. bw(72) > zero) then
         call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,mh,gamhig,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(72))
       end if ! ikin

       if (ikin0 /= 73 .and. bw(73) > zero) then
          call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mh,gamhig,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(73))
       end if ! ikin

       if (ikin0 /= 74 .and. bw(74) > zero) then
          call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mh,gamhig,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(74))
       end if ! ikin

       if (ikin0 /= 75 .and. bw(75) > zero) then
        call psneeffffg(1,1,0,itw,1,1,ie3,ict3,ecm,ecut,
     &                  mz,gamz,mh,gamhig,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(75))
       end if ! ikin

       if (ikin0 /= 76 .and. bw(76) > zero) then
        call psneeffffg(1,2,0,itw,1,1,ie3,ict3,ecm,ecut,
     &                  mz,gamz,mh,gamhig,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(76))
       end if ! ikin

       if (ikin0 /= 77 .and. bw(77) > zero) then
          call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,
     &                  mz,gamz,mh,gamhig,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(77))
       end if ! ikin

       if (ikin0 /= 78 .and. bw(78) > zero) then
         call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,
     &                  mz,gamz,mh,gamhig,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(78))
       end if ! ikin

       if (ikin0 /= 79 .and. bw(79) > zero) then
          call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,
     &                  mh,gamhig,mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(79))
       end if ! ikin

       if (ikin0 /= 80 .and. bw(80) > zero) then
          call psneeffffg(2,0,0,itw,1,1,ie3,ict3,ecm,ecut,
     &                  mh,gamhig,mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(80))
       end if ! ikin

       if (ikin0 /= 81 .and. bw(81) > zero) then
          call psneetbffg(1,1,1,ecm,ecut,mt,gamt,mw,gamw,
     &                      p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,
     &                      p5,ps5,m5,p6,ps6,m6,p7,ps7,dl(81))
       end if ! ikin

       if (ikin0 /= 82 .and. bw(82) > zero) then
          call psneetbffg(2,1,1,ecm,ecut,mt,gamt,mw,gamw,
     &                      p1,ps1,m1,p2,ps2,m2,p3,ps3,m3,p4,ps4,m4,
     &                      p5,ps5,m5,p6,ps6,m6,p7,ps7,dl(82))
       end if ! ikin




       if (ikin0 /= 83 .and. bw(83) > zero) then
        call psneeffffg(1,1,0,1,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(83))
       end if ! ikin

       if (ikin0 /= 84 .and. bw(84) > zero) then
        call psneeffffg(1,2,0,1,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(84))
       end if ! ikin

       if (ikin0 /= 85 .and. bw(85) > zero) then
        call psneeffffg(2,0,0,1,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(85))
       end if ! ikin

       if (ikin0 /= 86 .and. bw(86) > zero) then
        call psneeffffg(2,0,0,1,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(86))
       end if ! ikin

       if (ikin0 /= 87 .and. bw(87) > zero) then
        call psneeffffg(2,0,0,1,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(87))
       end if ! ikin

       if (ikin0 /= 88 .and. bw(88) > zero) then
        call psneeffffg(2,0,0,1,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(88))
       end if ! ikin




       if (ikin0 /= 89 .and. bw(89) > zero) then
        call psneeffffg(1,1,0,2,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(89))
       end if ! ikin

       if (ikin0 /= 90 .and. bw(90) > zero) then
        call psneeffffg(1,2,0,2,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(90))
       end if ! ikin

       if (ikin0 /= 91 .and. bw(91) > zero) then
        call psneeffffg(2,0,0,2,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(91))
       end if ! ikin

       if (ikin0 /= 92 .and. bw(92) > zero) then
        call psneeffffg(2,0,0,2,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(92))
       end if ! ikin

       if (ikin0 /= 93 .and. bw(93) > zero) then
        call psneeffffg(2,0,0,2,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(93))
       end if ! ikin

       if (ikin0 /= 94 .and. bw(94) > zero) then
        call psneeffffg(2,0,0,2,2,1,ie3,ict3,ecm,ecut,zero,zero,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(94))
       end if ! ikin





       if (ikin0 /= 95 .and. bw(95) > zero) then
        call psneeffffg(1,1,0,1,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(95))
       end if ! ikin

       if (ikin0 /= 96 .and. bw(96) > zero) then
        call psneeffffg(1,2,0,1,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(96))
       end if ! ikin

       if (ikin0 /= 97 .and. bw(97) > zero) then
        call psneeffffg(2,0,0,1,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(97))
       end if ! ikin

       if (ikin0 /= 98 .and. bw(98) > zero) then
        call psneeffffg(2,0,0,1,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(98))
       end if ! ikin

       if (ikin0 /= 99 .and. bw(99) > zero) then
        call psneeffffg(2,0,0,1,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(99))
       end if ! ikin

       if (ikin0 /= 100 .and. bw(100) > zero) then
        call psneeffffg(2,0,0,1,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(100))
       end if ! ikin




       if (ikin0 /= 101 .and. bw(101) > zero) then
        call psneeffffg(1,1,0,2,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(101))
       end if ! ikin

       if (ikin0 /= 102 .and. bw(102) > zero) then
        call psneeffffg(1,2,0,2,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(102))
       end if ! ikin

       if (ikin0 /= 103 .and. bw(103) > zero) then
        call psneeffffg(2,0,0,2,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(103))
       end if ! ikin

       if (ikin0 /= 104 .and. bw(104) > zero) then
        call psneeffffg(2,0,0,2,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(104))
       end if ! ikin

       if (ikin0 /= 105 .and. bw(105) > zero) then
        call psneeffffg(2,0,0,2,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(105))
       end if ! ikin

       if (ikin0 /= 106 .and. bw(106) > zero) then
        call psneeffffg(2,0,0,2,2,2,ie3,ict3,ecm,ecut,zero,zero,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(106))
       end if ! ikin










       if (ikin0 /= 107 .and. bw(107) > zero) then
        call psneeffffg(1,1,0,1,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(107))
       end if ! ikin

       if (ikin0 /= 108 .and. bw(108) > zero) then
        call psneeffffg(1,2,0,1,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(108))
       end if ! ikin

       if (ikin0 /= 109 .and. bw(109) > zero) then
        call psneeffffg(2,0,0,1,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(109))
       end if ! ikin

       if (ikin0 /= 110 .and. bw(110) > zero) then
        call psneeffffg(2,0,0,1,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(110))
       end if ! ikin

       if (ikin0 /= 111 .and. bw(111) > zero) then
        call psneeffffg(2,0,0,1,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(111))
       end if ! ikin

       if (ikin0 /= 112 .and. bw(112) > zero) then
        call psneeffffg(2,0,0,1,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(112))
       end if ! ikin




       if (ikin0 /= 113 .and. bw(113) > zero) then
        call psneeffffg(1,1,0,2,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(113))
       end if ! ikin

       if (ikin0 /= 114 .and. bw(114) > zero) then
        call psneeffffg(1,2,0,2,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(114))
       end if ! ikin

       if (ikin0 /= 115 .and. bw(115) > zero) then
        call psneeffffg(2,0,0,2,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(115))
       end if ! ikin

       if (ikin0 /= 116 .and. bw(116) > zero) then
        call psneeffffg(2,0,0,2,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(116))
       end if ! ikin

       if (ikin0 /= 117 .and. bw(117) > zero) then
        call psneeffffg(2,0,0,2,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(117))
       end if ! ikin

       if (ikin0 /= 118 .and. bw(118) > zero) then
        call psneeffffg(2,0,0,2,1,1,ie3,ict3,ecm,ecut,mz,gamz,
     &                  mz,gamz,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(118))
       end if ! ikin





       if (ikin0 /= 119 .and. bw(119) > zero) then
        call psneeffffg(1,1,0,1,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(119))
       end if ! ikin

       if (ikin0 /= 120 .and. bw(120) > zero) then
        call psneeffffg(1,2,0,1,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(120))
       end if ! ikin

       if (ikin0 /= 121 .and. bw(121) > zero) then
        call psneeffffg(2,0,0,1,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(121))
       end if ! ikin

       if (ikin0 /= 122 .and. bw(122) > zero) then
        call psneeffffg(2,0,0,1,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(122))
       end if ! ikin

       if (ikin0 /= 123 .and. bw(123) > zero) then
        call psneeffffg(2,0,0,1,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(123))
       end if ! ikin

       if (ikin0 /= 124 .and. bw(124) > zero) then
        call psneeffffg(2,0,0,1,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(124))
       end if ! ikin




       if (ikin0 /= 125 .and. bw(125) > zero) then
        call psneeffffg(1,1,0,2,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(125))
       end if ! ikin

       if (ikin0 /= 126 .and. bw(126) > zero) then
        call psneeffffg(1,2,0,2,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(126))
       end if ! ikin

       if (ikin0 /= 127 .and. bw(127) > zero) then
        call psneeffffg(2,0,0,2,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p6,ps6,m6,p3,ps3,m3,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(127))
       end if ! ikin

       if (ikin0 /= 128 .and. bw(128) > zero) then
        call psneeffffg(2,0,0,2,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p3,ps3,m3,p6,ps6,m6,p5,ps5,m5,p4,ps4,m4,
     &                  p7,ps7,dl(128))
       end if ! ikin

       if (ikin0 /= 129 .and. bw(129) > zero) then
        call psneeffffg(2,0,0,2,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p4,ps4,m4,p5,ps5,m5,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(129))
       end if ! ikin

       if (ikin0 /= 130 .and. bw(130) > zero) then
        call psneeffffg(2,0,0,2,1,2,ie3,ict3,ecm,ecut,mz,gamz,
     &                  zero,zero,p1,ps1,m1,p2,ps2,m2,
     &                  p5,ps5,m5,p4,ps4,m4,p3,ps3,m3,p6,ps6,m6,
     &                  p7,ps7,dl(130))
       end if ! ikin




      do i=1,nkin
       if (dl(i) /= 0.d0 .and. bw(i) /= zero) then
        dlinv=dlinv+bw(i)/abs(dl(i))
       end if
      end do

      if (nid > 1) then
       if (id == 1) then
        p3=p50
        p4=p40
        p5=p30
        p6=p60
        ps3=ps50
        ps4=ps40
        ps5=ps30
        ps6=ps60
        ikin0=0
       else if (id == 2) then
        p3=p30
        p4=p60
        p5=p50
        p6=p40
        ps3=ps30
        ps4=ps60
        ps5=ps50
        ps6=ps40
       else if (id == 3) then
        p3=p50
        p4=p60
        p5=p30
        p6=p40
        ps3=ps50
        ps4=ps60
        ps5=ps30
        ps6=ps40
       end if
      end if
 
      end do ! id


      if (dlinv == 0.d0) then
        cross=0.d0
        return
      else

      dlips=1.d0/dlinv

      if (nid > 1) then
       p3=p30
       p4=p40
       p5=p50
       p6=p60
       ps3=ps30
       ps4=ps40
       ps5=ps50
       ps6=ps60
      end if ! nid

      if (imad == 2) then
       mat2=1.d0
       mat2ww=1.d0
      else

      if (iproc < 11) then
        call eeffffgcc1(iproc,iww,p1,p2,p3,p4,p5,p6,p7,
     &                        ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2,mat2ww)
      else if (iproc < 14) then
        call eeffffgcc2(iew,iww,p1,p2,p3,p4,p5,p6,p7,
     &                        ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2,mat2ww)
      else if (iproc < 21) then
        call eeffffgcc1(iproc,iww,p1,p2,p3,p4,p5,p6,p7,
     &                        ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2,mat2ww)
      else if (iproc == 21) then
        call eeffffgcc3(iproc,iww,p1,p2,p3,p4,p5,p6,p7,
     &                        ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2,mat2ww)
      else if (iproc < 201) then
        call eeffffgnc1(p1,p2,p3,p4,p5,p6,p7,
     &                         ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2)
      else if (iproc < 211) then
        call eeffffgnc2(p1,p2,p3,p4,p5,p6,p7,
     &                         ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2)
      else if (iproc < 301) then
        call eeffffgnc3(iproc,p1,p2,p3,p4,p5,p6,p7,
     &                         ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2)
      else if (iproc < 401) then
        call eeffffgnc4(iproc,iew,iww,p1,p2,p3,p4,p5,p6,p7,
     &                         ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2,mat2ww)
      else if (iproc < 406) then
        call eeffffgid1(iproc,p1,p2,p3,p4,p5,p6,p7,
     &                        ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2)
      else if (iproc < 412) then
        call eeffffgid2(iew,p1,p2,p3,p4,p5,p6,p7,
     &                        ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2)
      else if (iproc == 412) then
        call eeffffgid3(p1,p2,p3,p4,p5,p6,p7,
     &                        ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2)
      end if ! iproc

      end if ! imad=2

        cross=convc/flux*mat2*dlips
        icall=icall+1


c        if (imad == 1) then
c          mat2m=(e0/ew)**2*STBTNG(p1,p2,p3,p4,p5,p6,p7)
c          crossm=bw(ikin)*convc/flux*mat2m*dlips
c          write(*,*) mat2,mat2m,mat2-mat2m
c        end if

       end if

       else

        cross=0.d0
        return

       end if  !  dl(ikin) 

      else

      write(*,*)'irad =',irad,' IS NOT ALLOWED'

      end if ! irad

c Find the maximum of cross

      if (irad /= 1) then
       if (cross > crmax) then
        if (iscan == 0) then
         write(11,3010) crmax,cross
 3010 format('# ATTENTION! cross_max updated from',e15.8,' to ',e15.8)
        end if
        crmax=cross
       end if
      end if
ckk>
c      ibla=ibla+1
c      if(ibla > 1400000) then
c       write(*,*)'bla',ibla,dlips,cross
c      end if
ckk<

c MC events

      if (imc == 1 .and. iscan == 0) then

      if (iwrite == 1) then
      if (irad == 0 .or. irad == 2) then

      write(11,4000)
      write(11,3000)
      write(11,5000)
      write(11,3000)
      write(11,2011) chproc
      write(11,3000)
      write(11,5011)
      write(11,3000)
      write(11,5021)
      write(11,5031)
      write(11,5041)
      write(11,5051)
      write(11,3000)
      write(11,5019)
      write(11,3000)
      write(11,5022)
      write(11,5032)
      write(11,5042)
      write(11,5052)
      write(11,3000)
      write(11,4000)


 4000 format('#-------------------------------------------------------',
     &       '----------------------#')
 3000 format('#')
 2011 format('#                         e+ e- -> ',a20)
 5000 format('# Particle momenta of the process:')
 5011 format('# generated with the program ''ee4fg v. 1.0'' by')
 5021 format('#                            Karol Kolodziej')
 5031 format('#                         University of Silesia')
 5041 format('#                            Katowice, Poland')
 5051 format('#                        e-mail: kolodzie@us.edu.pl')
 5019 format('#                                 and')
 5022 format('#                            Fred Jegerlehner')
 5032 format('#                              DESY-Zeuthen')
 5042 format('#                            Zeuthen, Germany')
 5052 format('#                         e-mail: fjeger@ifh.de')

       iwrite=0

       end if
       end if

ckk>
c       call random_number(rand)
       call ranlux(rand,1)
ckk<
       if (cross > rand*crmax) then
        ieff=ieff+1
        if(irad == 0) then
         if (ieff == 1) then
          write(11,4000)
          write(11,1900) crmax
          write(11,4000)
 1900     format('# Event generation started with cross_max =',e16.8)
          write(11,1000) 
 1000     format('# Initial state momenta:')
          write(11,4000)
          write(11,1001) p1
 1001     format('p1:',3e16.8,e24.16)
          write(11,1002) p2
 1002     format('p2:',3e16.8,e24.16)
          write(11,4000)
          write(11,1003) 
          write(11,4000)
 1003     format('# Final state momenta:')
         end if
         write(11,2000) ieff
         write(11,2003) p3
         write(11,2004) p4
         write(11,2005) p5
         write(11,2006) p6
 2000    format('#                    Event No.',i10)
 2003    format('p3:',4e16.8)
 2004    format('p4:',4e16.8)
 2005    format('p5:',4e16.8)
 2006    format('p6:',4e16.8)
 2007    format('p7:',4e16.8)
        else if(irad == 2) then
         if (ieff == 1) then
          write(11,4000)
          write(11,1900) crmax
          write(11,4000)
          write(11,1000)
          write(11,4000)
          write(11,1001) p1
          write(11,1002) p2
          write(11,4000)
          write(11,1006)
 1006     format('# Final state momenta of the hard bremsstrahlung ',
     &              'reaction:')
          write(11,4000)
         end if
         write(11,2000) ieff
         write(11,2003) p3
         write(11,2004) p4
         write(11,2005) p5
         write(11,2006) p6
         write(11,2007) p7
        end if
       end if
      end if


c Distriubutions:

      if (idis == 1 .and. iscan == 0) then

       if (irad == 1) then

        xd(1)=srr(p3+p4,p3+p4)
        xd(2)=srr(p5+p6,p5+p6)
        xd(3)=sqrt(abs(xd(1)))
        xd(4)=ps3(1)
        xd(5)=ps5(1)
        pv34=p3(1:)+p4(1:)
        xd(6)=pv34(3)/sqrt(pv34(1)**2+pv34(2)**2+pv34(3)**2)
        xd(7)=p3(0)
        xd(8)=p5(0)

       else if (irad == 2) then

        xd(1)=srr(p3+p4,p3+p4)
        xd(2)=srr(p5+p6,p5+p6)
        xd(3)=sqrt(abs(xd(1)))
        xd(4)=ps3(1)
        xd(5)=ps5(1)
        xd(6)=ps7(1)
        xd(7)=p3(0)
        xd(8)=p7(0)

       end if ! irad

        do j=1,ndist
         if (xd(j) >= xmin(j) .and. xd(j) <= xmax(j)) then
          do i=1,nbs(j)
           if (xd(j) <= xdi(i,j)) then
            ibin(j)=i
            ncs(i,j)=ncs(i,j)+1
            exit
           end if
          end do
         else
          ibin(j)=0
         end if
        end do

      end if ! idist

      end


