      subroutine cutscrit
c----------------------------------------------------------------------c
c Specifies the class of a process iproc, e.g., purely leptonic, 
c semileptonic, hadronic,..
c
c Input: iproc - process id
c
c Output: icrit=1,..,9
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 16 October, 2001
c----------------------------------------------------------------------c

      use mathprms
      use drivec
      use cutvalues

      implicit none
      integer, parameter :: dp=kind(1.d0)

      real(dp) :: theta

      if (iproc == 1 .or. iproc == 2 .or. iproc == 3 .or. iproc == 4
     &               .or. iproc == 5 .or. iproc == 6
     &   .or. iproc == 16 .or. iproc == 17 .or. iproc == 18) then

       icrit=1

      else if (iproc == 7 .or. iproc == 8 .or. iproc == 9 
     &        .or. iproc == 301 .or. iproc == 302 .or. iproc == 303
     &        .or. iproc == 304 .or. iproc == 305 .or. iproc == 306
     &        .or. iproc == 307 .or. iproc == 308 .or. iproc == 309
     &        .or. iproc == 310 .or. iproc == 311 .or. iproc == 312
     &        .or. iproc == 313 .or. iproc == 314
     &        .or. iproc == 406 .or. iproc == 407
     &        .or. iproc == 408 .or. iproc == 409 .or. iproc == 410
     &        .or. iproc == 411) then

       icrit=2

      else if (iproc ==  10 .or. iproc ==  14 .or. iproc == 15
     &    .or. iproc ==  19 .or. iproc ==  20 .or. iproc == 21 
     &    .or. iproc == 209 .or. iproc == 210
     &    .or. iproc == 217 .or. iproc == 218) then

       icrit=3

      else if (iproc == 101 .or. iproc == 102 .or. iproc == 105 
     &    .or. iproc == 106 .or. iproc == 109 .or. iproc == 110 
     &    .or. iproc == 113 .or. iproc == 114 .or. iproc == 117 
     &    .or. iproc == 118 .or. iproc == 121 .or. iproc == 122
     &    .or. iproc == 201 .or. iproc == 202 .or. iproc == 203
     &    .or. iproc == 204 .or. iproc == 205 .or. iproc == 206) then

       icrit=4

      else if (iproc == 103 .or. iproc == 104 .or. iproc == 107
     &    .or. iproc == 108 .or. iproc == 111 .or. iproc == 112 
     &    .or. iproc == 115 .or. iproc == 116 .or. iproc == 119
     &    .or. iproc == 120 .or. iproc == 123 .or. iproc == 124) then

       icrit=5

      else if (iproc == 125 .or. iproc == 207 .or. iproc == 208
     &    .or. iproc == 401 .or. iproc == 402 .or. iproc == 405) then

       icrit=6

      else if (iproc == 126 .or. iproc == 127) then

       icrit=7

      else if (iproc == 128 .or. iproc == 219 .or. iproc == 220
     &    .or. iproc == 403 .or. iproc == 404 .or. iproc == 412) then

       icrit=8

      else if (iproc == 211 .or. iproc == 212 .or. iproc == 213
     &    .or. iproc == 214 .or. iproc == 215 .or. iproc == 216) then

       icrit=9

      else

       write(*,*)'No cuts specified for this channel:',iproc

      end if ! iproc

      if (icrit == 1) then

       write(*,1000)
       theta=acos(ctlb)/pi*180.d0
       write(*,2000) theta,180.d0-theta,ctlb

       write(*,1100)
       theta=acos(ctlq)/pi*180.d0
       write(*,2100) theta,ctlq

       write(*,1200) ecutl
       write(*,1300) ecutq
       write(*,1400) mqq

       if (ihard == 1) then

        write(*,1500)
        theta=acos(ctgb)/pi*180.d0
        write(*,2200) theta,180.d0-theta,ctgb

        write(*,1700)
        theta=acos(ctgl)/pi*180.d0
        write(*,2300) theta,ctgl

        write(*,1800)
        theta=acos(ctgq)/pi*180.d0
        write(*,2400) theta,ctgq

        write(*,1600) ecutg

       end if

      else if (icrit == 2) then

       write(*,1300) ecutq
       write(*,1400) mqq

       if (ihard == 1) then

        write(*,1600) ecutg

        write(*,1500)
        theta=acos(ctgb)/pi*180.d0
        write(*,2200) theta,180.d0-theta,ctgb

        write(*,1800)
        theta=acos(ctgq)/pi*180.d0
        write(*,2400) theta,ctgq

       end if

      else if (icrit == 3) then

       write(*,1200) ecutl

       write(*,1000)
       theta=acos(ctlb)/pi*180.d0
       write(*,2000) theta,180.d0-theta,ctlb

       write(*,1900)
       theta=acos(ctll)/pi*180.d0
       write(*,2500) theta,ctll

       write(*,1450) mll

       if (ihard == 1) then

        write(*,1600) ecutg

        write(*,1500)
        theta=acos(ctgb)/pi*180.d0
        write(*,2200) theta,180.d0-theta,ctgb

        write(*,1700)
        theta=acos(ctgl)/pi*180.d0
        write(*,2300) theta,ctgl

       end if

      else if (icrit == 4) then

       write(*,1000)
       theta=acos(ctlb)/pi*180.d0
       write(*,2000) theta,180.d0-theta,ctlb

       write(*,1100)
       theta=acos(ctlq)/pi*180.d0
       write(*,2100) theta,ctlq

       write(*,1900)
       theta=acos(ctll)/pi*180.d0
       write(*,2500) theta,ctll

       write(*,1200) ecutl
       write(*,1300) ecutq
       write(*,1400) mqq
       write(*,1450) mll

       if (ihard == 1) then

        write(*,1600) ecutg

        write(*,1500)
        theta=acos(ctgb)/pi*180.d0
        write(*,2200) theta,180.d0-theta,ctgb

        write(*,1700)
        theta=acos(ctgl)/pi*180.d0
        write(*,2300) theta,ctgl

        write(*,1800)
        theta=acos(ctgq)/pi*180.d0
        write(*,2400) theta,ctgq

       end if

      else if (icrit == 5) then

       write(*,1300) ecutq
       write(*,1400) mqq

       if (ihard == 1) then

        write(*,1600) ecutg

        write(*,1500)
        theta=acos(ctgb)/pi*180.d0
        write(*,2200) theta,180.d0-theta,ctgb

        write(*,1800)
        theta=acos(ctgq)/pi*180.d0
        write(*,2400) theta,ctgq

       end if

      else if (icrit == 6 .or. icrit == 7) then

       write(*,1000)
       theta=acos(ctlb)/pi*180.d0
       write(*,2000) theta,180.d0-theta,ctlb

       write(*,1900)
       theta=acos(ctll)/pi*180.d0
       write(*,2500) theta,ctll

       write(*,1200) ecutl
       write(*,1450) mll

       if (ihard == 1) then

        write(*,1600) ecutg

        write(*,1500)
        theta=acos(ctgb)/pi*180.d0
        write(*,2200) theta,180.d0-theta,ctgb

        write(*,1700)
        theta=acos(ctgl)/pi*180.d0
        write(*,2300) theta,ctgl

       end if

      else if (icrit == 8) then

       if (ihard == 1) then

        write(*,1600) ecutg

        write(*,1500)
        theta=acos(ctgb)/pi*180.d0
        write(*,2200) theta,180.d0-theta,ctgb

       end if

      else if (icrit == 9) then

       write(*,1300) ecutq
       write(*,1400) mqq

       if (ihard == 1) then

        write(*,1600) ecutg

        write(*,1500)
        theta=acos(ctgb)/pi*180.d0
        write(*,2200) theta,180.d0-theta,ctgb

        write(*,1800)
        theta=acos(ctgq)/pi*180.d0
        write(*,2400) theta,ctgq

       end if


      end if

 1000 format('# Lepton-beam angle (deg):')
 1100 format('# Lepton-quark angle (deg):')
 1200 format('# Lepton energy:    E_l >',f10.4,' GeV')
 1300 format('# Quark energy:     E_q >',f10.4,' GeV')
 1400 format('# Quark  invariant mass:  m(q,q'') >',f10.4,' GeV')
 1450 format('# Lepton invariant mass:  m(l,l'') >',f10.4,' GeV')
 1500 format('# Photon-beam angle (deg):')
 1600 format('# Photon energy:    E_g >',f10.4,' GeV')
 1700 format('# Photon-lepton angle (deg):')
 1800 format('# Photon-quark angle (deg):')
 1900 format('# Lepton-lepton angle (deg):')
 2000 format('# ',f10.4,' < Theta_lb <',f10.4,'  =>  |cos(Theta_lb)|',
     &' <',f12.8)
 2100 format('#   Theta_lq >',f10.4,'             =>    cos(Theta_lq)',
     &' <',f12.8)
 2200 format('# ',f10.4,' < Theta_gb <',f10.4,'  =>  |cos(Theta_gb)|',
     &' <',f12.8)
 2300 format('#   Theta_gl >',f10.4,'             =>    cos(Theta_gl)',
     &' <',f12.8)
 2400 format('#   Theta_gq >',f10.4,'             =>    cos(Theta_gq)',
     &' <',f12.8)
 2500 format('#   Theta_ll >',f10.4,'             =>    cos(Theta_ll)',
     &' <',f12.8)


      end 


