      program ee4fg
c----------------------------------------------------------------------c
c The unpolarized cross section of 
c
c  e+(p1) + e-(p2) --> f1(p3) + f2~(p4) + f3(p5) + f4~(p6) + (gamma(p7))
c 

c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 14 January, 2000, modiffied 17 January, 2000; 22 July, 2003;
c                             7 November, 2003
c----------------------------------------------------------------------c

      use drivec   ! Defines parameters of distributions
      use inprms   ! Defines initial parameters
      use mathprms ! Defines mathematical constants
      use parproc  ! Defines initial parameters for prcess iproc
      use parsm
      use gaugepar
      use cutvalues
c      use topan
      use distribs

      implicit none
      integer, parameter :: dp=kind(1.d0)

      integer, parameter :: ne=1   ! No of the cms energies

      real(dp), dimension(ne) :: ! The cms energies:
     &            aecm=(/500.d0/)
c     &            aecm=(/200.d0,500.d0/)
c     &            aecm=(/190.d0,340.d0,360.d0,500.d0,2.d3/)!,10.d3/)
c     &     aecm=(/310.d0,320.d0,330.d0,340.d0,342.5d0,345.d0,347.5d0,
c     &            350.d0,355.d0,360.d0,365.d0,370.d0,
c     &            375.d0,380.d0,385.d0,390.d0,395.d0,400.d0,405.d0,
c     &            407.5d0,410.d0,412.5d0,415.d0,
c     &            420.d0,430.d0,440.d0,460.d0,480.d0,500.d0,550.d0,
c     &            600.d0,700.d0,800.d0,900.d0,
c     &            1.d3,1.2d3,1.4d3,1.6d3,1.8d3,2.d3/)
      integer :: i,ndim,n,ncall,ncall0,ncalls,ncallh,j,ie,id,
     &           neff0,neffs,neffh,nsdh,ncalla,neffa,iwwa,itopa

      real(dp) cross,cs0,sd0,chi20,cssb,sdsb,chi2sb,cshb,sdhb,chi2hb,
     &        cs0i,sd0i,chi20i,cssbi,sdsbi,chi2sbi,cshbi,sdhbi,chi2hbi,
     &        csta,sdta,chi2ta,theb,crosstopa,sd2
      real(dp) cswwa,gamw34,gamw56

      external cross,crosstopa

      real(dp) :: degam,arg,val,dels34,a

      real(dp), dimension(ne) :: acs0,asd0,awwa,asda,acssb,asdsb,
     &         acshb,asdhb,adiff

      integer :: iscan0,nscan0,iscanh,nscanh

      real(dp) :: cssc0(nkin0),cssc(nkinh)

      real(dp) :: x(10)

      real(dp) :: stl,stu

      character(77) desc(ndist)

c Specify the final state of the proces e+ e- -> 4f, iproc=
c1          1              for          u  d~  mu- vm~ ,*    
c1          2              for          u  d~  ta- vt~ ,*
c1          3              for          c  s~  mu- vm~ ,*
c1          4              for          c  s~  ta- vt~ ,*
c1          5              for          t  b~  mu- vm~ ,**
c1          6              for          t  b~  ta- vt~ ,**
c2          7              for          c  s~  d   u~  ,*
c2          8              for          t  b~  d   u~  ,** 
c2          9              for          t  b~  s   c~  ,** mg
c3         10              for          vt ta+ mu- vm~ ,*
c2         11 or 301       for          u  d~  d   u~  ,*
c2         12 or 305       for          c  s~  s   c~  ,*
c2         13 or 309       for          t  b~  b   t~  ,**
c3         14              for          vm mu+ mu- vm~ ,*
c3         15              for          vt ta+ ta- vt~ ,*
c1         16              for          u  d~  e-  ve~ ,*
c1         17              for          c  s~  e-  ve~ ,*
c1         18              for          t  b~  e-  ve~ ,** mg
c3         19              for          vm mu+ e-  ve~ ,*
c3         20              for          vt ta+ e-  ve~ ,*
c3         21              for          ve e+  e-  ve~ ,*  mg
c4        101              for          u  mu+ mu- u~  ,*
c4        102              for          u  ta+ ta- u~  ,*
c5        103              for          u  vm~ vm  u~  ,*
c5        104              for          u  vt~ vt  u~  ,*
c4        105              for          c  mu+ mu- c~  ,*
c4        106              for          c  ta+ ta- c~  ,*       H
c5        107              for          c  vm~ vm  c~  ,*
c5        108              for          c  vt~ vt  c~  ,*
c4        109              for          t  mu+ mu- t~  ,**      H?
c4        110              for          t  ta+ ta- t~  ,**      H
c5        111              for          t  vm~ vm  t~  ,** mg
c5        112              for          t  vt~ vt  t~  ,**
c4        113              for          d  mu+ mu- d~  ,*
c4        114              for          d  ta+ ta- d~  ,*
c5        115              for          d  vm~ vm  d~  ,*
c5        116              for          d  vt~ vt  d~  ,*
c4        117              for          s  mu+ mu- s~  ,*
c4        118              for          s  ta+ ta- s~  ,*
c5        119              for          s  vm~ vm  s~  ,*
c5        120              for          s  vt~ vt  s~  ,*
c4        121              for          b  mu+ mu- b~  ,*
c4        122              for          b  ta+ ta- b~  ,*       H
c5        123              for          b  vm~ vm  b~  ,*
c5        124              for          b  vt~ vt  b~  ,*
c6        125              for          mu- ta+ ta- mu+,*
c7        126              for          mu- vt~ vt  mu+,*
c7        127              for          ta- vm~ vm  ta+,*
c8        128              for          vt  vm~ vm  vt~,*
c4        201              for          u  e+  e-  u~  ,*
c4        202              for          c  e+  e-  c~  ,*       H
c4        203              for          t  e+  e-  t~  ,** mg   H
c4        204              for          d  e+  e-  d~  ,*
c4        205              for          s  e+  e-  s~  ,*
c4        206              for          b  e+  e-  b~  ,*       H
c6        207              for          mu- e+ e-  mu+ ,*
c6        208              for          ta- e+ e-  ta+ ,*       H
c3        209              for          vm  e+ e-  vm~ ,*
c3        210              for          vt  e+ e-  vt~ ,*
c9        211              for          ve  u~  u  ve~ ,*
c9        212              for          ve  c~  c  ve~ ,*       H
c9        213              for          ve  t~  t  ve~ ,*  mg   H
c9        214              for          ve  d~  d  ve~ ,*
c9        215              for          ve  s~  s  ve~ ,*
c9        216              for          ve  b~  b  ve~ ,*       H
c3        217              for          ve  mu+ mu- ve~,*
c3        218              for          ve  ta+ ta- ve~,*       H
c8        219              for          ve  vm~ vm  ve~,*  mg 
c8        220              for          ve  vt~ vt  ve~,*
c2        301              for          u  d~  d   u~  ,*
c2        302              for          u  s~  s   u~  ,*
c2        303              for          u  b~  b   u~  ,*
c2        304              for          c  d~  d   c~  ,*
c2        305              for          c  s~  s   c~  ,*
c2        306              for          c  b~  b   c~  ,*       H
c2        307              for          t  d~  d   t~  ,**
c2        308              for          t  s~  s   t~  ,**      H
c2        309              for          t  b~  b   t~  ,** mg   H
c2        310              for          d  s~  s   d~  ,*
c2        311              for          d  b~  b   d~  ,*
c2        312              for          u  c~  c   u~  ,*
c2        313              for          u  t~  t   u~  ,*
c2        314              for          c  t~  t   c~  ,*
c6        401              for          mu- mu+ mu- mu+,*
c6        402              for          ta- ta+ ta- ta+,*  mg   H
c8        403              for          vm  vm~ vm  vm~,*
c8        404              for          vt  vt~ vt  vt~,*
c5        405              for          e- e+ e- e+    ,*
c2        406              for          u  u~  u   u~  ,*
c2        407              for          c  c~  c   c~  ,*       H
c2        408              for          t  t~  t   t~  ,*  mg   H
c2        409              for          d  d~  d   d~  ,*
c2        410              for          s  s~  s   s~  ,*
c2        411              for          b  b~  b   b~  .*       H
c8        412              for          ve  ve~ ve  ve~ *

      iproc=1

c Calculate the Born cross section with 'ncall0' calls: 
c iborn = 1(yes)/else(no)?

      iborn=1
      ncall0=100000

c Scan the Born cross section with 'nscan0' calls: iscan0 = 1(yes)/else(no)?

      iscan0=1
      nscan0=2000

c Calculate the soft bremsstrahlung cross section with 'ncalls' calls: 
c isoft = 1(yes)/else(no)?

      isoft=1
      ncalls=100000

c Calculate the hard bremsstrahlung cross section with 'ncallh' calls:
c ihard = 1(yes)/else(no)?

      ihard=1
      ncallh=100000

c Scan the hard bremsstrahlung cross section with 'nscanh' calls: 
c iscanh = 1(yes)/else(no)?

      iscanh=1
      nscanh=2000

c Generate the unweighted events: imc=1(yes)/else(no)?

      imc=1

c Include the Higgs boson exchange: ihiggs = 1 (yes)/ else (no)?

      ihiggs=1

c Calculate the electroweak contributions only, iew =1 (yes)/else (ew
c + QCD diagrams):

      iew=0

c Calculate the double resonant diagrams only, iww =1 (yes)/else (all 
c the diagrams):

      iww=0

c Calculate approximated cross section of e+ e- -> t t~ -> t b~ fd fu~:
c itopa=1 (yes)/ else (no:

      itopa=0
      ncalla=20000

c Calculate approximated cross section of e+ e- -> W+ W- -> 4f:
c iwwa=1 (yes)/ else (no:

      iwwa=0

c Choose the scheme:
c     ischeme = 0 - fixed width scheme (FWS),
c               1 - complex mass scheme (CMS)

      ischeme=0

c If ischeme=1, then choose the scheme for alpha_W:
c     ialpw = 0 - real alpha_W,
c     ialpw = 1 - complex alpha_W

      ialpw=0

c Choose the linear gauge, relevant only for the nonradiative top quark 
c production: 
c     iarbg = 0 - unitary gauge,
c     iarbg = 1 - arbitrary gauge

      iarbg=0

c If iarbg=1, then choose gauge parameters (ksi greater or equal 1.d16 
c corresponds to the unitary gauge):

      ksia=1.d0
      ksiz=1.d16
      ksiw=1.d16

c The soft photon energy cut:

      ecut=1.d0

c Impose the cuts, icuts= 1 (yes - canonical)/ 2 (yes - a cut on the final 
c state electron)/ 3 (yes - a cut on the final state electron and positron)
c / else (no):

      icuts=1

      if (icuts == 1) then

c The canonical cuts:

       ctlb=0.985d0
       ctll=1.d0
c       ctll=cos(5.d0/180.d0*pi)
       ctlq=1.d0
       ctgb=0.985d0
       ctgl=cos(5.d0/180.d0*pi)
       ctgq=cos(5.d0/180.d0*pi)
       ecutg=ecut
       ecutl=5.0d0
       ecutq=0.0d0
       mqq=10.d0
       mll=0.d0

       mqq2=mqq**2
       mll2=mll**2

      else if (icuts > 1) then

       theb=5.d0
       cteb=cos(theb/180.d0*pi)

      end if ! icuts

c Test against Madgraph, imad=1(yes-commented)/else(no), 
c Test the phase space volume, imad=2
c Madgraph fails in case of the bremsstrahlung reaction 405, where it
c generates 999 instead of 1008 graphs, and in the mixed electroweak-QCD
c channels, where it generates either the electroweak or QCD contributions.

      imad=0

c Calculate distributions, idis=1(yes)/0(no)?

      idis=0

      if (idis == 1) then
       nbs= (/ 160, 160, 160, 40, 40, 40, 60, 60/)
c Remember to adjust the maximum No. of bins 'nbmax' in a module 'distribs.f'!
c and specify parameters of distributions below.

      end if

c Specify the maximum of the cross section (relevant if iscan0=0 or iscanh=0)

      crmax=1.d3

c Determine parameters of the proces:

      call parspec

      write(*,4000)
      write(*,2000)
      write(*,5000)
      write(*,2000)
      write(6,2011) chproc
      write(*,2000)
      write(*,5011)
      write(*,2000)
      write(*,5021)
      write(*,5031)
      write(*,5041)
      write(*,5051)
      write(*,2000)
      write(*,5019)
      write(*,2000)
      write(*,5022)
      write(*,5032)
      write(*,5042)
      write(*,5052)
      write(*,2000)
      write(*,4000)

 2000 format('#')
 2011 format('#                         e+ e- -> ',a20)
 5000 format('# Approaching the process:')
 5011 format('# with the program ''ee4fg v. 1.0'' by')
 5021 format('#                            Karol Kolodziej')
 5031 format('#                         University of Silesia')
 5041 format('#                            Katowice, Poland')
 5051 format('#                        e-mail: kolodzie@us.edu.pl')
 5019 format('#                                 and')
 5022 format('#                            Fred Jegerlehner')
 5032 format('#                              DESY-Zeuthen')
 5042 format('#                            Zeuthen, Germany')
 5052 format('#                         e-mail: fjeger@ifh.de')

      if (ischeme == 0) then
        write(6,5010)
 5010   format('# Fixed width scheme')
      else if (ischeme == 1) then
        write(6,5020)
 5020   format('# Complex mass scheme')
        if (ialpw == 0) then
         write(6,5030) cralpw
 5030    format('# with real 1/alpha_W = (',f11.7,',',f11.7,')')
        else if (ialpw == 1) then
         write(6,5040) cralpw
 5040    format('# with complex 1/alpha_W = (',f11.7,',',f11.7,')')
        else
         write(6,5050) ialpw
 5050    format('# ialpw =',i2,' is not allowed')
        end if
      else
        write(6,5060) ischeme
 5060   format('# ischeme =',i2,' is not allowed')
      end if

      if (iarbg == 1) then
        write(6,2095)
        write(6,2096) ksia,ksiz,ksiw
 2095   format('# Gauge parameters:')
 2096   format('# ksia =',1pe10.1,'  ksiz =',1pe10.1,'  ksiw =',1pe10.1)
      else if (iarbg == 0) then
        write(6,2097)
 2097   format('# Unitary gauge (Feynman gauge for a photon)')
      else
        write(6,2098) iarbg
 2098   format('# iarbg =',i2,' is not supported')
      end if

      write(6,2000)

c      if (iarbg == 1 .and. iwtb == 1) then
c        write(6,2195)
c 2195   format('# An anomalous Wtb-vertex included with:')
c        write(6,2196) f1p,f1m,f2p,f2m
c 2196   format('# f1p=',f9.5,' f1m=',f9.5,' f2p=',f9.5,' f2m=',f9.5)
c        write(6,2000)
c      end if
      write(6,2100) chproc
 2100 format('# External fermion masses: e- ',a20)
      write(6,1001) m1,m3,m4,m5,m6
 1001 format('#',5(e15.8))

      write(6,2110)
 2110 format('# and widths:')

      write(6,1020) gam1,gam3,gam4,gam5,gam6
 1020 format('#',5(e10.3))

      write(6,2000)
      write(6,2120)
 2120 format('# Intermediate boson masses and widths:',
     &           ' W, Gm_W, Z, Gm_Z')
      write(6,1002) mw,gamw,mz,gamz
      write(6,2000)
 1002 format('# ',4(f12.5))

      if (ihiggs == 1) then
       write(6,2000)
       write(6,2122)
 2122  format('# Higgs boson mass and width: H, Gm_H')
       write(6,2002) mh,gamhig
       write(6,2000)
 2002  format('# ',2(e15.5))
      end if

      write(6,1003) ralp0, ralpw, alphas
 1003 format('# 1/alpha0 = ',f11.7,'  1/alphaw = ',f11.7,
     &       '  alphas = ',f11.7)
      write(6,1007) csw2,gmu
 1007 format('# sw^2 = (',f18.15,',',f18.15,')  G_mu = ',e13.6)

      write(6,2000)
      write(6,1005) ecut
      write(6,2000)
 1005 format('# Minimum photon energy E_cut = ',e10.3,' GeV')


      if (iew == 1) then
        write(6,2075)
 2075   format('# ONLY THE ELECTROWEAK FEYNMAN DIAGRAMS!')
        write(6,2000)
       end if

      if (iww == 1) then
        write(6,2080)
 2080 format('# ONLY THE DOUBLE RESONANT FEYNMAN DIAGRAMS!')
        write(6,2000)
       end if

      if (icuts == 2) then
        write(6,2091) theb,180.d0-theb
 2091   format('# A FINAL ELECTRON ANGLE ',e12.5,' < theta <',e12.5)
        write(6,2000)
      else if (icuts == 3) then
        write(6,2092) theb,180.d0-theb
 2092   format('# FINAL ELECTRON AND POSITRON ANGLE ',e12.5,
     &            ' < theta <',e12.5)
        write(6,2000)
      end if


      if (icuts == 1) then

       write(*,4000)

       write(*,2090)
 2090  format('# CUTS IMPOSED:')

       call cutscrit

       write(*,2000)

      end if ! icuts


c Antitop quark width in the presence of anomalous Wtb coupling:

c      if (iwtb == 1) then
c      x(1)=0.5d0
c      x(2:)=0.d0
c      gam3=gamtopan(x)
c      write(*,*)'gamtop=',gam3
c      cm3=cmplx(m3,-gam3/2.d0,8)
c      end if


c The energy loop:

      do ie=1,ne

      ecm=aecm(ie)     !  The c.m.s. energy

      if (idis == 1) then
       stl=(mt-5.d0*gamt)**2
       stu=(mt+5.d0*gamt)**2
       xmin=(/ stl, stl, sqrt(stl),-1.d0,-1.d0,-1.d0, 0.d0, 0.d0/)
       xmax=(/ stu, stu, sqrt(stu), 1.d0, 1.d0, 1.d0, ecm/2.d0, 
     &                                                ecm/2.d0/)

       desc(1)='Invariant mass squared of particles 3, 4 and 5'
       desc(2)='Invariant mass squared of particles 6, 7 and 8'
       desc(3)='Invariant mass of particles 3, 4 and 5'
       desc(4)='Cosine of the b-quark angle with respect to e+'
       desc(5)='Cosine of the angle of particle 5 with respect to e+'
       desc(6)='Cosine of the angle of 3, 4 qnd 5 with respect to e+'
       desc(7)='Energy of the b-quark'
       desc(8)='Energy of particle 5'

       do j=1,ndist
        xdi(0,j)=xmin(j)
        dx(:,j)=(xmax(j)-xmin(j))/nbs(j)
        do i=1,nbs(j)
         xdi(i,j)=xdi(i-1,j)+dx(i,j)
        end do
       end do
      end if

      if (ecm < 300.d0) then  ! Map peaks of the cross section
       itw=0
       iw34=1
       iw56=1
       ie3=1
       ict3=0
      else
       itw=0
       iw34=1
       iw56=1
       ie3=1
       ict3=0
      end if

c----------------------------------------------------------------------c
c End of input
c----------------------------------------------------------------------c

      write(*,4000)
      write(6,2000)
      write(6,1006) ecm
      write(6,2000)
      write(*,4000)
 1006 format('#                       E_cm = ',f11.3,' GeV')

      if (ecm < m3+m4+m5+m6) then 
       write(*,*)'The CMS energy below threshold'
       stop
      end if

      if (imc == 1) then
       open(unit=11,file='events.dat',status='replace',action='write')
      end if
      
c The Born cross section with standard deviation:

      if (iborn == 1) then

       write(*,2000)

       write(*,5061) chproc
 5061 format('# The Born cross section of   e+ e- -> ',a20)

       write(*,2000)
       write(*,4000)

       irad=0
       ndim=7
       bw0=aw0
       iscan=iscan0
       nkin=nkin0

       if (iscan == 1) then

c Scan the Born cross section in order to find the dominant channels:

        ncall=nscan0
        cs0=0.d0
        sd0=0.d0
        icall=0
        cssc0=zero
        crmax=zero
        sd2=0.d0

        write(*,5110)
 5110 format('# Results of the initial scan:')
        write(*,5120)
 5120 format('# Kinematics        Weight          Integral        ',
     &       'St.dev.       No of calls')

        do ikin=1,nkin
         if (bw0(ikin) > 0.d0) then
          ident=1
          call carlos(cross,ndim,ncall,cs0i,sd0i)

          cs0=cs0+bw0(ikin)*nid*cs0i
          sd0=sd0+bw0(ikin)*nid*sd0i

          write(*,3002) ikin,bw0(ikin),bw0(ikin)*cs0i,bw0(ikin)*sd0i,
     &                  ncall
 3002 format('#  ',i4,'     ',e17.8,e17.8,e17.8,i10)

          cssc0(ikin)=bw0(ikin)*nid*cs0i
          sd2=sd2+(bw0(ikin)*nid*sd0i)**2
         end if
        end do

        write(*,4000)
        write(*,3800) icall,cs0,sqrt(sd2)
 3800 format('# Born scanned with',i8,' calls = ',e15.8,'+/-',e9.3)
c        write(11,3810) crmax
c 3810 format('# The maximum value of the cross section= ',e15.8)
c        crmax=1.5d0*crmax
c        write(11,3820) crmax
c 3820 format('# shifted to ',e15.8)
c        write(*,4000)

c Set weights for the final integration:

         neff0=0

         xmc(0)=zero

         do ikin=1,nkin

          if (bw0(ikin) > zero) then
           bw0(ikin)=cssc0(ikin)/cs0
          else
           bw0(ikin)=zero
          end if

c          xmc(ikin)=xmc(ikin-1)+nid*bw0(ikin)
          xmc(ikin)=xmc(ikin-1)+bw0(ikin)

          if (xmc(ikin) > 0.999999999999d0) then
           xmc(ikin)=1.d0
           write(*,3456) ikin,bw0(ikin),xmc(ikin)-xmc(ikin-1)
 3456 format('# Weight',i5,' = ',e23.16,' rescaled to',e23.16)
           bw0(ikin)=xmc(ikin)-xmc(ikin-1)
           bw0(ikin+1:)=zero
           xmc(ikin+1:)=zero
           exit
          end if

         end do

      iscan=0

      else ! iscan

c Set weights for the final integration:

      neff0=0

      xmc(0)=zero

      do ikin=1,nkin

       xmc(ikin)=xmc(ikin-1)+bw0(ikin)

       if (xmc(ikin) > 0.999999999999d0) then
        xmc(ikin)=1.d0
        write(*,3456) ikin,bw0(ikin),xmc(ikin)-xmc(ikin-1)
        bw0(ikin)=xmc(ikin)-xmc(ikin-1)
        bw0(ikin+1:)=zero
        xmc(ikin+1:)=zero
        exit
       end if

      end do


      end if ! iscan

c The Born cross section with standard deviation:

      ncall=ncall0

      cs0=0.d0
      sd0=0.d0
      icall=0

      ieff=0

      if (idis == 1) then
       ncs=0
       di=zero
      end if

      write(*,3200)
 3200 format('# Calculating the Born cross section with the weights:')
      write(*,5125)
 5125 format('# Kinematics        Weight          Total')


      do ikin=1,nkin
       if (bw0(ikin) > 0.d0) then
        write(*,3300) ikin,bw0(ikin),xmc(ikin)
 3300   format('#  ',i4,'     ', 2e17.8)
       end if
      end do

      do id=1,nid
       ident=id
       call carlos(cross,ndim,ncall,cs0i,sd0i)
       cs0=cs0+cs0i
       if (sd0i > sd0) then
        sd0=sd0i
       end if
c       sd0=sd0+sd0i
      end do ! id

      neff0=icall

 2987 format('# Integral =',e13.6,'  Standard dev. =',e9.2,' with ',i9,
     &                                                         ' calls')

 4000 format('#-------------------------------------------------------',
     &       '----------------------#')

      write(*,4000)
      write(*,2989)
 2989 format('# Final result:')

      write(6,2987) cs0,sd0,neff0

      if (imc == 1) then
       write(*,3030) dble(ieff)/dble(icall)
 3030  format('# Efficiency of the event acceptance =',e10.3)
       write(*,4000)
      end if


      if (idis == 1) then

       do j=1,ndist

       write(*,4000)
       write(6,3000) j
 3000 format('# Distribution No. ',i3)
       write(6,3001) desc(j)
 3001  format('# ',a77)
       write(*,4000)

        arg=xmin(j)

        do n=1,nbs(j)

         if (ncs(n,j) > 0 .and. dx(n,j) > zero) then
          val=di(n,j)/dx(n,j)
         else
          val=zero
         end if

         if (j < 3) then
          write(6,1010) sqrt(xdi(n-1,j)),val
          write(6,1010) sqrt(xdi(n,j)),val
         else
          write(6,1010) xdi(n-1,j),val
          write(6,1010) xdi(n,j),val
         end if
        end do

       end do

      write(*,4000)
      write(*,5080)
 5080 format('# Test of the distributions:')

      write(*,5085) cs0,neff0
 5085 format('# Total:  ',e15.8,i12)

      do j=1,ndist
       write(*,5090) j,sum(di(:,j)),sum(ncs(:,j))
 5090 format('# ',i8,e15.8,i12)
      end do

      end if ! idis


      else

      cs0=0.d0
      sd0=0.d0

      end if ! iborn

c Approximated top production cross section:

      if (itopa == 1) then

        if (ecm > 2.d0*m3) then

         write(*,2000)

         write(*,5062) chproc
 5062 format('# Approximated Born cross section of  e+ e- -> t t ~ -> ',
     &                                                              a20)

         write(*,2000)
         write(*,4000)

         ndim=1
         ncall=ncalla

         icall=0

         call carlos(crosstopa,ndim,ncall,csta,sdta)

         neffa=icall

         write(*,2989)
         write(6,2987) csta,sdta,neffa
         write(*,4000)

        else
         csta=0.d0
        end if
      else
         csta=0.d0
      end if

c The soft bremsstrahlung cross section with standard deviation and chi^2:

      if (isoft == 1) then

       write(*,2000)
       write(*,4000)

       write(*,5063) chproc
 5063  format('# The soft bremsstrahlung cross section of   e+ e- -> ',
     &                                                             a20)

       write(*,2000)
       write(*,4000)

       irad=1
       ndim=7
       ncall=ncalls
       nkin=nkins

       cssb=0.d0
       sdsb=0.d0
       crmax=zero

       icall=0
       ieff=0
       iscan=0

       if (idis == 1) then
        ncs=0
        di=zero
       end if

      write(*,3210)
 3210 format('# Calculating the soft bremsstrahlung with the weights:')

      write(*,5125)

      do ikin=1,nkin
       if (bw0(ikin) > 0.d0) then
        write(*,3300) ikin,bw0(ikin),xmc(ikin)
       end if
      end do

      do id=1,nid
       ident=id
       call carlos(cross,ndim,ncall,cssbi,sdsbi)

       cssb=cssb+cssbi
       if (sdsbi > sdsb) then
        sdsb=sdsbi
       end if
c       sdsb=sdsb+sdsbi
      end do ! id

      neffs=icall

      write(*,4000)
      write(*,2989)

      write(6,2987) cssb,sdsb,neffs

c      write(*,3030) dble(ieff)/dble(icall)

      write(*,4000)

      if (idis == 1) then

       do j=1,ndist

       write(*,4000)
       write(6,3000) j
       write(6,3001) desc(j)
       write(*,4000)

        arg=xmin(j)

        do n=1,nbs(j)

         if (ncs(n,j) > 0 .and. dx(n,j) > zero) then
          val=di(n,j)/dx(n,j)
         else
          val=zero
         end if

         if (j < 3) then
          write(6,1010) sqrt(xdi(n-1,j)),val
          write(6,1010) sqrt(xdi(n,j)),val
         else
          write(6,1010) xdi(n-1,j),val
          write(6,1010) xdi(n,j),val
         end if
        end do

       end do

      write(*,4000)
      write(*,5080)

      write(*,5085) cssb,neffs

      do j=1,ndist
       write(*,5090) j,sum(di(:,j)),sum(ncs(:,j))
      end do

      end if ! idis


      else

       cssb=0.d0
       sdsb=0.d0
       chi2sb=0.d0

      end if ! isoft

c The hard bremsstrahlung cross section with standard deviation:

      if (ihard == 1) then

       write(*,2000)

       write(*,5064) chproc
 5064  format('# The hard bremsstrahlung cross section of   e+ e- -> ',
     &                                                             a20)

       write(*,2000)
       write(*,4000)

       irad=2
       ndim=10
       bw=aw
       iscan=iscanh
       nkin=nkinh

       if (iscan == 1) then

c Scan the hard bremsstrahlung cross section in order to find the dominant 
c channels:

        ncall=nscanh
        cshb=zero
        sdhb=zero
        icall=0
        cssc=zero
        crmax=zero
        sd2=0.d0

        write(*,5110)
        write(*,5120)

        do ikin=1,nkin
         if (bw(ikin) > 0.d0) then
          ident=1
          call carlos(cross,ndim,ncall,cshbi,sdhbi)

          cshb=cshb+bw(ikin)*nid*cshbi
          sdhb=sdhb+bw(ikin)*nid*sdhbi

          write(*,3002) ikin,bw(ikin),bw(ikin)*cshbi,bw(ikin)*sdhbi,
     &                  ncall

          cssc(ikin)=bw(ikin)*nid*cshbi
          sd2=sd2+(bw(ikin)*nid*sdhbi)**2
         end if
        end do

        write(*,4000)
        write(*,3811) icall,cshb,sqrt(sd2)
 3811 format('# Hard bremsstrahlung scanned with',i8,' calls = ',e15.8,
     &                                                     '+/-',e9.3)

c        write(*,3810) crmax
c        crmax=1.5d0*crmax
c        write(*,3820) crmax
c        write(*,4000)

c Set weights for the final integration:

         neffh=0

         xmc(0)=zero

         do ikin=1,nkin

          if (bw(ikin) > zero) then
           bw(ikin)=cssc(ikin)/cshb
          else
           bw(ikin)=zero
          end if

c          xmc(ikin)=xmc(ikin-1)+nid*bw(ikin)
          xmc(ikin)=xmc(ikin-1)+bw(ikin)

          if (xmc(ikin) > 0.999999999999d0) then
           xmc(ikin)=1.d0
           write(*,3456) ikin,bw(ikin),xmc(ikin)-xmc(ikin-1)
           bw(ikin)=xmc(ikin)-xmc(ikin-1)
           bw(ikin+1:)=zero
           xmc(ikin+1:)=zero
           exit
          end if

         end do

      iscan=0

      else ! iscan

c Set weights for the final integration:

      neffh=0

      xmc(0)=zero

      do ikin=1,nkin

       xmc(ikin)=xmc(ikin-1)+bw(ikin)

       if (xmc(ikin) > 0.999999999999d0) then
        xmc(ikin)=1.d0
        write(*,3456) ikin,bw(ikin),xmc(ikin)-xmc(ikin-1)
        bw(ikin)=xmc(ikin)-xmc(ikin-1)
        bw(ikin+1:)=zero
        xmc(ikin+1:)=zero
        exit
       end if

      end do


      end if ! iscan

c The hard bremsstrahlung cross section with standard deviation:

      ncall=ncallh

      cshb=0.d0
      sdhb=0.d0
      icall=0

      ieff=0

      if (idis == 1) then
       ncs=0
       di=zero
      end if

      write(*,3220)
 3220 format('# Calculating the hard bremsstrahlung with the weights:')

      write(*,5125)

      do ikin=1,nkin
       if (bw(ikin) > 0.d0) then
        write(*,3300) ikin,bw(ikin),xmc(ikin)
       end if
      end do

      do id=1,nid
       ident=id

       call carlos(cross,ndim,ncall,cshbi,sdhbi)

       cshb=cshb+cshbi
       if (sdhbi > sdhb) then
        sdhb=sdhbi
       end if
c       sdhb=sdhb+sdhbi
      end do ! id

      neffh=icall

      write(*,4000)
      write(*,2989)

      write(6,2987) cshb,sdhb,neffh

      if (imc == 1) then
       write(*,3030) dble(ieff)/dble(icall)
       write(*,4000)
      end if

      if (idis == 1) then

       do j=1,ndist

       write(*,4000)
       write(6,3000) j
       write(6,3001) desc(j)
       write(*,4000)

        arg=xmin(j)

        do n=1,nbs(j)

         if (ncs(n,j) > 0 .and. dx(n,j) > zero) then
          val=di(n,j)/dx(n,j)
         else
          val=zero
         end if

         if (j < 3) then
          write(6,1010) sqrt(xdi(n-1,j)),val
          write(6,1010) sqrt(xdi(n,j)),val
         else
          write(6,1010) xdi(n-1,j),val
          write(6,1010) xdi(n,j),val
         end if
        end do

       end do

      write(*,4000)
      write(*,5080)

      write(*,5085) cshb,neffh

      do j=1,ndist
       write(*,5090) j,sum(di(:,j)),sum(ncs(:,j))
      end do

      end if ! idis


      else

      cshb=0.d0
      sdhb=0.d0

      end if ! ihard

c      if (ie == 1) then

      write(6,2000)

      write(6,2130)
 2130 format('#    cs0 (fb)   sd     ',
     &          '  cssb (fb)   sd     ',
     &          '  cshb (fb)   sd     ',
     &          '  cs(s+h)')


c      if (nsdh > 10) then
c       sdhb=sqrt(dot_product(sdhba,sdhba)/dble(nsdh))
c      end if

      write(6,1004) cs0,sd0,cssb,sdsb,cshb,sdhb,cssb+cshb

 1004 format('#',e12.5,e9.2,e12.5,e9.2,e12.5,e9.2,e11.4)

      acs0(ie)=cs0
      asd0(ie)=sd0
      acssb(ie)=cssb
      asdsb(ie)=sdsb
      acshb(ie)=cshb
      asdhb(ie)=sdhb

      if (iwwa == 1) then
       call cseeww(ecm,mw,gamw,mz,gamz,ew,sw2,convc,cswwa)
       call wwidth(m3,m4,mw,3,1.d0,ew,sw2,gamw34)
       call wwidth(m5,m6,mw,1,1.d0,ew,sw2,gamw56)
       cswwa=cswwa*gamw34/gamw*gamw56/gamw
       awwa(ie)=cswwa
       asda(ie)=0.d0
      else if (itopa == 1) then
       awwa(ie)=csta
       asda(ie)=sdta
      else
       awwa(ie)=0.d0
       asda(ie)=0.d0
      end if

c      adiff(ie)=(cswwa-cs0)/cs0*100.d0

      write(6,2200)
 2200 format('# Born cross sections:')
      write(6,2202)
 2202 format('#    ecm         cs0       sd0       csapp  ',
     &         '   sda')
      do j=1,ie
       write(6,1013) aecm(j),acs0(j),asd0(j),awwa(j),asda(j)
      end do
 1013 format(e11.4,e12.5,e9.2,e12.5,e9.2)
      write(6,2210)
 2210 format('# Bremsstrahlung cross sections:')
      write(6,2212)
 2212 format('#    ecm        cssb      sdsb       cshb     sdhb    ')

      do j=1,ie
       write(6,1014) aecm(j),acssb(j),asdsb(j),acshb(j),asdhb(j)

      end do

      end do   ! ie

 1012 format(2e11.4,e9.2,e11.4)
 1014 format(e11.4,e12.5,e9.2,e12.5,e9.2)
 1010 format(2e11.4)

      stop
      end


