      subroutine eeffffgcc1(iproc,iww,p1,p2,p3,p4,p5,p6,p7,
     &                         ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2,mat2ww)
c----------------------------------------------------------------------c
c Returns the squared matrix element mat2 averaged over initial spins 
c            and summed over final spins and colours of
c
c  e+(p1) + e-(p2) --> f1u(p3) + f1d~(p4) + f2d(p5) + f2u~(p6) + gamma(p7)
c
c for the charged current processes not containing virtual gluons
c
c Input: iproc -specifies the proces,
c        iww = 1 (the double resonance diagrams only)/ else (all the 
c              diagrams),
c        pi, i=1,...,7 - external particle momenta,
c        psi, i=1,...,7 - spherical components of the external 
c                               particle momenta,
c
c The frame is defined as that p1=(E1,0,0,p), p2=(E2,0,0,-p).
c Massive vector bosons are taken in the unitary gauge and massless 
c in the Feynman gauge
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 2 March, 1998; modified 30 March, 1998; 17 April, 1998;
c                         18 April, 1998; 27 January 1999;
c                         2 February, 1999; 29 September, 1999;
c                         January/February 2000; 14-19 April 2000;
c                         21 June 2000; 15 February, 2001; 4 May, 2001;
c                         1 November, 2001
c----------------------------------------------------------------------c

      use mathprms 
      use parsm
      use helproc
      use parproc
      use inistate

      implicit none
      integer, parameter :: dp=kind(1.d0)

      integer iproc,iww
      integer i1,i2,i3,i4,i5,i6,i7,i

      real(dp), dimension(0:3) ::  p1,p2,p3,p4,p5,p6,p7
      real(dp), dimension(0:4) ::  ps1,ps2,ps3,ps4,ps5,ps6,ps7
      real(dp) :: mat2,mat2ww,srr,e7(0:3,n7),ebeam=0.d0

      complex(dp) :: mat,mat0,matww,src,scc

      real(dp) dbe,t52
      complex(dp) d17,d27,d37,d47,d57,d67

      complex(dp), dimension(2,2) :: xp3,xp4,xp5,xp6,xp7,
     &                              yp3,yp4,yp5,yp6,yp7

      complex(dp), dimension(4,n3) :: u3
      complex(dp), dimension(4,n4) :: u4
      complex(dp), dimension(4,n5) :: u5
      complex(dp), dimension(4,n6) :: u6

      complex(dp), dimension(2,2,n7) :: xe7,ye7

      complex(dp), dimension(0:3,n1,n2,n7) :: ea12g,ez12g
      complex(dp), dimension(2,2,n1,n2,n7) :: xa12g,xz12g,ya12g,yz12g,
     &                                       x312g,x412g,x512g,x612g,
     &                                       y312g,y412g,y512g,y612g
      complex(dp), dimension(0:3,n3,n6) :: ea36,ez36
      complex(dp), dimension(0:3,n3,n6,n7) :: ea36g,ez36g
      complex(dp), dimension(2,2,n3,n6) :: xa36,xz36,x136,x536,
     &                                    ya36,yz36,y136,y536
      complex(dp), dimension(2,2,n3,n6,n7) :: xa36g,xz36g,x136g,x536g,
     &                                       ya36g,yz36g,y136g,y536g
      complex(dp), dimension(0:3,n5,n4) :: ea54,ez54
      complex(dp), dimension(0:3,n5,n4,n7) :: ea54g,ez54g
      complex(dp), dimension(2,2,n5,n4) :: xa54,xz54,x154,x354,
     &                                    ya54,yz54,y154,y354
      complex(dp), dimension(2,2,n5,n4,n7) :: xa54g,xz54g,x154g,x354g,
     &                                       ya54g,yz54g,y154g,y354g
      complex(dp), dimension(0:3,n3,n4) :: ew34
      complex(dp), dimension(0:3,n3,n4,n7) :: ew34g
      complex(dp), dimension(2,2,n3,n4) :: xw34,yw34
      complex(dp), dimension(2,2,n3,n4,n7) :: xw34g,yw34g
      complex(dp), dimension(0:3,n5,n6) :: ew56
      complex(dp), dimension(0:3,n5,n6,n7) :: ew56g
      complex(dp), dimension(2,2,n5,n6) :: xw56,yw56
      complex(dp), dimension(2,2,n5,n6,n7) :: xw56g,yw56g

      complex(dp), dimension(0:3,n1,n6) :: ew16
      complex(dp), dimension(2,2,n1,n6) :: xw16,yw16
      complex(dp), dimension(0:3,n5,n2) :: ea52,ez52
      complex(dp), dimension(2,2,n5,n2) :: xa52,ya52,xz52,yz52,
     &                                    x152,y152,x352,y352,
     &                                    x452,y452
      complex(dp), dimension(0:3,n1,n6,n7) :: ew16g
      complex(dp), dimension(2,2,n1,n6,n7) :: xw16g,yw16g
      complex(dp), dimension(0:3,n5,n2,n7) :: ea52g,ez52g
      complex(dp), dimension(2,2,n5,n2,n7) :: xa52g,ya52g,
     &                                       xz52g,yz52g,
     &                                       x152g,y152g,
     &                                       x352g,y352g,
     &                                       x452g,y452g

      complex(dp), dimension(n3,n6) :: h36
      complex(dp), dimension(n5,n4) :: h54

      complex(dp), dimension(2,2,n7) :: h00g
      complex(dp), dimension(n3,n6,n7) :: h36g
      complex(dp), dimension(n5,n4,n7) :: h54g

c      complex(dp), dimension(4,n1,n7) :: u17

      complex(dp), dimension(n1,n7,n3,n4,n5,n6,n2) :: m1_1
      complex(dp), dimension(n1,n3,n4,n5,n6,n7,n2) :: m1_2
      complex(dp), dimension(n1,n3,n4,n7,n5,n6,n2) :: m1_3
      complex(dp), dimension(n1,n3,n4,n5,n6,n7,n2) :: m1_4
      complex(dp), dimension(n5,n6,n3,n4,n1,n2,n7) :: m2_1
      complex(dp), dimension(n5,n6,n3,n4,n7,n1,n2) :: m2_2
      complex(dp), dimension(n5,n6,n7,n3,n4,n1,n2) :: m2_3
      complex(dp), dimension(n3,n4,n5,n6,n1,n2,n7) :: m2_4
      complex(dp), dimension(n3,n1,n2,n7,n5,n6,n4) :: m3_1
      complex(dp), dimension(n3,n7,n1,n2,n5,n6,n4) :: m3_2
      complex(dp), dimension(n3,n1,n2,n5,n6,n7,n4) :: m3_3
      complex(dp), dimension(n3,n1,n2,n7,n5,n6,n4) :: m3_4
      complex(dp), dimension(n3,n1,n2,n5,n6,n7,n4) :: m3_5
      complex(dp), dimension(n3,n5,n6,n1,n2,n7,n4) :: m4_1
      complex(dp), dimension(n3,n7,n5,n6,n1,n2,n4) :: m4_2
      complex(dp), dimension(n3,n5,n6,n1,n2,n7,n4) :: m4_3
      complex(dp), dimension(n3,n5,n6,n7,n1,n2,n4) :: m4_4
      complex(dp), dimension(n3,n5,n6,n7,n1,n2,n4) :: m4_5
      complex(dp), dimension(n5,n1,n2,n7,n3,n4,n6) :: m5_1
      complex(dp), dimension(n5,n7,n1,n2,n3,n4,n6) :: m5_2
      complex(dp), dimension(n5,n1,n2,n7,n3,n4,n6) :: m5_3
      complex(dp), dimension(n5,n1,n2,n3,n4,n7,n6) :: m5_4
      complex(dp), dimension(n5,n1,n2,n3,n4,n7,n6) :: m5_5
      complex(dp), dimension(n5,n3,n4,n1,n2,n7,n6) :: m6_1
      complex(dp), dimension(n5,n7,n3,n4,n1,n2,n6) :: m6_2
      complex(dp), dimension(n5,n3,n4,n7,n1,n2,n6) :: m6_3
      complex(dp), dimension(n5,n3,n4,n7,n1,n2,n6) :: m6_4
      complex(dp), dimension(n5,n3,n4,n1,n2,n7,n6) :: m6_5
      complex(dp), dimension(n1,n7,n5,n4,n3,n6,n2) :: m7_1
      complex(dp), dimension(n1,n5,n4,n3,n6,n7,n2) :: m7_2
      complex(dp), dimension(n1,n5,n4,n7,n3,n6,n2) :: m7_3
      complex(dp), dimension(n1,n5,n4,n7,n3,n6,n2) :: m7_4
      complex(dp), dimension(n1,n5,n4,n3,n6,n7,n2) :: m7_5
      complex(dp), dimension(n1,n7,n3,n6,n5,n4,n2) :: m8_1
      complex(dp), dimension(n1,n3,n6,n5,n4,n7,n2) :: m8_2
      complex(dp), dimension(n1,n3,n6,n7,n5,n4,n2) :: m8_3
      complex(dp), dimension(n1,n3,n6,n7,n5,n4,n2) :: m8_4
      complex(dp), dimension(n1,n3,n6,n5,n4,n7,n2) :: m8_5
      complex(dp), dimension(n3,n7,n1,n2,n5,n4,n6) :: m9_1
      complex(dp), dimension(n3,n1,n2,n5,n4,n7,n6) :: m9_2
      complex(dp), dimension(n3,n1,n2,n7,n5,n4,n6) :: m9_3
      complex(dp), dimension(n3,n1,n2,n7,n5,n4,n6) :: m9_4
      complex(dp), dimension(n3,n1,n2,n5,n4,n7,n6) :: m9_5
      complex(dp), dimension(n3,n7,n5,n4,n1,n2,n6) :: m10_1
      complex(dp), dimension(n3,n5,n4,n1,n2,n7,n6) :: m10_2
      complex(dp), dimension(n3,n5,n4,n7,n1,n2,n6) :: m10_3
      complex(dp), dimension(n3,n5,n4,n7,n1,n2,n6) :: m10_4
      complex(dp), dimension(n3,n5,n4,n1,n2,n7,n6) :: m10_5
      complex(dp), dimension(n5,n7,n1,n2,n3,n6,n4) :: m11_1
      complex(dp), dimension(n5,n1,n2,n3,n6,n7,n4) :: m11_2
      complex(dp), dimension(n5,n1,n2,n7,n3,n6,n4) :: m11_3
      complex(dp), dimension(n5,n1,n2,n7,n3,n6,n4) :: m11_4
      complex(dp), dimension(n5,n1,n2,n3,n6,n7,n4) :: m11_5
      complex(dp), dimension(n5,n7,n3,n6,n1,n2,n4) :: m12_1
      complex(dp), dimension(n5,n3,n6,n1,n2,n7,n4) :: m12_2
      complex(dp), dimension(n5,n3,n6,n7,n1,n2,n4) :: m12_3
      complex(dp), dimension(n5,n3,n6,n7,n1,n2,n4) :: m12_4
      complex(dp), dimension(n5,n3,n6,n1,n2,n7,n4) :: m12_5

      complex(dp), dimension(n1,n6,n3,n4,n5,n2,n7) :: m17_1
      complex(dp), dimension(n1,n6,n3,n4,n7,n5,n2) :: m17_2
      complex(dp), dimension(n1,n6,n7,n3,n4,n5,n2) :: m17_3
      complex(dp), dimension(n3,n4,n1,n6,n5,n2,n7) :: m17_4
      complex(dp), dimension(n5,n7,n3,n4,n1,n6,n2) :: m18_1
      complex(dp), dimension(n5,n3,n4,n1,n6,n7,n2) :: m18_2
      complex(dp), dimension(n5,n3,n4,n7,n1,n6,n2) :: m18_3
      complex(dp), dimension(n5,n3,n4,n1,n6,n7,n2) :: m18_4
      complex(dp), dimension(n3,n7,n5,n2,n1,n6,n4) :: m19_1
      complex(dp), dimension(n3,n5,n2,n1,n6,n7,n4) :: m19_2
      complex(dp), dimension(n3,n5,n2,n7,n1,n6,n4) :: m19_3
      complex(dp), dimension(n3,n5,n2,n7,n1,n6,n4) :: m19_4
      complex(dp), dimension(n3,n5,n2,n1,n6,n7,n4) :: m19_5
      complex(dp), dimension(n3,n7,n1,n6,n5,n2,n4) :: m20_1
      complex(dp), dimension(n3,n1,n6,n5,n2,n7,n4) :: m20_2
      complex(dp), dimension(n3,n1,n6,n7,n5,n2,n4) :: m20_3
      complex(dp), dimension(n3,n1,n6,n7,n5,n2,n4) :: m20_4
      complex(dp), dimension(n3,n1,n6,n5,n2,n7,n4) :: m20_5
      complex(dp), dimension(n1,n7,n5,n2,n3,n4,n6) :: m21_1
      complex(dp), dimension(n1,n5,n2,n7,n3,n4,n6) :: m21_2
      complex(dp), dimension(n1,n5,n2,n7,n3,n4,n6) :: m21_3
      complex(dp), dimension(n1,n5,n2,n3,n4,n7,n6) :: m21_4
      complex(dp), dimension(n1,n7,n3,n4,n5,n2,n6) :: m22_1
      complex(dp), dimension(n1,n3,n4,n7,n5,n2,n6) :: m22_2
      complex(dp), dimension(n1,n3,n4,n5,n2,n7,n6) :: m22_3

      save ebeam

      if (p1(0).ne.ebeam) then
       call inipart(p1,p2,ps1,ps2)
       ebeam=p1(0)
      end if

c External particle momenta in the spinor representation:


      call spinr(p3,xp3,yp3)
      call spinr(p4,xp4,yp4)
      call spinr(p5,xp5,yp5)
      call spinr(p6,xp6,yp6)
      call spinr(p7,xp7,yp7)

c Spinors of the external fermions:

      call spinornew(p3,ps3,m3,1,1,n3,u3)
      call spinornew(p4,ps4,m4,-1,0,n4,u4)
      call spinornew(p5,ps5,m5,1,1,n5,u5)
      call spinornew(p6,ps6,m6,-1,0,n6,u6)

c Photon polarization vectors:

      call recpol(p7,ps7,zero,e7)

      do i7=1,n7
ckk>
c Test gauge invariance:

c      e7(:,i7)=p7
ckk<
        call spinr(e7(:,i7),xe7(:,:,i7),ye7(:,:,i7))
      end do

c Fermion denominators:

c      dbe=1.d0-sqrt(1.d0-(m1/p1(0))**2)
      dbe=(m1/p1(0))**2/2.d0

      d17=cmplx(-2.d0*p1(0)*p7(0)*(1.d0-ps7(1)+dbe*ps7(1)),zero,dp)
c     &                               +(gam1/2.d0)**2,m1*gam1,dp)
      d27=cmplx(-2.d0*p2(0)*p7(0)*(1.d0+ps7(1)-dbe*ps7(1)),zero,dp)
c     &                               +(gam2/2.d0)**2,m2*gam2,dp)
      d37=cmplx(srr(p3+p7,p3+p7),zero,dp)-cm3**2
      d47=cmplx(srr(p4+p7,p4+p7),zero,dp)-cm4**2
      d57=cmplx(srr(p5+p7,p5+p7),zero,dp)-cm5**2
      d67=cmplx(srr(p6+p7,p6+p7),zero,dp)-cm6**2

c Building blocks of the diagrams:

c Vector boson couplings sandwiched by the external spinors:

      call fvf(u3,n3,p3,m3,wff,ocom,zero,mw2,u4,n4,p4,m4,
     &                                                 ew34,xw34,yw34)
      call fvf(u5,n5,p5,m5,wff,ocom,zero,mw2,u6,n6,p6,m6,
     &                                                 ew56,xw56,yw56)
      if (iproc > 15) then

      t52=-2.d0*ps2(0)*ps5(0)*(1.d0+ps5(1)
     &    +(m2*(p2(0)-p5(0))/(p2(0)*p5(0)))**2/2.d0)

       call fvf(u1,n1,-p1,m1,wff,ocom,zero,mw2,u6,n6,p6,m6,
     &                                                 ew16,xw16,yw16)
       call fvf(u5,n5,p5,m5,ga5m,ga5p,t52,ma2,u2,n2,-p2,m2,
     &                                                 ea52,xa52,ya52)
       call fvf(u5,n5,p5,m5,gz5m,gz5p,t52,mz2,u2,n2,-p2,m2,
     &                                                 ez52,xz52,yz52)
      end if ! iproc > 15


      if (iww /= 1) then
      if (iproc > 10 .and. iproc < 16) then
       if (ga3m /= ocom) then
        call fvf(u3,n3,p3,m3,ga3m,ga3p,zero,ma2,u6,n6,p6,m6,
     &                                                 ea36,xa36,ya36)
       else
        xa36=ocom
        ya36=ocom
       end if ! ga3m
       call fvf(u3,n3,p3,m3,gz3m,gz3p,zero,mz2,u6,n6,p6,m6,
     &                                                 ez36,xz36,yz36)
       call fvf(u5,n5,p5,m5,ga5m,ga5p,zero,ma2,u4,n4,p4,m4,
     &                                                 ea54,xa54,ya54)
       call fvf(u5,n5,p5,m5,gz5m,gz5p,zero,mz2,u4,n4,p4,m4,
     &                                                 ez54,xz54,yz54)
       if (ihiggs == 1) then
        call fhf(u5,n5,p5,hff(5),zero,mh2,u4,n4,p4,h54)
       end if
      end if ! iproc
      end if ! iww

      call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &           u6,n6,p6,xp6,yp6,cm6,ga6m,d67,wff,ocom,mw2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,-gww,ew56,ew56g,xw56g,yw56g,
     &           0,hff(5),mh2,h00g)

      call ffvgnew(u3,n3,p3,xp3,yp3,cm3,ga3m,d37,
     &           u4,n4,p4,xp4,yp4,cm4,ga4m,d47,wff,ocom,mw2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,gww,ew34,ew34g,xw34g,yw34g,
     &           0,hff(3),mh2,h00g)

      call ffvgnew(u1,n1,-p1,-xp1,-yp1,cm1,ga1m,d17,
     &          u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,ga1m,ga1p,ma2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea12,ea12g,xa12g,ya12g,
     &          0,hff(1),mh2,h00g)

      call ffvgnew(u1,n1,-p1,-xp1,-yp1,cm1,ga1m,d17,
     &          u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,gz1m,gz1p,mz2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea12,ez12g,xz12g,yz12g,
     &          0,hff(1),mh2,h00g)

      if (iproc > 15) then
c       call ffvg(u1,n1,-p1,ga1m,d17,u6,n6,p6,ga6m,d67,wff,zero,mw2,
c     &          e7,xe7,ye7,n7,p7,xp7,yp7,-gww,ew16,ew16g,xw16g,yw16g)
       call ffvgnew(u1,n1,-p1,-xp1,-yp1,cm1,ga1m,d17,
     &           u6,n6,p6,xp6,yp6,cm6,ga6m,d67,wff,ocom,mw2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,-gww,ew16,ew16g,xw16g,yw16g,
     &           0,hff(6),mh2,h00g)
c       call ffvg(u5,n5,p5,ga5m,d57,u2,n2,-p2,ga2m,d27,
c     &          ga5m,ga5p,ma2,e7,xe7,ye7,n7,p7,xp7,yp7,zero,ea52,
c     &          ea52g,xa52g,ya52g)

      call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &          u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,ga5m,ga5p,ma2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea52,ea52g,xa52g,ya52g,
     &          0,hff(5),mh2,h00g)

c       call ffvg(u5,n5,p5,ga5m,d57,u2,n2,-p2,ga2m,d27,
c     &          gz5m,gz5p,mz2,e7,xe7,ye7,n7,p7,xp7,yp7,zero,ez52,
c     &          ez52g,xz52g,yz52g)

      call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &          u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,gz5m,gz5p,mz2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea52,ez52g,xz52g,yz52g,
     &          0,hff(5),mh2,h00g)


      end if ! iproc > 15


      if (iww /= 1) then
      if (iproc > 10 .and. iproc < 16) then

      if (ga3m /= ocom) then
       call ffvgnew(u3,n3,p3,xp3,yp3,cm3,ga3m,d37,
     &           u6,n6,p6,xp6,yp6,cm6,ga6m,d67,ga3m,ga3p,ma2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea36,ea36g,xa36g,ya36g,
     &           0,hff(3),mh2,h00g)
      else
       ea36g=ocom
       xa36g=ocom
       ya36g=ocom
      end if ! ga3m

      call ffvgnew(u3,n3,p3,xp3,yp3,cm3,ga3m,d37,
     &           u6,n6,p6,xp6,yp6,cm6,ga6m,d67,gz3m,gz3p,mz2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ez36,ez36g,xz36g,yz36g,
     &           ihiggs,hff(3),mh2,h36g)

      call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &           u4,n4,p4,xp4,yp4,cm4,ga4m,d47,ga5m,ga5p,ma2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea54,ea54g,xa54g,ya54g,
     &           0,hff(5),mh2,h00g)

       call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &           u4,n4,p4,xp4,yp4,cm4,ga4m,d47,gz5m,gz5p,mz2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ez54,ez54g,xz54g,yz54g,
     &           ihiggs,hff(5),mh2,h54g)

      end if ! iproc
      end if ! iww

c Amplitudes:

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &                xp7,yp7,cm1,d17,xw34,yw34,wff,ocom,
     &                xp2-xp5-xp6,yp2-yp5-yp6,ocom,ocom,
     &                xw56,yw56,wff,ocom,u2,-p2,
     &                m1_1,n1,n7,n3*n4,n5*n6,n2)

c      call uep(u1,xe7,ye7,ga1p,ga1m,-xp1+xp7,-yp1+yp7,cm1,d17,u17,n1,n7)

c      call fefef(u17,-p1+p7,xw34,yw34,wff,ocom,
c     &                xp2-xp5-xp6,yp2-yp5-yp6,ocom,ocom,
c     &                xw56,yw56,wff,ocom,u2,-p2,
c     &                m1_1,n1*n7,n3*n4,n5*n6,n2)

      call fefefef(u1,-p1,xw34,yw34,wff,ocom,
     &               -xp1+xp3+xp4,-yp1+yp3+yp4,ocom,ocom,
     &                xw56,yw56,wff,ocom,xp7,yp7,cm2,d27,
     &                xe7,ye7,ga2m,ga2p,u2,-p2,
     &                m1_2,n1,n3*n4,n5*n6,n7,n2)

      call fefef(u1,-p1,xw34g,yw34g,wff,ocom,
     &              xp2-xp5-xp6,yp2-yp5-yp6,ocom,ocom,
     &              xw56,yw56,wff,ocom,u2,-p2,
     &              m1_3,n1,n3*n4*n7,n5*n6,n2)

      call fefef(u1,-p1,xw34,yw34,wff,ocom,
     &             -xp1+xp3+xp4,-yp1+yp3+yp4,ocom,ocom,
     &              xw56g,yw56g,wff,ocom,u2,-p2,
     &              m1_4,n1,n3*n4,n5*n6*n7,n2)


      call eee(p5+p6,ew56,-p3-p4,ew34,
     &         p3+p4+p5+p6,gww*ea12g+zww*ez12g,
     &                                      m2_1,n5*n6,n3*n4,n1*n2*n7)

      call eee(p5+p6,ew56,-p3-p4-p7,ew34g,
     &      p1+p2,gww*ea12+zww*ez12,m2_2,n5*n6,n3*n4*n7,n1*n2)

      call eee(p5+p6+p7,ew56g,-p3-p4,ew34,
     &      p1+p2,gww*ea12+zww*ez12,m2_3,n5*n6*n7,n3*n4,n1*n2)

      call eeee(ew34,ew56,ggww*ea12+gzww*ez12,cmplx(e7,zero,dp),
     &                                      m2_4,n3*n4,n5*n6,n1*n2,n7)


      if (iproc > 15) then

      call eee(-p1+p6,ew16,-p3-p4,ew34,
     &         p2-p5-p7,gww*ea52g+zww*ez52g,m17_1,n1*n6,n3*n4,n5*n2*n7)

      call eee(-p1+p6,ew16,-p3-p4-p7,ew34g,
     &          p2-p5,gww*ea52+zww*ez52,m17_2,n1*n6,n3*n4*n7,n5*n2)

      call eee(-p1+p6+p7,ew16g,-p3-p4,ew34,
     &          p2-p5,gww*ea52+zww*ez52,m17_3,n1*n6*n7,n3*n4,n5*n2)

      call eeee(ew34,ew16,ggww*ea52+gzww*ez52,cmplx(e7,zero,dp),
     &                                      m17_4,n3*n4,n1*n6,n5*n2,n7)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,
     &                xp7,yp7,cm5,d57,xw34,yw34,wff,ocom,
     &                xp2+xp1-xp6,yp2+yp1-yp6,ocom,ocom,
     &                xw16,yw16,wff,ocom,u2,-p2,
     &                m18_1,n5,n7,n3*n4,n1*n6,n2)

      call fefefef(u5,p5,xw34,yw34,wff,ocom,
     &                xp5+xp3+xp4,yp5+yp3+yp4,ocom,ocom,
     &                xw16,yw16,wff,ocom,xp7,yp7,cm2,d27,
     &                xe7,ye7,ga2m,ga2p,u2,-p2,
     &                m18_2,n5,n3*n4,n1*n6,n7,n2)

      call fefef(u5,p5,xw34g,yw34g,wff,ocom,
     &              xp2+xp1-xp6,yp2+yp1-yp6,ocom,ocom,
     &              xw16,yw16,wff,ocom,u2,-p2,
     &              m18_3,n5,n3*n4*n7,n1*n6,n2)

      call fefef(u5,p5,xw34,yw34,wff,ocom,
     &              xp5+xp3+xp4,yp5+yp3+yp4,ocom,ocom,
     &              xw16g,yw16g,wff,ocom,u2,-p2,
     &              m18_4,n5,n3*n4,n1*n6*n7,n2)


      end if ! iproc

      if (iww /= 1) then

      x312g=ga3p*xa12g+gz3p*xz12g
      y312g=ga3m*ya12g+gz3m*yz12g
      x412g=ga4p*xa12g+gz4p*xz12g
      y412g=ga4m*ya12g+gz4m*yz12g
      x512g=ga5p*xa12g+gz5p*xz12g
      y512g=ga5m*ya12g+gz5m*yz12g
      x612g=ga6p*xa12g+gz6p*xz12g
      y612g=ga6m*ya12g+gz6m*yz12g

      call fefef(u3,p3,x312g,y312g,onec,onec,
     &              -xp4-xp5-xp6,-yp4-yp5-yp6,cm3,ocom,
     &              xw56,yw56,wff,ocom,u4,p4,
     &              m3_1,n3,n1*n2*n7,n5*n6,n4)

      call fefefef(u3,p3,xe7,ye7,ga3m,ga3p,
     &                xp7,yp7,cm3,d37,x312,y312,onec,onec,
     &               -xp4-xp5-xp6,-yp4-yp5-yp6,cm3,ocom,
     &                xw56,yw56,wff,ocom,u4,p4,
     &                m3_2,n3,n7,n1*n2,n5*n6,n4)

      call fefefef(u3,p3,x312,y312,onec,onec,
     &               -xp1-xp2+xp3,-yp1-yp2+yp3,cm3,ocom,
     &                xw56,yw56,wff,ocom,
     &                xp7,yp7,cm4,d47,xe7,ye7,ga4m,ga4p,u4,p4,
     &                m3_3,n3,n1*n2,n5*n6,n7,n4)

      call fefefef(u3,p3,x312,y312,onec,onec,
     &               -xp1-xp2+xp3,-yp1-yp2+yp3,cm3,ocom,
     &                xe7,ye7,ga3m,ga3p,
     &               -xp4-xp5-xp6,-yp4-yp5-yp6,cm3,ocom,
     &                xw56,yw56,wff,ocom,u4,p4,
     &                m3_4,n3,n1*n2,n7,n5*n6,n4)

      call fefef(u3,p3,x312,y312,onec,onec,
     &             -xp1-xp2+xp3,-yp1-yp2+yp3,cm3,ocom,
     &              xw56g,yw56g,wff,ocom,u4,p4,
     &              m3_5,n3,n1*n2,n5*n6*n7,n4)

      call fefef(u3,p3,xw56,yw56,wff,ocom,
     &              xp3+xp5+xp6,yp3+yp5+yp6,cm4,ocom,
     &              x412g,y412g,onec,onec,
     &              u4,p4,m4_1,n3,n5*n6,n1*n2*n7,n4)

      call fefefef(u3,p3,xe7,ye7,ga3m,ga3p,
     &                xp7,yp7,cm3,d37,xw56,yw56,wff,ocom,
     &                xp1+xp2-xp4,yp1+yp2-yp4,cm4,ocom,
     &                x412,y412,onec,onec,u4,p4,
     &                m4_2,n3,n7,n5*n6,n1*n2,n4)

      call fefefef(u3,p3,xw56,yw56,wff,ocom,
     &                xp3+xp5+xp6,yp3+yp5+yp6,cm4,ocom,
     &                x412,y412,onec,onec,xp7,yp7,cm4,d47,
     &                xe7,ye7,ga4m,ga4p,u4,p4,
     &                m4_3,n3,n5*n6,n1*n2,n7,n4)

      call fefefef(u3,p3,xw56,yw56,wff,ocom,
     &                xp3+xp5+xp6,yp3+yp5+yp6,cm4,ocom,
     &       xe7,ye7,ga4m,ga4p,xp1+xp2-xp4,yp1+yp2-yp4,cm4,ocom,
     &                x412,y412,onec,onec,u4,p4,
     &                m4_4,n3,n5*n6,n7,n1*n2,n4)

      call fefef(u3,p3,xw56g,yw56g,wff,ocom,
     &              xp1+xp2-xp4,yp1+yp2-yp4,cm4,ocom,
     &              x412,y412,onec,onec,u4,p4,
     &              m4_5,n3,n5*n6*n7,n1*n2,n4)

      call fefef(u5,p5,x512g,y512g,onec,onec,
     &             -xp6-xp3-xp4,-yp6-yp3-yp4,cm5,ocom,
     &              xw34,yw34,wff,ocom,u6,p6,
     &              m5_1,n5,n1*n2*n7,n3*n4,n6)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,
     &                xp7,yp7,cm5,d57,
     &                x512,y512,onec,onec,
     &               -xp6-xp3-xp4,-yp6-yp3-yp4,cm5,ocom,
     &                xw34,yw34,wff,ocom,u6,p6,
     &                m5_2,n5,n7,n1*n2,n3*n4,n6)

      call fefefef(u5,p5,x512,y512,onec,onec,
     &               -xp1-xp2+xp5,-yp1-yp2+yp5,cm5,ocom,
     &                xe7,ye7,ga5m,ga5p,
     &               -xp6-xp3-xp4,-yp6-yp3-yp4,cm5,ocom,
     &                xw34,yw34,wff,ocom,u6,p6,
     &                m5_3,n5,n1*n2,n7,n3*n4,n6)

      call fefefef(u5,p5,x512,y512,onec,onec,
     &               -xp1-xp2+xp5,-yp1-yp2+yp5,cm5,ocom,
     &                xw34,yw34,wff,ocom,
     &                xp7,yp7,cm6,d67,
     &                xe7,ye7,ga6m,ga6p,u6,p6,
     &                m5_5,n5,n1*n2,n3*n4,n7,n6)

      call fefef(u5,p5,x512,y512,onec,onec,
     &             -xp1-xp2+xp5,-yp1-yp2+yp5,cm5,ocom,
     &              xw34g,yw34g,wff,ocom,u6,p6,
     &              m5_4,n5,n1*n2,n3*n4*n7,n6)

      call fefef(u5,p5,xw34,yw34,wff,ocom,
     &           xp5+xp3+xp4,yp5+yp3+yp4,cm6,ocom,
     &           x612g,y612g,onec,onec,u6,p6,m6_1,n5,n3*n4,n1*n2*n7,n6)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,xp7,yp7,cm5,d57,
     &                xw34,yw34,wff,ocom,
     &                xp1+xp2-xp6,yp1+yp2-yp6,cm6,ocom,
     &                x612,y612,onec,onec,u6,p6,
     &                m6_2,n5,n7,n3*n4,n1*n2,n6)

      call fefefef(u5,p5,xw34,yw34,wff,ocom,
     &                xp5+xp3+xp4,yp5+yp3+yp4,cm6,ocom,
     &                xe7,ye7,ga6m,ga6p,
     &                xp1+xp2-xp6,yp1+yp2-yp6,cm6,ocom,
     &                x612,y612,onec,onec,u6,p6,
     &                m6_4,n5,n3*n4,n7,n1*n2,n6)

      call fefefef(u5,p5,xw34,yw34,wff,ocom,
     &                xp5+xp3+xp4,yp5+yp3+yp4,cm6,ocom,
     &                x612,y612,onec,onec,
     &                xp7,yp7,cm6,d67,xe7,ye7,ga6m,ga6p,u6,p6,
     &                m6_5,n5,n3*n4,n1*n2,n7,n6)

      call fefef(u5,p5,xw34g,yw34g,wff,ocom,
     &              xp1+xp2-xp6,yp1+yp2-yp6,cm6,ocom,
     &              x612,y612,onec,onec,u6,p6,
     &              m6_3,n5,n3*n4*n7,n1*n2,n6)


      if (iproc > 10 .and. iproc < 16) then

      x136=ga1p*xa36+gz1p*xz36
      y136=ga1m*ya36+gz1m*yz36
      x136g=ga1p*xa36g+gz1p*xz36g
      y136g=ga1m*ya36g+gz1m*yz36g

      x154=ga1p*xa54+gz1p*xz54
      y154=ga1m*ya54+gz1m*yz54
      x154g=ga1p*xa54g+gz1p*xz54g
      y154g=ga1m*ya54g+gz1m*yz54g

      x354=ga3p*xa54+gz3p*xz54
      y354=ga3m*ya54+gz3m*yz54
      x354g=ga3p*xa54g+gz3p*xz54g
      y354g=ga3m*ya54g+gz3m*yz54g

      x536=ga5p*xa36+gz5p*xz36
      y536=ga5m*ya36+gz5m*yz36
      x536g=ga5p*xa36g+gz5p*xz36g
      y536g=ga5m*ya36g+gz5m*yz36g

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &                xp7,yp7,cm1,d17,x154,y154,onec,onec,
     &                xp2-xp3-xp6,yp2-yp3-yp6,cm2,ocom,
     &                x136,y136,onec,onec,u2,-p2,
     &                m7_1,n1,n7,n5*n4,n3*n6,n2)
c      call fefef(u17,-p1+p7,x154,y154,onec,onec,
c     &                xp2-xp3-xp6,yp2-yp3-yp6,cm2,ocom,
c     &                x136,y136,onec,onec,u2,-p2,
c     &                m7_1,n1*n7,n5*n4,n3*n6,n2)

      call fefefef(u1,-p1,x154,y154,onec,onec,
     &                -xp1+xp5+xp4,-yp1+yp5+yp4,cm1,ocom,
     &                x136,y136,onec,onec,xp7,yp7,cm2,d27,
     &                xe7,ye7,ga2m,ga2p,u2,-p2,
     &                m7_2,n1,n5*n4,n3*n6,n7,n2)

      call fefefef(u1,-p1,x154,y154,onec,onec,
     &                -xp1+xp5+xp4,-yp1+yp5+yp4,cm1,ocom,
     &                xe7,ye7,ga1m,ga1p,
     &                xp2-xp3-xp6,yp2-yp3-yp6,cm2,ocom,
     &                x136,y136,onec,onec,u2,-p2,
     &                m7_3,n1,n5*n4,n7,n3*n6,n2)

      call fefef(u1,-p1,x154g,y154g,onec,onec,
     &           xp2-xp3-xp6,yp2-yp3-yp6,cm2,ocom,
     &           x136,y136,onec,onec,u2,-p2,
     &           m7_4,n1,n5*n4*n7,n3*n6,n2)

      call fefef(u1,-p1,x154,y154,onec,onec,
     &          -xp1+xp5+xp4,-yp1+yp5+yp4,cm1,ocom,
     &           x136g,y136g,onec,onec,u2,-p2,
     &           m7_5,n1,n5*n4,n3*n6*n7,n2)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &                xp7,yp7,cm1,d17,x136,y136,onec,onec,
     &                xp2-xp5-xp4,yp2-yp5-yp4,cm2,ocom,
     &                x154,y154,onec,onec,u2,-p2,
     &                m8_1,n1,n7,n3*n6,n5*n4,n2)
c      call fefef(u17,-p1+p7,x136,y136,onec,onec,
c     &                xp2-xp5-xp4,yp2-yp5-yp4,cm2,ocom,
c     &                x154,y154,onec,onec,u2,-p2,
c     &                m8_1,n1*n7,n3*n6,n5*n4,n2)

      call fefefef(u1,-p1,x136,y136,onec,onec,
     &                -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &                x154,y154,onec,onec,xp7,yp7,cm2,d27,
     &                xe7,ye7,ga2m,ga2p,u2,-p2,
     &                m8_2,n1,n3*n6,n5*n4,n7,n2)

      call fefefef(u1,-p1,x136,y136,onec,onec,
     &                -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &                xe7,ye7,ga1m,ga1p,
     &                xp2-xp5-xp4,yp2-yp5-yp4,cm2,ocom,
     &                x154,y154,onec,onec,u2,-p2,
     &                m8_3,n1,n3*n6,n7,n5*n4,n2)

      call fefef(u1,-p1,x136g,y136g,onec,onec,
     &           xp2-xp5-xp4,yp2-yp5-yp4,cm2,ocom,
     &           x154,y154,onec,onec,u2,-p2,
     &           m8_4,n1,n3*n6*n7,n5*n4,n2)

      call fefef(u1,-p1,x136,y136,onec,onec,
     &          -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &           x154g,y154g,onec,onec,u2,-p2,
     &           m8_5,n1,n3*n6,n5*n4*n7,n2)

      call fefefef(u3,p3,xe7,ye7,ga3m,ga3p,
     &             xp7,yp7,cm3,d37,x312,y312,onec,onec,
     &            -xp6-xp5-xp4,-yp6-yp5-yp4,cm6,ocom,
     &             x354,y354,onec,onec,u6,p6,
     &             m9_1,n3,n7,n1*n2,n5*n4,n6)

      call fefefef(u3,p3,x312,y312,onec,onec,
     &             xp3-xp1-xp2,yp3-yp1-yp2,cm3,ocom,
     &             x354,y354,onec,onec,xp7,yp7,cm6,d67,
     &             xe7,ye7,ga6m,ga6p,u6,p6,
     &             m9_2,n3,n1*n2,n5*n4,n7,n6)

      call fefefef(u3,p3,x312,y312,onec,onec,
     &             xp3-xp1-xp2,yp3-yp1-yp2,cm3,ocom,
     &             xe7,ye7,ga3m,ga3p,
     &            -xp6-xp5-xp4,-yp6-yp5-yp4,cm6,ocom,
     &             x354,y354,onec,onec,u6,p6,
     &             m9_3,n3,n1*n2,n7,n5*n4,n6)

      call fefef(u3,p3,x312g,y312g,onec,onec,
     &          -xp6-xp5-xp4,-yp6-yp5-yp4,cm6,ocom,
     &           x354,y354,onec,onec,u6,p6,m9_4,n3,n1*n2*n7,n5*n4,n6)

      call fefef(u3,p3,x312,y312,onec,onec,
     &           xp3-xp1-xp2,yp3-yp1-yp2,cm3,ocom,
     &           x354g,y354g,onec,onec,u6,p6,m9_5,n3,n1*n2,n5*n4*n7,n6)

      call fefefef(u3,p3,xe7,ye7,ga3m,ga3p,
     &             xp7,yp7,cm3,d37,x354,y354,onec,onec,
     &            -xp6+xp1+xp2,-yp6+yp1+yp2,cm6,ocom,
     &             x312,y312,onec,onec,u6,p6,m10_1,n3,n7,n5*n4,n1*n2,n6)

      call fefefef(u3,p3,x354,y354,onec,onec,
     &             xp3+xp5+xp4,yp3+yp5+yp4,cm3,ocom,
     &             x312,y312,onec,onec,xp7,yp7,cm6,d67,
     &             xe7,ye7,ga6m,ga6p,u6,p6,m10_2,n3,n5*n4,n1*n2,n7,n6)

      call fefefef(u3,p3,x354,y354,onec,onec,
     &             xp3+xp5+xp4,yp3+yp5+yp4,cm3,ocom,
     &             xe7,ye7,ga3m,ga3p,
     &            -xp6+xp1+xp2,-yp6+yp1+yp2,cm6,ocom,
     &             x612,y612,onec,onec,u6,p6,m10_3,n3,n5*n4,n7,n1*n2,n6)

      call fefef(u3,p3,x354g,y354g,onec,onec,
     &          -xp6+xp1+xp2,-yp6+yp1+yp2,cm6,ocom,
     &           x612,y612,onec,onec,u6,p6,m10_4,n3,n5*n4*n7,n1*n2,n6)

      call fefef(u3,p3,x354,y354,onec,onec,
     &           xp3+xp5+xp4,yp3+yp5+yp4,cm3,ocom,
     &           x612g,y612g,onec,onec,u6,p6,m10_5,n3,n5*n4,n1*n2*n7,n6)


      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,
     &             xp7,yp7,cm5,d57,x512,y512,onec,onec,
     &            -xp4-xp3-xp6,-yp4-yp3-yp6,cm4,ocom,
     &             x536,y536,onec,onec,u4,p4,
     &             m11_1,n5,n7,n1*n2,n3*n6,n4)

      call fefefef(u5,p5,x512,y512,onec,onec,
     &             xp5-xp1-xp2,yp5-yp1-yp2,cm5,ocom,
     &             x536,y536,onec,onec,xp7,yp7,cm4,d47,
     &             xe7,ye7,ga4m,ga4p,u4,p4,
     &             m11_2,n5,n1*n2,n3*n6,n7,n4)

      call fefefef(u5,p5,x512,y512,onec,onec,
     &             xp5-xp1-xp2,yp5-yp1-yp2,cm5,ocom,
     &             xe7,ye7,ga5m,ga5p,
     &            -xp4-xp3-xp6,-yp4-yp3-yp6,cm4,ocom,
     &             x536,y536,onec,onec,u4,p4,
     &             m11_3,n5,n1*n2,n7,n3*n6,n4)

      call fefef(u5,p5,x512g,y512g,onec,onec,
     &          -xp4-xp3-xp6,-yp4-yp3-yp6,cm4,ocom,
     &           x536,y536,onec,onec,u4,p4,m11_4,n5,n1*n2*n7,n3*n6,n4)

      call fefef(u5,p5,x512,y512,onec,onec,
     &           xp5-xp1-xp2,yp5-yp1-yp2,cm5,ocom,
     &           x536g,y536g,onec,onec,u4,p4,m11_5,n5,n1*n2,n3*n6*n7,n4)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,
     &             xp7,yp7,cm5,d57,x536,y536,onec,onec,
     &            -xp4+xp1+xp2,-yp4+yp1+yp2,cm4,ocom,
     &             x412,y412,onec,onec,u4,p4,m12_1,n5,n7,n3*n6,n1*n2,n4)

      call fefefef(u5,p5,x536,y536,onec,onec,
     &             xp5+xp3+xp6,yp5+yp3+yp6,cm5,ocom,
     &             x512,y512,onec,onec,xp7,yp7,cm4,d47,
     &             xe7,ye7,ga4m,ga4p,u4,p4,m12_2,n5,n3*n6,n1*n2,n7,n4)

      call fefefef(u5,p5,x536,y536,onec,onec,
     &             xp5+xp3+xp6,yp5+yp3+yp6,cm5,ocom,
     &             xe7,ye7,ga5m,ga5p,
     &            -xp4+xp1+xp2,-yp4+yp1+yp2,cm4,ocom,
     &             x412,y412,onec,onec,u4,p4,m12_3,n5,n3*n6,n7,n1*n2,n4)

      call fefef(u5,p5,x536g,y536g,onec,onec,
     &          -xp4+xp1+xp2,-yp4+yp1+yp2,cm4,ocom,
     &           x412,y412,onec,onec,u4,p4,m12_4,n5,n3*n6*n7,n1*n2,n4)

      call fefef(u5,p5,x536,y536,onec,onec,
     &           xp5+xp3+xp6,yp5+yp3+yp6,cm5,ocom,
     &           x412g,y412g,onec,onec,u4,p4,m12_5,n5,n3*n6,n1*n2*n7,n4)


      else if (iproc > 15) then

      x152=ga1p*xa52+gz1p*xz52
      y152=ga1m*ya52+gz1m*yz52
      x152g=ga1p*xa52g+gz1p*xz52g
      y152g=ga1m*ya52g+gz1m*yz52g

      x352=ga3p*xa52+gz3p*xz52
      y352=ga3m*ya52+gz3m*yz52
      x352g=ga3p*xa52g+gz3p*xz52g
      y352g=ga3m*ya52g+gz3m*yz52g

      x452=ga4p*xa52+gz4p*xz52
      y452=ga4m*ya52+gz4m*yz52
      x452g=ga4p*xa52g+gz4p*xz52g
      y452g=ga4m*ya52g+gz4m*yz52g

      call fefefef(u3,p3,xe7,ye7,ga3m,ga3p,
     &             xp7,yp7,cm3,d37,x352,y352,onec,onec,
     &             xp1-xp4-xp6,yp1-yp4-yp6,cm3,ocom,
     &             xw16,yw16,wff,ocom,u4,p4,
     &             m19_1,n3,n7,n5*n2,n1*n6,n4)

      call fefefef(u3,p3,x352,y352,onec,onec,
     &             xp3+xp5-xp2,yp3+yp5-yp2,cm3,ocom,
     &             xw16,yw16,wff,ocom,xp7,yp7,cm4,d47,
     &             xe7,ye7,ga4m,ga4p,u4,p4,
     &             m19_2,n3,n5*n2,n1*n6,n7,n4)

      call fefefef(u3,p3,x352,y352,onec,onec,
     &             xp3+xp5-xp2,yp3+yp5-yp2,cm3,ocom,
     &             xe7,ye7,ga3m,ga3p,
     &            -xp4+xp1-xp6,-yp4+yp1-yp6,cm3,ocom,
     &             xw16,yw16,wff,ocom,u4,p4,
     &             m19_3,n3,n5*n2,n7,n1*n6,n4)

      call fefef(u3,p3,x352g,y352g,onec,onec,
     &          -xp4+xp1-xp6,-yp4+yp1-yp6,cm3,ocom,
     &           xw16,yw16,wff,ocom,u4,p4,m19_4,n3,n5*n2*n7,n1*n6,n4)

      call fefef(u3,p3,x352,y352,onec,onec,
     &           xp3+xp5-xp2,yp3+yp5-yp2,cm3,ocom,
     &           xw16g,yw16g,wff,ocom,u4,p4,m19_5,n3,n5*n2,n1*n6*n7,n4)

      call fefefef(u3,p3,xe7,ye7,ga3m,ga3p,
     &             xp7,yp7,cm3,d37,xw16,yw16,wff,ocom,
     &             xp2-xp4-xp5,yp2-yp4-yp5,cm4,ocom,
     &             x452,y452,onec,onec,u4,p4,
     &             m20_1,n3,n7,n1*n6,n5*n2,n4)

      call fefefef(u3,p3,xw16,yw16,wff,ocom,
     &             xp3+xp6-xp1,yp3+yp6-yp1,cm4,ocom,
     &             x452,y452,onec,onec,xp7,yp7,cm4,d47,
     &             xe7,ye7,ga4m,ga4p,u4,p4,
     &             m20_2,n3,n1*n6,n5*n2,n7,n4)

      call fefefef(u3,p3,xw16,yw16,wff,ocom,
     &             xp3+xp6-xp1,yp3+yp6-yp1,cm4,ocom,
     &             xe7,ye7,ga4m,ga4p,
     &            -xp4+xp2-xp5,-yp4+yp2-yp5,cm4,ocom,
     &             x452,y452,onec,onec,u4,p4,
     &             m20_3,n3,n1*n6,n7,n5*n2,n4)

      call fefef(u3,p3,xw16g,yw16g,wff,ocom,
     &          -xp4+xp2-xp5,-yp4+yp2-yp5,cm4,ocom,
     &           x452,y452,onec,onec,u4,p4,m20_4,n3,n1*n6*n7,n5*n2,n4)

      call fefef(u3,p3,xw16,yw16,wff,ocom,
     &           xp3+xp6-xp1,yp3+yp6-yp1,cm4,ocom,
     &           x452g,y452g,onec,onec,u4,p4,m20_5,n3,n1*n6,n5*n2*n7,n4)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &             xp7,yp7,cm1,d17,x152,y152,onec,onec,
     &            -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &             xw34,yw34,wff,ocom,u6,p6,
     &             m21_1,n1,n7,n5*n2,n3*n4,n6)
c      call fefef(u17,-p1+p7,x152,y152,onec,onec,
c     &            -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
c     &             xw34,yw34,wff,ocom,u6,p6,
c     &             m21_1,n1*n7,n5*n2,n3*n4,n6)

      call fefefef(u1,-p1,x152,y152,onec,onec,
     &            -xp1+xp5-xp2,-yp1+yp5-yp2,cm1,ocom,
     &             xe7,ye7,ga1m,ga1p,
     &            -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &             xw34,yw34,wff,ocom,u6,p6,
     &             m21_2,n1,n5*n2,n7,n3*n4,n6)

      call fefef(u1,-p1,x152g,y152g,onec,onec,
     &          -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &           xw34,yw34,wff,ocom,u6,p6,m21_3,n1,n5*n2*n7,n3*n4,n6)

      call fefef(u1,-p1,x152,y152,onec,onec,
     &          -xp1+xp5-xp2,-yp1+yp5-yp2,cm1,ocom,
     &           xw34g,yw34g,wff,ocom,u6,p6,m21_4,n1,n5*n2,n3*n4*n7,n6)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &             xp7,yp7,cm1,d17,xw34,yw34,wff,ocom,
     &            -xp6+xp2-xp5,-yp6+yp2-yp5,cm6,ocom,
     &             xz52,yz52,gz6m,gz6p,u6,p6,
     &             m22_1,n1,n7,n3*n4,n5*n2,n6)
c      call fefef(u17,-p1+p7,xw34,yw34,wff,ocom,
c     &            -xp6+xp2-xp5,-yp6+yp2-yp5,cm6,ocom,
c     &             xz52,yz52,gz6m,gz6p,u6,p6,
c     &             m22_1,n1*n7,n3*n4,n5*n2,n6)

      call fefef(u1,-p1,xw34g,yw34g,wff,ocom,
     &          -xp6+xp2-xp5,-yp6+yp2-yp5,cm6,ocom,
     &           xz52,yz52,gz6m,gz6p,u6,p6,m22_2,n1,n3*n4*n7,n5*n2,n6)

      call fefef(u1,-p1,xw34,yw34,wff,ocom,
     &          -xp1+xp3+xp4,-yp1+yp3+yp4,cm6,ocom,
     &           xz52g,yz52g,gz6m,gz6p,u6,p6,m22_3,n1,n3*n4,n5*n2*n7,n6)

      end if  ! iproc
      end if  ! iww


c The spin averaged squared matrix element:

      mat2=zero
      mat2ww=zero

      do i1=1,n1
      do i2=1,n2
      do i3=1,n3
      do i4=1,n4
      do i5=1,n5
      do i6=1,n6
      do i7=1,n7

      mat=m1_1(i1,i7,i3,i4,i5,i6,i2)
     &   +m1_2(i1,i3,i4,i5,i6,i7,i2)
     &   +m1_3(i1,i3,i4,i7,i5,i6,i2)
     &   +m1_4(i1,i3,i4,i5,i6,i7,i2)
     &   +m2_1(i5,i6,i3,i4,i1,i2,i7)
     &   +m2_2(i5,i6,i3,i4,i7,i1,i2)
     &   +m2_3(i5,i6,i7,i3,i4,i1,i2)
     &   -m2_4(i3,i4,i5,i6,i1,i2,i7) 

      if (iproc > 15) then

      mat=mat
     &   -m17_1(i1,i6,i3,i4,i5,i2,i7)
     &   -m17_2(i1,i6,i3,i4,i7,i5,i2)
     &   -m17_3(i1,i6,i7,i3,i4,i5,i2)
     &   -m18_1(i5,i7,i3,i4,i1,i6,i2)
     &   -m18_2(i5,i3,i4,i1,i6,i7,i2)
     &   -m18_3(i5,i3,i4,i7,i1,i6,i2)
     &   -m18_4(i5,i3,i4,i1,i6,i7,i2)
     &   +m17_4(i3,i4,i1,i6,i5,i2,i7)

      end if ! iproc

      matww=mat

      if (iww /= 1) then

      mat=mat
     &   +m3_1(i3,i1,i2,i7,i5,i6,i4)
     &   +m3_2(i3,i7,i1,i2,i5,i6,i4)
     &   +m3_3(i3,i1,i2,i5,i6,i7,i4)
     &   +m3_4(i3,i1,i2,i7,i5,i6,i4)
     &   +m3_5(i3,i1,i2,i5,i6,i7,i4)
     &   +m4_1(i3,i5,i6,i1,i2,i7,i4)
     &   +m4_2(i3,i7,i5,i6,i1,i2,i4)
     &   +m4_3(i3,i5,i6,i1,i2,i7,i4)
     &   +m4_4(i3,i5,i6,i7,i1,i2,i4)
     &   +m4_5(i3,i5,i6,i7,i1,i2,i4)
     &   +m5_1(i5,i1,i2,i7,i3,i4,i6)
     &   +m5_2(i5,i7,i1,i2,i3,i4,i6)
     &   +m5_3(i5,i1,i2,i7,i3,i4,i6)
     &   +m5_4(i5,i1,i2,i3,i4,i7,i6)
     &   +m5_5(i5,i1,i2,i3,i4,i7,i6)

      mat=mat
     &   +m6_1(i5,i3,i4,i1,i2,i7,i6)
     &   +m6_2(i5,i7,i3,i4,i1,i2,i6)
     &   +m6_3(i5,i3,i4,i7,i1,i2,i6)
     &   +m6_4(i5,i3,i4,i7,i1,i2,i6)
     &   +m6_5(i5,i3,i4,i1,i2,i7,i6)


      if (iproc > 13 .and. iproc < 16) then

      mat=mat
     &   -m7_1(i1,i7,i5,i4,i3,i6,i2)
     &   -m7_2(i1,i5,i4,i3,i6,i7,i2)
     &   -m7_3(i1,i5,i4,i7,i3,i6,i2)
     &   -m7_4(i1,i5,i4,i7,i3,i6,i2)
     &   -m7_5(i1,i5,i4,i3,i6,i7,i2)
     &   -m8_1(i1,i7,i3,i6,i5,i4,i2)
     &   -m8_2(i1,i3,i6,i5,i4,i7,i2)
     &   -m8_3(i1,i3,i6,i7,i5,i4,i2)
     &   -m8_4(i1,i3,i6,i7,i5,i4,i2)
     &   -m8_5(i1,i3,i6,i5,i4,i7,i2)
      mat=mat
     &   -m9_1(i3,i7,i1,i2,i5,i4,i6)
     &   -m9_2(i3,i1,i2,i5,i4,i7,i6)
     &   -m9_3(i3,i1,i2,i7,i5,i4,i6)
     &   -m9_4(i3,i1,i2,i7,i5,i4,i6)
     &   -m9_5(i3,i1,i2,i5,i4,i7,i6)
     &   -m10_1(i3,i7,i5,i4,i1,i2,i6)
     &   -m10_2(i3,i5,i4,i1,i2,i7,i6)
     &   -m10_3(i3,i5,i4,i7,i1,i2,i6)
     &   -m10_4(i3,i5,i4,i7,i1,i2,i6)
     &   -m10_5(i3,i5,i4,i1,i2,i7,i6)
      mat=mat
     &   -m11_1(i5,i7,i1,i2,i3,i6,i4)
     &   -m11_2(i5,i1,i2,i3,i6,i7,i4)
     &   -m11_3(i5,i1,i2,i7,i3,i6,i4)
     &   -m11_4(i5,i1,i2,i7,i3,i6,i4)
     &   -m11_5(i5,i1,i2,i3,i6,i7,i4)
     &   -m12_1(i5,i7,i3,i6,i1,i2,i4)
     &   -m12_2(i5,i3,i6,i1,i2,i7,i4)
     &   -m12_3(i5,i3,i6,i7,i1,i2,i4)
     &   -m12_4(i5,i3,i6,i7,i1,i2,i4)
     &   -m12_5(i5,i3,i6,i1,i2,i7,i4)

      if (ihiggs == 1) then
       mat=mat
     &    -hzz*(h54g(i5,i4,i7)*scc(ez12(:,i1,i2),ez36(:,i3,i6))
     &         +h54(i5,i4)*(scc(ez12g(:,i1,i2,i7),ez36(:,i3,i6))
     &                     +scc(ez12(:,i1,i2),ez36g(:,i3,i6,i7))))
      end if

      else if (iproc > 15) then

      mat=mat
     &   -m19_1(i3,i7,i5,i2,i1,i6,i4)
     &   -m19_2(i3,i5,i2,i1,i6,i7,i4)
     &   -m19_3(i3,i5,i2,i7,i1,i6,i4)
     &   -m19_4(i3,i5,i2,i7,i1,i6,i4)
     &   -m19_5(i3,i5,i2,i1,i6,i7,i4)
     &   -m20_1(i3,i7,i1,i6,i5,i2,i4)
     &   -m20_2(i3,i1,i6,i5,i2,i7,i4)
     &   -m20_3(i3,i1,i6,i7,i5,i2,i4)
     &   -m20_4(i3,i1,i6,i7,i5,i2,i4)
     &   -m20_5(i3,i1,i6,i5,i2,i7,i4)
     &   -m21_1(i1,i7,i5,i2,i3,i4,i6)
     &   -m21_2(i1,i5,i2,i7,i3,i4,i6)
     &   -m21_3(i1,i5,i2,i7,i3,i4,i6)
     &   -m21_4(i1,i5,i2,i3,i4,i7,i6)
     &   -m22_1(i1,i7,i3,i4,i5,i2,i6)
     &   -m22_2(i1,i3,i4,i7,i5,i2,i6)
     &   -m22_3(i1,i3,i4,i5,i2,i7,i6)

      end if   ! iproc
      end if   ! iww                               

      mat2=mat2+(abs(mat))**2
      mat2ww=mat2ww+(abs(matww))**2

      end do
      end do
      end do
      end do
      end do
      end do
      end do

      mat2=comf2*mat2
      mat2ww=comf2*mat2ww

      end 


