      subroutine eeffffgcc3(iproc,iww,p1,p2,p3,p4,p5,p6,p7,
     &                         ps1,ps2,ps3,ps4,ps5,ps6,ps7,mat2,mat2ww)
c----------------------------------------------------------------------c
c Returns the squared matrix element mat2 averaged over initial spins 
c            and summed over final spins and colours of
c
c  e+(p1) + e-(p2) --> ve(p3) + e+(p4) + e-(p5) + ve~(p6) + gamma(p7)
c
c for the charged current processes not containing virtual gluons
c
c Input: iproc -specifies the proces,
c        iww = 1 (the double resonance diagrams only)/ else (all the 
c              diagrams),
c        pi, i=1,...,7 - external particle momenta,
c        psi, i=1,...,7 - spherical components of the external 
c                               particle momenta,
c
c The frame is defined as that p1=(E1,0,0,p), p2=(E2,0,0,-p).
c Massive vector bosons are taken in the unitary gauge and massless 
c in the Feynman gauge
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 7 September, 2000;  modified 15 February, 2001; 2 November, 2001;
c                              20 June, 2003
c----------------------------------------------------------------------c

      use mathprms 
      use parsm
      use helproc
      use parproc
      use inistate

      implicit none
      integer, parameter :: dp=kind(1.d0)

      integer iproc,iww
      integer i1,i2,i3,i4,i5,i6,i7,i

      real(dp), dimension(0:3) ::  p1,p2,p3,p4,p5,p6,p7
      real(dp), dimension(0:4) ::  ps1,ps2,ps3,ps4,ps5,ps6,ps7
      real(dp) :: mat2,mat2ww,srr,e7(0:3,n7),ebeam=0.d0

      complex(dp) :: mat,mat0,matww,src

      real(dp) dbe,t52
      complex(dp) d17,d27,d37,d47,d57,d67

      complex(dp), dimension(2,2) :: xp3,xp4,xp5,xp6,xp7,
     &                              yp3,yp4,yp5,yp6,yp7

      complex(dp), dimension(4,n3) :: u3
      complex(dp), dimension(4,n4) :: u4
      complex(dp), dimension(4,n5) :: u5
      complex(dp), dimension(4,n6) :: u6

      complex(dp), dimension(2,2,n7) :: xe7,ye7

      complex(dp), dimension(0:3,n1,n2,n7) :: ea12g,ez12g
      complex(dp), dimension(2,2,n1,n2,n7) :: xa12g,xz12g,ya12g,yz12g,
     &                                       x412g,x512g,
     &                                       y412g,y512g
      complex(dp), dimension(0:3,n3,n6) :: ea36,ez36
      complex(dp), dimension(0:3,n3,n6,n7) :: ea36g,ez36g
      complex(dp), dimension(2,2,n3,n6) :: xz36,yz36
      complex(dp), dimension(2,2,n3,n6,n7) :: xz36g,yz36g
      complex(dp), dimension(0:3,n5,n4) :: ea54,ez54
      complex(dp), dimension(0:3,n5,n4,n7) :: ea54g,ez54g
      complex(dp), dimension(2,2,n5,n4) :: xa54,xz54,x154,
     &                                    ya54,yz54,y154
      complex(dp), dimension(2,2,n5,n4,n7) :: xa54g,xz54g,x154g,
     &                                       ya54g,yz54g,y154g
      complex(dp), dimension(0:3,n1,n4) :: ea14,ez14
      complex(dp), dimension(0:3,n1,n4,n7) :: ea14g,ez14g
      complex(dp), dimension(2,2,n1,n4) :: xa14,xz14,
     &                                    ya14,yz14
      complex(dp), dimension(2,2,n1,n4,n7) :: xa14g,xz14g,
     &                                       ya14g,yz14g
      complex(dp), dimension(0:3,n3,n4) :: ew34
      complex(dp), dimension(0:3,n3,n4,n7) :: ew34g
      complex(dp), dimension(2,2,n3,n4) :: xw34,yw34
      complex(dp), dimension(2,2,n3,n4,n7) :: xw34g,yw34g
      complex(dp), dimension(0:3,n3,n2) :: ew32
      complex(dp), dimension(0:3,n3,n2,n7) :: ew32g
      complex(dp), dimension(2,2,n3,n2) :: xw32,yw32
      complex(dp), dimension(2,2,n3,n2,n7) :: xw32g,yw32g
      complex(dp), dimension(0:3,n5,n6) :: ew56
      complex(dp), dimension(0:3,n5,n6,n7) :: ew56g
      complex(dp), dimension(2,2,n5,n6) :: xw56,yw56
      complex(dp), dimension(2,2,n5,n6,n7) :: xw56g,yw56g

      complex(dp), dimension(0:3,n1,n6) :: ew16
      complex(dp), dimension(2,2,n1,n6) :: xw16,yw16
      complex(dp), dimension(0:3,n5,n2) :: ea52,ez52
      complex(dp), dimension(2,2,n5,n2) :: xa52,ya52,xz52,yz52,
     &                                    x152,y152,x452,y452
      complex(dp), dimension(0:3,n1,n6,n7) :: ew16g
      complex(dp), dimension(2,2,n1,n6,n7) :: xw16g,yw16g
      complex(dp), dimension(0:3,n5,n2,n7) :: ea52g,ez52g
      complex(dp), dimension(2,2,n5,n2,n7) :: xa52g,ya52g,
     &                                       xz52g,yz52g,
     &                                       x152g,y152g,
     &                                       x452g,y452g
      complex(dp), dimension(2,2,n7) :: h00g

      complex(dp), dimension(n1,n7,n3,n4,n5,n6,n2) :: m1_1
      complex(dp), dimension(n1,n3,n4,n5,n6,n7,n2) :: m1_2
      complex(dp), dimension(n1,n3,n4,n7,n5,n6,n2) :: m1_3
      complex(dp), dimension(n1,n3,n4,n5,n6,n7,n2) :: m1_4
      complex(dp), dimension(n5,n6,n3,n4,n1,n2,n7) :: m2_1
      complex(dp), dimension(n5,n6,n3,n4,n7,n1,n2) :: m2_2
      complex(dp), dimension(n5,n6,n7,n3,n4,n1,n2) :: m2_3
      complex(dp), dimension(n3,n1,n2,n7,n5,n6,n4) :: m3_1
      complex(dp), dimension(n3,n1,n2,n5,n6,n7,n4) :: m3_2
      complex(dp), dimension(n3,n1,n2,n5,n6,n7,n4) :: m3_3
      complex(dp), dimension(n3,n5,n6,n1,n2,n7,n4) :: m4_1
      complex(dp), dimension(n3,n5,n6,n1,n2,n7,n4) :: m4_2
      complex(dp), dimension(n3,n5,n6,n7,n1,n2,n4) :: m4_3
      complex(dp), dimension(n3,n5,n6,n7,n1,n2,n4) :: m4_4
      complex(dp), dimension(n5,n1,n2,n7,n3,n4,n6) :: m5_1
      complex(dp), dimension(n5,n7,n1,n2,n3,n4,n6) :: m5_2
      complex(dp), dimension(n5,n1,n2,n7,n3,n4,n6) :: m5_3
      complex(dp), dimension(n5,n1,n2,n3,n4,n7,n6) :: m5_4
      complex(dp), dimension(n5,n3,n4,n1,n2,n7,n6) :: m6_1
      complex(dp), dimension(n5,n7,n3,n4,n1,n2,n6) :: m6_2
      complex(dp), dimension(n5,n3,n4,n7,n1,n2,n6) :: m6_3
      complex(dp), dimension(n3,n4,n5,n6,n1,n2,n7) :: m2_4
      complex(dp), dimension(n1,n7,n5,n4,n3,n6,n2) :: m7_1
      complex(dp), dimension(n1,n5,n4,n3,n6,n7,n2) :: m7_2
      complex(dp), dimension(n1,n5,n4,n7,n3,n6,n2) :: m7_3
      complex(dp), dimension(n1,n5,n4,n7,n3,n6,n2) :: m7_4
      complex(dp), dimension(n1,n5,n4,n3,n6,n7,n2) :: m7_5
      complex(dp), dimension(n1,n7,n3,n6,n5,n4,n2) :: m8_1
      complex(dp), dimension(n1,n3,n6,n5,n4,n7,n2) :: m8_2
      complex(dp), dimension(n1,n3,n6,n7,n5,n4,n2) :: m8_3
      complex(dp), dimension(n1,n3,n6,n7,n5,n4,n2) :: m8_4
      complex(dp), dimension(n1,n3,n6,n5,n4,n7,n2) :: m8_5
      complex(dp), dimension(n3,n1,n2,n7,n5,n4,n6) :: m9_1
      complex(dp), dimension(n3,n1,n2,n5,n4,n7,n6) :: m9_2
      complex(dp), dimension(n3,n5,n4,n7,n1,n2,n6) :: m10_1
      complex(dp), dimension(n3,n5,n4,n1,n2,n7,n6) :: m10_2
      complex(dp), dimension(n5,n7,n1,n2,n3,n6,n4) :: m11_1
      complex(dp), dimension(n5,n1,n2,n3,n6,n7,n4) :: m11_2
      complex(dp), dimension(n5,n1,n2,n7,n3,n6,n4) :: m11_3
      complex(dp), dimension(n5,n1,n2,n7,n3,n6,n4) :: m11_4
      complex(dp), dimension(n5,n1,n2,n3,n6,n7,n4) :: m11_5
      complex(dp), dimension(n5,n7,n3,n6,n1,n2,n4) :: m12_1
      complex(dp), dimension(n5,n3,n6,n1,n2,n7,n4) :: m12_2
      complex(dp), dimension(n5,n3,n6,n7,n1,n2,n4) :: m12_3
      complex(dp), dimension(n5,n3,n6,n7,n1,n2,n4) :: m12_4
      complex(dp), dimension(n5,n3,n6,n1,n2,n7,n4) :: m12_5

      complex(dp), dimension(n1,n6,n3,n4,n5,n2,n7) :: m17_1
      complex(dp), dimension(n1,n6,n3,n4,n7,n5,n2) :: m17_2
      complex(dp), dimension(n1,n6,n7,n3,n4,n5,n2) :: m17_3
      complex(dp), dimension(n3,n4,n1,n6,n5,n2,n7) :: m17_4
      complex(dp), dimension(n5,n7,n3,n4,n1,n6,n2) :: m18_1
      complex(dp), dimension(n5,n3,n4,n1,n6,n7,n2) :: m18_2
      complex(dp), dimension(n5,n3,n4,n7,n1,n6,n2) :: m18_3
      complex(dp), dimension(n5,n3,n4,n1,n6,n7,n2) :: m18_4
      complex(dp), dimension(n3,n5,n2,n1,n6,n7,n4) :: m19_1
      complex(dp), dimension(n3,n5,n2,n7,n1,n6,n4) :: m19_2
      complex(dp), dimension(n3,n5,n2,n1,n6,n7,n4) :: m19_3
      complex(dp), dimension(n3,n1,n6,n5,n2,n7,n4) :: m20_1
      complex(dp), dimension(n3,n1,n6,n7,n5,n2,n4) :: m20_2
      complex(dp), dimension(n3,n1,n6,n7,n5,n2,n4) :: m20_3
      complex(dp), dimension(n3,n1,n6,n5,n2,n7,n4) :: m20_4
      complex(dp), dimension(n1,n7,n5,n2,n3,n4,n6) :: m21_1
      complex(dp), dimension(n1,n5,n2,n7,n3,n4,n6) :: m21_2
      complex(dp), dimension(n1,n5,n2,n7,n3,n4,n6) :: m21_3
      complex(dp), dimension(n1,n5,n2,n3,n4,n7,n6) :: m21_4
      complex(dp), dimension(n1,n7,n3,n4,n5,n2,n6) :: m22_1
      complex(dp), dimension(n1,n3,n4,n7,n5,n2,n6) :: m22_2
      complex(dp), dimension(n1,n3,n4,n5,n2,n7,n6) :: m22_3

      complex(dp), dimension(n5,n6,n3,n2,n1,n4,n7) :: m17_1p
      complex(dp), dimension(n5,n6,n3,n2,n7,n1,n4) :: m17_2p
      complex(dp), dimension(n5,n6,n7,n3,n2,n1,n4) :: m17_3p
      complex(dp), dimension(n3,n2,n5,n6,n1,n4,n7) :: m17_4p
      complex(dp), dimension(n1,n7,n3,n2,n5,n6,n4) :: m18_1p
      complex(dp), dimension(n1,n3,n2,n5,n6,n7,n4) :: m18_2p
      complex(dp), dimension(n1,n3,n2,n7,n5,n6,n4) :: m18_3p
      complex(dp), dimension(n1,n3,n2,n5,n6,n7,n4) :: m18_4p
      complex(dp), dimension(n5,n7,n3,n2,n1,n4,n6) :: m19_1p
      complex(dp), dimension(n5,n3,n2,n7,n1,n4,n6) :: m19_2p
      complex(dp), dimension(n5,n3,n2,n1,n4,n7,n6) :: m19_3p
      complex(dp), dimension(n5,n7,n1,n4,n3,n2,n6) :: m20_1p
      complex(dp), dimension(n5,n1,n4,n7,n3,n2,n6) :: m20_2p
      complex(dp), dimension(n5,n1,n4,n7,n3,n2,n6) :: m20_3p
      complex(dp), dimension(n5,n1,n4,n3,n2,n7,n6) :: m20_4p
      complex(dp), dimension(n3,n5,n6,n7,n1,n4,n2) :: m21_1p
      complex(dp), dimension(n3,n5,n6,n1,n4,n7,n2) :: m21_2p
      complex(dp), dimension(n3,n5,n6,n7,n1,n4,n2) :: m21_3p
      complex(dp), dimension(n3,n5,n6,n1,n4,n7,n2) :: m21_4p
      complex(dp), dimension(n3,n1,n4,n5,n6,n7,n2) :: m22_1p
      complex(dp), dimension(n3,n1,n4,n7,n5,n6,n2) :: m22_2p
      complex(dp), dimension(n3,n1,n4,n5,n6,n7,n2) :: m22_3p

      complex(dp), dimension(n3,n5,n2,n7,n1,n4,n6) :: m23_1
      complex(dp), dimension(n3,n5,n2,n1,n4,n7,n6) :: m23_2
      complex(dp), dimension(n3,n1,n4,n7,n5,n2,n6) :: m24_1
      complex(dp), dimension(n3,n1,n4,n5,n2,n7,n6) :: m24_2
      complex(dp), dimension(n5,n7,n3,n6,n1,n4,n2) :: m25_1
      complex(dp), dimension(n5,n3,n6,n7,n1,n4,n2) :: m25_2
      complex(dp), dimension(n5,n3,n6,n1,n4,n7,n2) :: m25_3
      complex(dp), dimension(n5,n3,n6,n1,n4,n7,n2) :: m25_4
      complex(dp), dimension(n1,n6,n7,n3,n2,n5,n4) :: m26_1
      complex(dp), dimension(n1,n6,n3,n2,n7,n5,n4) :: m26_2
      complex(dp), dimension(n1,n6,n3,n2,n5,n4,n7) :: m26_3
      complex(dp), dimension(n3,n2,n1,n6,n5,n4,n7) :: m26_4
      complex(dp), dimension(n1,n7,n5,n4,n3,n2,n6) :: m27_1
      complex(dp), dimension(n1,n5,n4,n7,n3,n2,n6) :: m27_2
      complex(dp), dimension(n1,n5,n4,n7,n3,n2,n6) :: m27_3
      complex(dp), dimension(n1,n5,n4,n3,n2,n7,n6) :: m27_4
      complex(dp), dimension(n1,n7,n3,n2,n5,n4,n6) :: m28_1
      complex(dp), dimension(n1,n3,n2,n7,n5,n4,n6) :: m28_2
      complex(dp), dimension(n1,n3,n2,n5,n4,n7,n6) :: m28_3
      complex(dp), dimension(n5,n7,n3,n2,n1,n6,n4) :: m29_1
      complex(dp), dimension(n5,n3,n2,n1,n6,n7,n4) :: m29_2
      complex(dp), dimension(n5,n3,n2,n7,n1,n6,n4) :: m29_3
      complex(dp), dimension(n5,n3,n2,n1,n6,n7,n4) :: m29_4
      complex(dp), dimension(n5,n7,n1,n4,n3,n6,n2) :: m30_1
      complex(dp), dimension(n5,n1,n4,n7,n3,n6,n2) :: m30_2
      complex(dp), dimension(n5,n1,n4,n3,n6,n7,n2) :: m30_3
      complex(dp), dimension(n5,n1,n4,n7,n3,n6,n2) :: m30_4
      complex(dp), dimension(n1,n7,n3,n6,n5,n2,n4) :: m31_1
      complex(dp), dimension(n1,n3,n6,n7,n5,n2,n4) :: m31_2
      complex(dp), dimension(n1,n3,n6,n5,n2,n7,n4) :: m31_3
      complex(dp), dimension(n1,n3,n6,n5,n2,n7,n4) :: m31_4
      complex(dp), dimension(n3,n1,n6,n7,n5,n4,n2) :: m32_1
      complex(dp), dimension(n3,n1,n6,n5,n4,n7,n2) :: m32_2
      complex(dp), dimension(n3,n1,n6,n7,n5,n4,n2) :: m32_3
      complex(dp), dimension(n3,n1,n6,n5,n4,n7,n2) :: m32_4
      complex(dp), dimension(n1,n7,n5,n2,n3,n6,n4) :: m33_1
      complex(dp), dimension(n1,n5,n2,n7,n3,n6,n4) :: m33_2
      complex(dp), dimension(n1,n5,n2,n3,n6,n7,n4) :: m33_3
      complex(dp), dimension(n1,n5,n2,n7,n3,n6,n4) :: m33_4
      complex(dp), dimension(n3,n5,n4,n1,n6,n7,n2) :: m34_1
      complex(dp), dimension(n3,n5,n4,n7,n1,n6,n2) :: m34_2
      complex(dp), dimension(n3,n5,n4,n1,n6,n7,n2) :: m34_3

      save ebeam

      if (p1(0).ne.ebeam) then
       call inipart(p1,p2,ps1,ps2)
       ebeam=p1(0)
      end if

c External particle momenta in the spinor representation:

      call spinr(p3,xp3,yp3)
      call spinr(p4,xp4,yp4)
      call spinr(p5,xp5,yp5)
      call spinr(p6,xp6,yp6)
      call spinr(p7,xp7,yp7)

c Spinors of the external fermions:

      call spinornew(p3,ps3,m3,1,1,n3,u3)
      call spinornew(p4,ps4,m4,-1,0,n4,u4)
      call spinornew(p5,ps5,m5,1,1,n5,u5)
      call spinornew(p6,ps6,m6,-1,0,n6,u6)

c Photon polarization vectors:

      call recpol(p7,ps7,zero,e7)

      do i7=1,n7
ckk>
c Test gauge invariance:

c      e7(:,i7)=p7
ckk<
        call spinr(e7(:,i7),xe7(:,:,i7),ye7(:,:,i7))
      end do

c Fermion denominators:

c      dbe=1.d0-sqrt(1.d0-(m1/p1(0))**2)
      dbe=(m1/p1(0))**2/2.d0

      d17=cmplx(-2.d0*p1(0)*p7(0)*(1.d0-ps7(1)+dbe*ps7(1)),zero,dp)
c     &                             +(gam1/2.d0)**2,m1*gam1,dp)
      d27=cmplx(-2.d0*p2(0)*p7(0)*(1.d0+ps7(1)-dbe*ps7(1)),zero,dp)
c     &                             +(gam2/2.d0)**2,m2*gam2,dp)
      d37=cmplx(srr(p3+p7,p3+p7),zero,dp)-cm3**2
      d47=cmplx(srr(p4+p7,p4+p7),zero,dp)-cm4**2
      d57=cmplx(srr(p5+p7,p5+p7),zero,dp)-cm5**2
      d67=cmplx(srr(p6+p7,p6+p7),zero,dp)-cm6**2

c Building blocks of the diagrams:

c Vector boson couplings sandwiched by the external spinors:

      call fvf(u3,n3,p3,m3,wff,ocom,zero,mw2,u4,n4,p4,m4,
     &                                                 ew34,xw34,yw34)
      call fvf(u5,n5,p5,m5,wff,ocom,zero,mw2,u6,n6,p6,m6,
     &                                                 ew56,xw56,yw56)

      t52=-2.d0*ps2(0)*ps5(0)*(1.d0+ps5(1)
     &    +(m2*(p2(0)-p5(0))/(p2(0)*p5(0)))**2/2.d0)

       call fvf(u1,n1,-p1,m1,wff,ocom,zero,mw2,u6,n6,p6,m6,
     &                                                 ew16,xw16,yw16)
       call fvf(u5,n5,p5,m5,ga5m,ga5p,t52,ma2,u2,n2,-p2,m2,
     &                                                 ea52,xa52,ya52)
       call fvf(u5,n5,p5,m5,gz5m,gz5p,t52,mz2,u2,n2,-p2,m2,
     &                                                 ez52,xz52,yz52)

      if (iww /= 1) then
       call fvf(u3,n3,p3,m3,gz3m,gz3p,zero,mz2,u6,n6,p6,m6,
     &                                                 ez36,xz36,yz36)
       call fvf(u5,n5,p5,m5,ga5m,ga5p,zero,ma2,u4,n4,p4,m4,
     &                                                 ea54,xa54,ya54)
       call fvf(u5,n5,p5,m5,gz5m,gz5p,zero,mz2,u4,n4,p4,m4,
     &                                                 ez54,xz54,yz54)
      end if ! iww

      call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &           u6,n6,p6,xp6,yp6,cm6,ga6m,d67,wff,ocom,mw2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,-gww,ew56,ew56g,xw56g,yw56g,
     &           0,hff(5),mh2,h00g)

      call ffvgnew(u3,n3,p3,xp3,yp3,cm3,ga3m,d37,
     &           u4,n4,p4,xp4,yp4,cm4,ga4m,d47,wff,ocom,mw2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,gww,ew34,ew34g,xw34g,yw34g,
     &           0,hff(3),mh2,h00g)

      call ffvgnew(u1,n1,-p1,-xp1,-yp1,cm1,ga1m,d17,
     &          u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,ga1m,ga1p,ma2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea12,ea12g,xa12g,ya12g,
     &          0,hff(1),mh2,h00g)

      call ffvgnew(u1,n1,-p1,-xp1,-yp1,cm1,ga1m,d17,
     &          u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,gz1m,gz1p,mz2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea12,ez12g,xz12g,yz12g,
     &          0,hff(1),mh2,h00g)

       call ffvgnew(u1,n1,-p1,-xp1,-yp1,cm1,ga1m,d17,
     &           u6,n6,p6,xp6,yp6,cm6,ga6m,d67,wff,ocom,mw2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,-gww,ew16,ew16g,xw16g,yw16g,
     &           0,hff(6),mh2,h00g)

      call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &          u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,ga5m,ga5p,ma2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea52,ea52g,xa52g,ya52g,
     &          0,hff(5),mh2,h00g)

      call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &          u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,gz5m,gz5p,mz2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ez52,ez52g,xz52g,yz52g,
     &          0,hff(5),mh2,h00g)

      if (iww /= 1) then

      call ffvgnew(u3,n3,p3,xp3,yp3,cm3,ga3m,d37,
     &           u6,n6,p6,xp6,yp6,cm6,ga6m,d67,gz3m,gz3p,mz2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ez36,ez36g,xz36g,yz36g,
     &           0,hff(3),mh2,h00g)

      call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &           u4,n4,p4,xp4,yp4,cm4,ga4m,d47,ga5m,ga5p,ma2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea54,ea54g,xa54g,ya54g,
     &           0,hff(5),mh2,h00g)

       call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &           u4,n4,p4,xp4,yp4,cm4,ga4m,d47,gz5m,gz5p,mz2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ez54,ez54g,xz54g,yz54g,
     &           0,hff(5),mh2,h00g)

      end if ! iww

c Amplitudes:

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &                xp7,yp7,cm1,d17,xw34,yw34,wff,ocom,
     &                xp2-xp5-xp6,yp2-yp5-yp6,ocom,ocom,
     &                xw56,yw56,wff,ocom,u2,-p2,
     &                m1_1,n1,n7,n3*n4,n5*n6,n2)

      call fefefef(u1,-p1,xw34,yw34,wff,ocom,
     &               -xp1+xp3+xp4,-yp1+yp3+yp4,ocom,ocom,
     &                xw56,yw56,wff,ocom,xp7,yp7,cm2,d27,
     &                xe7,ye7,ga2m,ga2p,u2,-p2,
     &                m1_2,n1,n3*n4,n5*n6,n7,n2)

      call fefef(u1,-p1,xw34g,yw34g,wff,ocom,
     &              xp2-xp5-xp6,yp2-yp5-yp6,ocom,ocom,
     &              xw56,yw56,wff,ocom,u2,-p2,
     &              m1_3,n1,n3*n4*n7,n5*n6,n2)

      call fefef(u1,-p1,xw34,yw34,wff,ocom,
     &             -xp1+xp3+xp4,-yp1+yp3+yp4,ocom,ocom,
     &              xw56g,yw56g,wff,ocom,u2,-p2,
     &              m1_4,n1,n3*n4,n5*n6*n7,n2)


      call eee(p5+p6,ew56,-p3-p4,ew34,
     &         p3+p4+p5+p6,gww*ea12g+zww*ez12g,
     &                                      m2_1,n5*n6,n3*n4,n1*n2*n7)

      call eee(p5+p6,ew56,-p3-p4-p7,ew34g,
     &      p1+p2,gww*ea12+zww*ez12,m2_2,n5*n6,n3*n4*n7,n1*n2)

      call eee(p5+p6+p7,ew56g,-p3-p4,ew34,
     &      p1+p2,gww*ea12+zww*ez12,m2_3,n5*n6*n7,n3*n4,n1*n2)

      call eeee(ew34,ew56,ggww*ea12+gzww*ez12,cmplx(e7,zero,dp),
     &                                      m2_4,n3*n4,n5*n6,n1*n2,n7)

      call eee(-p1+p6,ew16,-p3-p4,ew34,
     &         p2-p5-p7,gww*ea52g+zww*ez52g,m17_1,n1*n6,n3*n4,n5*n2*n7)

      call eee(-p1+p6,ew16,-p3-p4-p7,ew34g,
     &          p2-p5,gww*ea52+zww*ez52,m17_2,n1*n6,n3*n4*n7,n5*n2)

      call eee(-p1+p6+p7,ew16g,-p3-p4,ew34,
     &          p2-p5,gww*ea52+zww*ez52,m17_3,n1*n6*n7,n3*n4,n5*n2)

      call eeee(ew34,ew16,ggww*ea52+gzww*ez52,cmplx(e7,zero,dp),
     &                                      m17_4,n3*n4,n1*n6,n5*n2,n7)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,
     &                xp7,yp7,cm5,d57,xw34,yw34,wff,ocom,
     &                xp2+xp1-xp6,yp2+yp1-yp6,ocom,ocom,
     &                xw16,yw16,wff,ocom,u2,-p2,
     &                m18_1,n5,n7,n3*n4,n1*n6,n2)

      call fefefef(u5,p5,xw34,yw34,wff,ocom,
     &                xp5+xp3+xp4,yp5+yp3+yp4,ocom,ocom,
     &                xw16,yw16,wff,ocom,xp7,yp7,cm2,d27,
     &                xe7,ye7,ga2m,ga2p,u2,-p2,
     &                m18_2,n5,n3*n4,n1*n6,n7,n2)

      call fefef(u5,p5,xw34g,yw34g,wff,ocom,
     &              xp2+xp1-xp6,yp2+yp1-yp6,ocom,ocom,
     &              xw16,yw16,wff,ocom,u2,-p2,
     &              m18_3,n5,n3*n4*n7,n1*n6,n2)

      call fefef(u5,p5,xw34,yw34,wff,ocom,
     &              xp5+xp3+xp4,yp5+yp3+yp4,ocom,ocom,
     &              xw16g,yw16g,wff,ocom,u2,-p2,
     &              m18_4,n5,n3*n4,n1*n6*n7,n2)

      call fvf(u3,n3,p3,m3,wff,ocom,zero,mw2,u2,n2,-p2,m2,
     &                                                 ew32,xw32,yw32)
c      call ffvg(u3,n3,p3,ga3m,d37,u2,n2,-p2,ga2m,d27,wff,ocom,mw2,
c     &          e7,xe7,ye7,n7,p7,xp7,yp7,gww,ew32,ew32g,xw32g,yw32g)

      call ffvgnew(u3,n3,p3,xp3,yp3,cm3,ga3m,d37,
     &           u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,wff,ocom,mw2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,gww,ew32,ew32g,xw32g,yw32g,
     &           0,hff(3),mh2,h00g)

      call fvf(u1,n1,-p1,m1,ga1m,ga1p,zero,ma2,u4,n4,p4,m4,
     &                                                 ea14,xa14,ya14)
      call fvf(u1,n1,-p1,m1,gz1m,gz1p,zero,mz2,u4,n4,p4,m4,
     &                                                 ez14,xz14,yz14)

c      call ffvg(u1,n1,-p1,ga1m,d17,u4,n4,p4,ga4m,d47,
c     &          ga1m,ga1p,ma2,e7,xe7,ye7,n7,p7,xp7,yp7,zero,ea14,
c     &          ea14g,xa14g,ya14g)

c      call ffvg(u1,n1,-p1,ga1m,d17,u4,n4,p4,ga4m,d47,
c     &          gz1m,gz1p,mz2,e7,xe7,ye7,n7,p7,xp7,yp7,zero,ez14,
c     &          ez14g,xz14g,yz14g)

      call ffvgnew(u1,n1,-p1,-xp1,-yp1,cm1,ga1m,d17,
     &          u4,n4,p4,xp4,yp4,cm4,ga4m,d47,ga4m,ga4p,ma2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea14,ea14g,xa14g,ya14g,
     &          0,hff(1),mh2,h00g)

      call ffvgnew(u1,n1,-p1,-xp1,-yp1,cm1,ga1m,d17,
     &          u4,n4,p4,xp4,yp4,cm4,ga4m,d47,gz4m,gz4p,mz2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ez14,ez14g,xz14g,yz14g,
     &          0,hff(1),mh2,h00g)


      call eee(p5+p6,ew56,p2-p3,ew32,
     &         p1-p4-p7,gww*ea14g+zww*ez14g,m17_1p,n5*n6,n3*n2,n1*n4*n7)

      call eee(p5+p6,ew56,p2-p3-p7,ew32g,
     &         p1-p4,gww*ea14+zww*ez14,m17_2p,n5*n6,n3*n2*n7,n1*n4)

      call eee(p5+p6+p7,ew56g,p2-p3,ew32,
     &          p1-p4,gww*ea14+zww*ez14,m17_3p,n5*n6*n7,n3*n2,n1*n4)

      call eeee(ew32,ew56,ggww*ea14+gzww*ez14,cmplx(e7,zero,dp),
     &                                      m17_4p,n3*n2,n5*n6,n1*n4,n7)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &                xp7,yp7,cm1,d17,xw32,yw32,wff,ocom,
     &               -xp4-xp5-xp6,-yp4-yp5-yp6,ocom,ocom,
     &                xw56,yw56,wff,ocom,u4,p4,
     &                m18_1p,n1,n7,n3*n2,n5*n6,n4)

      call fefefef(u1,-p1,xw32,yw32,wff,ocom,
     &               -xp1-xp2+xp3,-yp1-yp2+yp3,ocom,ocom,
     &                xw56,yw56,wff,ocom,xp7,yp7,cm4,d47,
     &                xe7,ye7,ga4m,ga4p,u4,p4,
     &                m18_2p,n1,n3*n2,n5*n6,n7,n4)

      call fefef(u1,-p1,xw32g,yw32g,wff,ocom,
     &             -xp4-xp5-xp6,-yp4-yp5-yp6,ocom,ocom,
     &              xw56,yw56,wff,ocom,u4,p4,
     &              m18_3p,n1,n3*n2*n7,n5*n6,n4)

      call fefef(u1,-p1,xw32,yw32,wff,ocom,
     &             -xp1-xp2+xp3,-yp1-yp2+yp3,ocom,ocom,
     &              xw56g,yw56g,wff,ocom,u4,p4,
     &              m18_4p,n1,n3*n2,n5*n6*n7,n4)


      call eee(-p1+p6+p7,ew16g,p2-p3,ew32,-p4-p5,
     &                   gww*ea54+zww*ez54,m26_1,n1*n6*n7,n3*n2,n5*n4)

      call eee(-p1+p6,ew16,p2-p3-p7,ew32g,-p4-p5,
     &                   gww*ea54+zww*ez54,m26_2,n1*n6,n3*n2*n7,n5*n4)

      call eee(-p1+p6,ew16,p2-p3,ew32,-p4-p5-p7,
     &              gww*ea54g+zww*ez54g,m26_3,n1*n6,n3*n2,n5*n4*n7)

      call eeee(ew32,ew16,ggww*ea54+gzww*ez54,cmplx(e7,zero,dp),
     &                                    m26_4,n3*n2,n1*n6,n5*n4,n7)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,xp7,yp7,cm5,d57,
     &             xw32,yw32,wff,ocom,
     &             xp1-xp4-xp6,yp1-yp4-yp6,ocom,ocom,
     &             xw16,yw16,wff,ocom,u4,p4,m29_1,n5,n7,n3*n2,n1*n6,n4)

      call fefefef(u5,p5,xw32,yw32,wff,ocom,
     &            -xp2+xp3+xp5,-yp2+yp3+yp5,ocom,ocom,
     &             xw16,yw16,wff,ocom,
     &             xp7,yp7,cm4,d47,xe7,ye7,ga4m,ga4p,u4,p4,
     &             m29_2,n5,n3*n2,n1*n6,n7,n4)

      call fefef(u5,p5,xw32g,yw32g,wff,ocom,
     &           xp1-xp4-xp6,yp1-yp4-yp6,ocom,ocom,
     &           xw16,yw16,wff,ocom,u4,p4,m29_3,n5,n3*n2*n7,n1*n6,n4)

      call fefef(u5,p5,xw32,yw32,wff,ocom,
     &          -xp2+xp3+xp5,-yp2+yp3+yp5,ocom,ocom,
     &           xw16g,yw16g,wff,ocom,u4,p4,m29_4,n5,n3*n2,n1*n6*n7,n4)


      if (iww /= 1) then

      x412g=ga4p*xa12g+gz4p*xz12g
      y412g=ga4m*ya12g+gz4m*yz12g
      x512g=ga5p*xa12g+gz5p*xz12g
      y512g=ga5m*ya12g+gz5m*yz12g

      call fefef(u3,p3,xz12g,yz12g,gz3m,gz3p,
     &              -xp4-xp5-xp6,-yp4-yp5-yp6,cm3,ocom,
     &              xw56,yw56,wff,ocom,u4,p4,
     &              m3_1,n3,n1*n2*n7,n5*n6,n4)

      call fefefef(u3,p3,xz12,yz12,gz3m,gz3p,
     &               -xp1-xp2+xp3,-yp1-yp2+yp3,cm3,ocom,
     &                xw56,yw56,wff,ocom,
     &                xp7,yp7,cm4,d47,xe7,ye7,ga4m,ga4p,u4,p4,
     &                m3_2,n3,n1*n2,n5*n6,n7,n4)

      call fefef(u3,p3,xz12,yz12,gz3m,gz3p,
     &             -xp1-xp2+xp3,-yp1-yp2+yp3,cm3,ocom,
     &              xw56g,yw56g,wff,ocom,u4,p4,
     &              m3_3,n3,n1*n2,n5*n6*n7,n4)

      call fefef(u3,p3,xw56,yw56,wff,ocom,
     &              xp3+xp5+xp6,yp3+yp5+yp6,cm4,ocom,
     &              x412g,y412g,onec,onec,
     &              u4,p4,m4_1,n3,n5*n6,n1*n2*n7,n4)

      call fefefef(u3,p3,xw56,yw56,wff,ocom,
     &                xp3+xp5+xp6,yp3+yp5+yp6,cm4,ocom,
     &                x412,y412,onec,onec,xp7,yp7,cm4,d47,
     &                xe7,ye7,ga4m,ga4p,u4,p4,
     &                m4_2,n3,n5*n6,n1*n2,n7,n4)

      call fefefef(u3,p3,xw56,yw56,wff,ocom,
     &                xp3+xp5+xp6,yp3+yp5+yp6,cm4,ocom,
     &       xe7,ye7,ga4m,ga4p,xp1+xp2-xp4,yp1+yp2-yp4,cm4,ocom,
     &                x412,y412,onec,onec,u4,p4,
     &                m4_3,n3,n5*n6,n7,n1*n2,n4)

      call fefef(u3,p3,xw56g,yw56g,wff,ocom,
     &              xp1+xp2-xp4,yp1+yp2-yp4,cm4,ocom,
     &              x412,y412,onec,onec,u4,p4,
     &              m4_4,n3,n5*n6*n7,n1*n2,n4)

      call fefef(u5,p5,x512g,y512g,onec,onec,
     &             -xp6-xp3-xp4,-yp6-yp3-yp4,cm5,ocom,
     &              xw34,yw34,wff,ocom,u6,p6,
     &              m5_1,n5,n1*n2*n7,n3*n4,n6)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,
     &                xp7,yp7,cm5,d57,
     &                x512,y512,onec,onec,
     &               -xp6-xp3-xp4,-yp6-yp3-yp4,cm5,ocom,
     &                xw34,yw34,wff,ocom,u6,p6,
     &                m5_2,n5,n7,n1*n2,n3*n4,n6)

      call fefefef(u5,p5,x512,y512,onec,onec,
     &               -xp1-xp2+xp5,-yp1-yp2+yp5,cm5,ocom,
     &                xe7,ye7,ga5m,ga5p,
     &               -xp6-xp3-xp4,-yp6-yp3-yp4,cm5,ocom,
     &                xw34,yw34,wff,ocom,u6,p6,
     &                m5_3,n5,n1*n2,n7,n3*n4,n6)

      call fefef(u5,p5,x512,y512,onec,onec,
     &             -xp1-xp2+xp5,-yp1-yp2+yp5,cm5,ocom,
     &              xw34g,yw34g,wff,ocom,u6,p6,
     &              m5_4,n5,n1*n2,n3*n4*n7,n6)

      call fefef(u5,p5,xw34,yw34,wff,ocom,
     &           xp5+xp3+xp4,yp5+yp3+yp4,cm6,ocom,
     &           xz12g,yz12g,gz6m,gz6p,u6,p6,m6_1,n5,n3*n4,n1*n2*n7,n6)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,xp7,yp7,cm5,d57,
     &                xw34,yw34,wff,ocom,
     &                xp1+xp2-xp6,yp1+yp2-yp6,cm6,ocom,
     &                xz12,yz12,gz6m,gz6p,u6,p6,
     &                m6_2,n5,n7,n3*n4,n1*n2,n6)

      call fefef(u5,p5,xw34g,yw34g,wff,ocom,
     &              xp1+xp2-xp6,yp1+yp2-yp6,cm6,ocom,
     &              xz12,yz12,gz6m,gz6p,u6,p6,
     &              m6_3,n5,n3*n4*n7,n1*n2,n6)


      x154=ga1p*xa54+gz1p*xz54
      y154=ga1m*ya54+gz1m*yz54
      x154g=ga1p*xa54g+gz1p*xz54g
      y154g=ga1m*ya54g+gz1m*yz54g

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &                xp7,yp7,cm1,d17,x154,y154,onec,onec,
     &                xp2-xp3-xp6,yp2-yp3-yp6,cm2,ocom,
     &                xz36,yz36,gz1m,gz1p,u2,-p2,
     &                m7_1,n1,n7,n5*n4,n3*n6,n2)

      call fefefef(u1,-p1,x154,y154,onec,onec,
     &                -xp1+xp5+xp4,-yp1+yp5+yp4,cm1,ocom,
     &                xz36,yz36,gz1m,gz1p,xp7,yp7,cm2,d27,
     &                xe7,ye7,ga2m,ga2p,u2,-p2,
     &                m7_2,n1,n5*n4,n3*n6,n7,n2)

      call fefefef(u1,-p1,x154,y154,onec,onec,
     &                -xp1+xp5+xp4,-yp1+yp5+yp4,cm1,ocom,
     &                xe7,ye7,ga1m,ga1p,
     &                xp2-xp3-xp6,yp2-yp3-yp6,cm2,ocom,
     &                xz36,yz36,gz1m,gz1p,u2,-p2,
     &                m7_3,n1,n5*n4,n7,n3*n6,n2)

      call fefef(u1,-p1,x154g,y154g,onec,onec,
     &           xp2-xp3-xp6,yp2-yp3-yp6,cm2,ocom,
     &           xz36,yz36,gz1m,gz1p,u2,-p2,
     &           m7_4,n1,n5*n4*n7,n3*n6,n2)

      call fefef(u1,-p1,x154,y154,onec,onec,
     &          -xp1+xp5+xp4,-yp1+yp5+yp4,cm1,ocom,
     &           xz36g,yz36g,gz1m,gz1p,u2,-p2,
     &           m7_5,n1,n5*n4,n3*n6*n7,n2)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &                xp7,yp7,cm1,d17,xz36,yz36,gz1m,gz1p,
     &                xp2-xp5-xp4,yp2-yp5-yp4,cm2,ocom,
     &                x154,y154,onec,onec,u2,-p2,
     &                m8_1,n1,n7,n3*n6,n5*n4,n2)

      call fefefef(u1,-p1,xz36,yz36,gz1m,gz1p,
     &                -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &                x154,y154,onec,onec,xp7,yp7,cm2,d27,
     &                xe7,ye7,ga2m,ga2p,u2,-p2,
     &                m8_2,n1,n3*n6,n5*n4,n7,n2)

      call fefefef(u1,-p1,xz36,yz36,gz1m,gz1p,
     &                -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &                xe7,ye7,ga1m,ga1p,
     &                xp2-xp5-xp4,yp2-yp5-yp4,cm2,ocom,
     &                x154,y154,onec,onec,u2,-p2,
     &                m8_3,n1,n3*n6,n7,n5*n4,n2)

      call fefef(u1,-p1,xz36g,yz36g,gz1m,gz1p,
     &           xp2-xp5-xp4,yp2-yp5-yp4,cm2,ocom,
     &           x154,y154,onec,onec,u2,-p2,
     &           m8_4,n1,n3*n6*n7,n5*n4,n2)

      call fefef(u1,-p1,xz36,yz36,gz1m,gz1p,
     &          -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &           x154g,y154g,onec,onec,u2,-p2,
     &           m8_5,n1,n3*n6,n5*n4*n7,n2)

      call fefef(u3,p3,xz12g,yz12g,gz3m,gz3p,
     &          -xp6-xp5-xp4,-yp6-yp5-yp4,cm6,ocom,
     &           xz54,yz54,gz3m,gz3p,u6,p6,m9_1,n3,n1*n2*n7,n5*n4,n6)

      call fefef(u3,p3,xz12,yz12,gz3m,gz3p,
     &           xp3-xp1-xp2,yp3-yp1-yp2,cm3,ocom,
     &           xz54g,yz54g,gz3m,gz3p,u6,p6,m9_2,n3,n1*n2,n5*n4*n7,n6)

      call fefef(u3,p3,xz54g,yz54g,gz3m,gz3p,
     &          -xp6+xp1+xp2,-yp6+yp1+yp2,cm6,ocom,
     &           xz12,yz12,gz6m,gz6p,u6,p6,m10_1,n3,n5*n4*n7,n1*n2,n6)

      call fefef(u3,p3,xz54,yz54,gz3m,gz3p,
     &           xp3+xp5+xp4,yp3+yp5+yp4,cm3,ocom,
     &           xz12g,yz12g,gz6m,gz6p,u6,p6,m10_2,n3,n5*n4,n1*n2*n7,n6)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,
     &             xp7,yp7,cm5,d57,x512,y512,onec,onec,
     &            -xp4-xp3-xp6,-yp4-yp3-yp6,cm4,ocom,
     &             xz36,yz36,gz5m,gz5p,u4,p4,
     &             m11_1,n5,n7,n1*n2,n3*n6,n4)

      call fefefef(u5,p5,x512,y512,onec,onec,
     &             xp5-xp1-xp2,yp5-yp1-yp2,cm5,ocom,
     &             xz36,yz36,gz5m,gz5p,xp7,yp7,cm4,d47,
     &             xe7,ye7,ga4m,ga4p,u4,p4,
     &             m11_2,n5,n1*n2,n3*n6,n7,n4)

      call fefefef(u5,p5,x512,y512,onec,onec,
     &             xp5-xp1-xp2,yp5-yp1-yp2,cm5,ocom,
     &             xe7,ye7,ga5m,ga5p,
     &            -xp4-xp3-xp6,-yp4-yp3-yp6,cm4,ocom,
     &             xz36,yz36,gz5m,gz5p,u4,p4,
     &             m11_3,n5,n1*n2,n7,n3*n6,n4)

      call fefef(u5,p5,x512g,y512g,onec,onec,
     &          -xp4-xp3-xp6,-yp4-yp3-yp6,cm4,ocom,
     &           xz36,yz36,gz5m,gz5p,u4,p4,m11_4,n5,n1*n2*n7,n3*n6,n4)

      call fefef(u5,p5,x512,y512,onec,onec,
     &           xp5-xp1-xp2,yp5-yp1-yp2,cm5,ocom,
     &           xz36g,yz36g,gz5m,gz5p,u4,p4,m11_5,n5,n1*n2,n3*n6*n7,n4)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,
     &             xp7,yp7,cm5,d57,xz36,yz36,gz5m,gz5p,
     &            -xp4+xp1+xp2,-yp4+yp1+yp2,cm4,ocom,
     &             x412,y412,onec,onec,u4,p4,m12_1,n5,n7,n3*n6,n1*n2,n4)

      call fefefef(u5,p5,xz36,yz36,gz5m,gz5p,
     &             xp5+xp3+xp6,yp5+yp3+yp6,cm5,ocom,
     &             x512,y512,onec,onec,xp7,yp7,cm4,d47,
     &             xe7,ye7,ga4m,ga4p,u4,p4,m12_2,n5,n3*n6,n1*n2,n7,n4)

      call fefefef(u5,p5,xz36,yz36,gz5m,gz5p,
     &             xp5+xp3+xp6,yp5+yp3+yp6,cm5,ocom,
     &             xe7,ye7,ga5m,ga5p,
     &            -xp4+xp1+xp2,-yp4+yp1+yp2,cm4,ocom,
     &             x412,y412,onec,onec,u4,p4,m12_3,n5,n3*n6,n7,n1*n2,n4)

      call fefef(u5,p5,xz36g,yz36g,gz5m,gz5p,
     &          -xp4+xp1+xp2,-yp4+yp1+yp2,cm4,ocom,
     &           x412,y412,onec,onec,u4,p4,m12_4,n5,n3*n6*n7,n1*n2,n4)

      call fefef(u5,p5,xz36,yz36,gz5m,gz5p,
     &           xp5+xp3+xp6,yp5+yp3+yp6,cm5,ocom,
     &           x412g,y412g,onec,onec,u4,p4,m12_5,n5,n3*n6,n1*n2*n7,n4)


      x152=ga1p*xa52+gz1p*xz52
      y152=ga1m*ya52+gz1m*yz52
      x152g=ga1p*xa52g+gz1p*xz52g
      y152g=ga1m*ya52g+gz1m*yz52g

      x452=ga4p*xa52+gz4p*xz52
      y452=ga4m*ya52+gz4m*yz52
      x452g=ga4p*xa52g+gz4p*xz52g
      y452g=ga4m*ya52g+gz4m*yz52g

      call fefefef(u3,p3,xz52,yz52,gz3m,gz3p,
     &             xp3+xp5-xp2,yp3+yp5-yp2,cm3,ocom,
     &             xw16,yw16,wff,ocom,xp7,yp7,cm4,d47,
     &             xe7,ye7,ga4m,ga4p,u4,p4,
     &             m19_1,n3,n5*n2,n1*n6,n7,n4)

      call fefef(u3,p3,xz52g,yz52g,gz3m,gz3p,
     &          -xp4+xp1-xp6,-yp4+yp1-yp6,cm3,ocom,
     &           xw16,yw16,wff,ocom,u4,p4,m19_2,n3,n5*n2*n7,n1*n6,n4)

      call fefef(u3,p3,xz52,yz52,gz3m,gz3p,
     &           xp3+xp5-xp2,yp3+yp5-yp2,cm3,ocom,
     &           xw16g,yw16g,wff,ocom,u4,p4,m19_3,n3,n5*n2,n1*n6*n7,n4)

      call fefefef(u3,p3,xw16,yw16,wff,ocom,
     &             xp3+xp6-xp1,yp3+yp6-yp1,cm4,ocom,
     &             x452,y452,onec,onec,xp7,yp7,cm4,d47,
     &             xe7,ye7,ga4m,ga4p,u4,p4,
     &             m20_1,n3,n1*n6,n5*n2,n7,n4)

      call fefefef(u3,p3,xw16,yw16,wff,ocom,
     &             xp3+xp6-xp1,yp3+yp6-yp1,cm4,ocom,
     &             xe7,ye7,ga4m,ga4p,
     &            -xp4+xp2-xp5,-yp4+yp2-yp5,cm4,ocom,
     &             x452,y452,onec,onec,u4,p4,
     &             m20_2,n3,n1*n6,n7,n5*n2,n4)

      call fefef(u3,p3,xw16g,yw16g,wff,ocom,
     &          -xp4+xp2-xp5,-yp4+yp2-yp5,cm4,ocom,
     &           x452,y452,onec,onec,u4,p4,m20_3,n3,n1*n6*n7,n5*n2,n4)

      call fefef(u3,p3,xw16,yw16,wff,ocom,
     &           xp3+xp6-xp1,yp3+yp6-yp1,cm4,ocom,
     &           x452g,y452g,onec,onec,u4,p4,m20_4,n3,n1*n6,n5*n2*n7,n4)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &             xp7,yp7,cm1,d17,x152,y152,onec,onec,
     &            -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &             xw34,yw34,wff,ocom,u6,p6,
     &             m21_1,n1,n7,n5*n2,n3*n4,n6)

      call fefefef(u1,-p1,x152,y152,onec,onec,
     &            -xp1+xp5-xp2,-yp1+yp5-yp2,cm1,ocom,
     &             xe7,ye7,ga1m,ga1p,
     &            -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &             xw34,yw34,wff,ocom,u6,p6,
     &             m21_2,n1,n5*n2,n7,n3*n4,n6)

      call fefef(u1,-p1,x152g,y152g,onec,onec,
     &          -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &           xw34,yw34,wff,ocom,u6,p6,m21_3,n1,n5*n2*n7,n3*n4,n6)

      call fefef(u1,-p1,x152,y152,onec,onec,
     &          -xp1+xp5-xp2,-yp1+yp5-yp2,cm1,ocom,
     &           xw34g,yw34g,wff,ocom,u6,p6,m21_4,n1,n5*n2,n3*n4*n7,n6)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,
     &             xp7,yp7,cm1,d17,xw34,yw34,wff,ocom,
     &            -xp6+xp2-xp5,-yp6+yp2-yp5,cm6,ocom,
     &             xz52,yz52,gz6m,gz6p,u6,p6,
     &             m22_1,n1,n7,n3*n4,n5*n2,n6)

      call fefef(u1,-p1,xw34g,yw34g,wff,ocom,
     &          -xp6+xp2-xp5,-yp6+yp2-yp5,cm6,ocom,
     &           xz52,yz52,gz6m,gz6p,u6,p6,m22_2,n1,n3*n4*n7,n5*n2,n6)

      call fefef(u1,-p1,xw34,yw34,wff,ocom,
     &          -xp1+xp3+xp4,-yp1+yp3+yp4,cm6,ocom,
     &           xz52g,yz52g,gz6m,gz6p,u6,p6,m22_3,n1,n3*n4,n5*n2*n7,n6)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,xp7,yp7,cm5,d57,
     &             xw32,yw32,wff,ocom,
     &             xp1-xp4-xp6,yp1-yp4-yp6,ocom,ocom,
     &             xz14,yz14,gz6m,gz6p,
     &             u6,p6,m19_1p,n5,n7,n3*n2,n1*n4,n6)

      call fefef(u5,p5,xw32g,yw32g,wff,ocom,
     &           xp1-xp4-xp6,yp1-yp4-yp6,ocom,ocom,
     &           xz14,yz14,gz6m,gz6p,
     &           u6,p6,m19_2p,n5,n3*n2*n7,n1*n4,n6)

      call fefef(u5,p5,xw32,yw32,wff,ocom,
     &          -xp2+xp3+xp5,-yp2+yp3+yp5,ocom,ocom,
     &           xz14g,yz14g,gz6m,gz6p,
     &           u6,p6,m19_3p,n5,n3*n2,n1*n4*n7,n6)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,xp7,yp7,cm5,d57,
     &             ga5p*xa14+gz5p*xz14,ga5m*ya14+gz5m*yz14,onec,onec,
     &             xp2-xp3-xp6,yp2-yp3-yp6,cm5,ocom,
     &             xw32,yw32,wff,ocom,u6,p6,
     &             m20_1p,n5,n7,n1*n4,n3*n2,n6)

      call fefefef(u5,p5,
     &             ga5p*xa14+gz5p*xz14,ga5m*ya14+gz5m*yz14,onec,onec,
     &            -xp1+xp4+xp5,-yp1+yp4+yp5,cm5,ocom,
     &             xe7,ye7,ga5m,ga5p,
     &             xp2-xp3-xp6,yp2-yp3-yp6,cm5,ocom,
     &             xw32,yw32,wff,ocom,u6,p6,
     &             m20_2p,n5,n1*n4,n7,n3*n2,n6)

      call fefef(u5,p5,
     &           ga5p*xa14g+gz5p*xz14g,ga5m*ya14g+gz5m*yz14g,onec,onec,
     &           xp2-xp3-xp6,yp2-yp3-yp6,cm5,ocom,
     &           xw32,yw32,wff,ocom,u6,p6,
     &           m20_3p,n5,n1*n4*n7,n3*n2,n6)

      call fefef(u5,p5,ga5p*xa14+gz5p*xz14,ga5m*ya14+gz5m*yz14,
     &           onec,onec,-xp1+xp4+xp5,-yp1+yp4+yp5,cm5,ocom,
     &           xw32g,yw32g,wff,ocom,u6,p6,
     &           m20_4p,n5,n1*n4,n3*n2*n7,n6)

      call fefefef(u3,p3,xw56,yw56,wff,ocom,
     &             xp3+xp5+xp6,yp3+yp5+yp6,cm2,ocom,
     &             xe7,ye7,ga5m,ga5p,
     &             xp1+xp2-xp4,yp1+yp2-yp4,cm2,ocom,
     &             ga2p*xa14+gz2p*xz14,ga2m*ya14+gz2m*yz14,onec,onec,
     &             u2,-p2,m21_1p,n3,n5*n6,n7,n1*n4,n2)

      call fefefef(u3,p3,xw56,yw56,wff,ocom,
     &             xp3+xp5+xp6,yp3+yp5+yp6,cm2,ocom,
     &             ga2p*xa14+gz2p*xz14,ga2m*ya14+gz2m*yz14,onec,onec,
     &             xp7,yp7,cm2,d27,xe7,ye7,ga2m,ga2p,u2,-p2,
     &             m21_2p,n3,n5*n6,n1*n4,n7,n2)

      call fefef(u3,p3,xw56g,yw56g,wff,ocom,
     &           xp1+xp2-xp4,yp1+yp2-yp4,cm2,ocom,
     &           ga2p*xa14+gz2p*xz14,ga2m*ya14+gz2m*yz14,onec,onec,
     &           u2,-p2,m21_3p,n3,n5*n6*n7,n1*n4,n2)

      call fefef(u3,p3,xw56,yw56,wff,ocom,
     &           xp3+xp5+xp6,yp3+yp5+yp6,cm2,ocom,
     &           ga2p*xa14g+gz2p*xz14g,ga2m*ya14g+gz2m*yz14g,onec,onec,
     &           u2,-p2,m21_4p,n3,n5*n6,n1*n4*n7,n2)

      call fefefef(u3,p3,xz14,yz14,gz3m,gz3p,
     &            -xp1+xp3+xp4,-yp1+yp3+yp4,ocom,ocom,
     &             xw56,yw56,wff,ocom,
     &             xp7,yp7,cm2,d27,xe7,ye7,ga2m,ga2p,u2,-p2,
     &             m22_1p,n3,n1*n4,n5*n6,n7,n2)

      call fefef(u3,p3,xz14g,yz14g,gz3m,gz3p,
     &           xp2-xp5-xp6,yp2-yp5-yp6,ocom,ocom,
     &           xw56,yw56,wff,ocom,u2,-p2,
     &           m22_2p,n3,n1*n4*n7,n5*n6,n2)

      call fefef(u3,p3,xz14,yz14,gz3m,gz3p,
     &          -xp1+xp3+xp4,-yp1+yp3+yp4,ocom,ocom,
     &           xw56g,yw56g,wff,ocom,u2,-p2,
     &           m22_3p,n3,n1*n4,n5*n6*n7,n2)

      call fefef(u3,p3,xz52g,yz52g,gz3m,gz3p,
     &           xp1-xp4-xp6,yp1-yp4-yp6,ocom,ocom,
     &           xz14,yz14,gz6m,gz6p,u6,p6,m23_1,n3,n5*n2*n7,n1*n4,n6)

      call fefef(u3,p3,xz52,yz52,gz3m,gz3p,
     &          -xp2+xp3+xp5,-yp2+yp3+yp5,ocom,ocom,
     &           xz14g,yz14g,gz6m,gz6p,u6,p6,m23_2,n3,n5*n2,n1*n4*n7,n6)

      call fefef(u3,p3,xz14g,yz14g,gz3m,gz3p,
     &           xp2-xp5-xp6,yp2-yp5-yp6,ocom,ocom,
     &           xz52,yz52,gz6m,gz6p,u6,p6,m24_1,n3,n1*n4*n7,n5*n2,n6)

      call fefef(u3,p3,xz14,yz14,gz3m,gz3p,
     &          -xp1+xp3+xp4,-yp1+yp3+yp4,ocom,ocom,
     &           xz52g,yz52g,gz6m,gz6p,u6,p6,m24_2,n3,n1*n4,n5*n2*n7,n6)


      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,xp7,yp7,cm5,d57,
     &             xz36,yz36,gz5m,gz5p,
     &             xp1+xp2-xp4,yp1+yp2-yp4,cm5,ocom,
     &             ga2p*xa14+gz2p*xz14,ga2m*ya14+gz2m*yz14,onec,onec,
     &                               u2,-p2,m25_1,n5,n7,n3*n6,n1*n4,n2)

      call fefefef(u5,p5,xz36,yz36,gz5m,gz5p,
     &             xp3+xp5+xp6,yp3+yp5+yp6,cm5,ocom,
     &             xe7,ye7,ga5m,ga5p,
     &             xp1+xp2-xp4,yp1+yp2-yp4,cm5,ocom,
     &             ga2p*xa14+gz2p*xz14,ga2m*ya14+gz2m*yz14,onec,onec,
     &                               u2,-p2,m25_2,n5,n3*n6,n7,n1*n4,n2)

      call fefefef(u5,p5,xz36,yz36,gz5m,gz5p,
     &             xp3+xp5+xp6,yp3+yp5+yp6,cm5,ocom,
     &             ga2p*xa14+gz2p*xz14,ga2m*ya14+gz2m*yz14,onec,onec,
     &             xp7,yp7,cm2,d27,xe7,ye7,ga2m,ga2p,
     &                               u2,-p2,m25_3,n5,n3*n6,n1*n4,n7,n2)

      call fefef(u5,p5,xz36,yz36,gz5m,gz5p,
     &           xp3+xp5+xp6,yp3+yp5+yp6,cm5,ocom,
     &           ga2p*xa14g+gz2p*xz14g,ga2m*ya14g+gz2m*yz14g,onec,onec,
     &                               u2,-p2,m25_4,n5,n3*n6,n1*n4*n7,n2)


      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,xp7,yp7,cm1,d17,
     &             ga1p*xa54+gz1p*xz54,ga1m*ya54+gz1m*yz54,onec,onec,
     &             xp2-xp3-xp6,yp2-yp3-yp6,cm1,ocom,
     &             xw32,yw32,wff,ocom,u6,p6,m27_1,n1,n7,n5*n4,n3*n2,n6)

      call fefefef(u1,-p1,ga1p*xa54+gz1p*xz54,
     &                                ga1m*ya54+gz1m*yz54,onec,onec,
     &            -xp1+xp4+xp5,-yp1+yp4+yp5,cm1,ocom,
     &             xe7,ye7,ga1m,ga1p,
     &             xp2-xp3-xp6,yp2-yp3-yp6,cm1,ocom,
     &             xw32,yw32,wff,ocom,u6,p6,m27_2,n1,n5*n4,n7,n3*n2,n6)

      call fefef(u1,-p1,ga1p*xa54g+gz1p*xz54g,
     &                                ga1m*ya54g+gz1m*yz54g,onec,onec,
     &           xp2-xp3-xp6,yp2-yp3-yp6,cm1,ocom,
     &           xw32,yw32,wff,ocom,u6,p6,m27_3,n1,n5*n4*n7,n3*n2,n6)

      call fefef(u1,-p1,ga1p*xa54+gz1p*xz54,
     &                                ga1m*ya54+gz1m*yz54,onec,onec,
     &          -xp1+xp4+xp5,-yp1+yp4+yp5,cm1,ocom,
     &           xw32g,yw32g,wff,ocom,u6,p6,m27_4,n1,n5*n4,n3*n2*n7,n6)


      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,xp7,yp7,cm1,d17,
     &             xw32,yw32,wff,ocom,
     &            -xp4-xp5-xp6,-yp4-yp5-yp6,ocom,ocom,
     &             xz54,yz54,gz6m,gz6p,u6,p6,m28_1,n1,n7,n3*n2,n5*n4,n6)

      call fefef(u1,-p1,xw32g,yw32g,wff,ocom,
     &          -xp4-xp5-xp6,-yp4-yp5-yp6,ocom,ocom,
     &           xz54,yz54,gz6m,gz6p,u6,p6,m28_2,n1,n3*n2*n7,n5*n4,n6)

      call fefef(u1,-p1,xw32,yw32,wff,ocom,
     &          -xp1-xp2+xp3,-yp1-yp2+yp3,ocom,ocom,
     &           xz54g,yz54g,gz6m,gz6p,u6,p6,m28_3,n1,n3*n2,n5*n4*n7,n6)


      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,xp7,yp7,cm5,d57,
     &             ga5p*xa14+gz5p*xz14,ga5m*ya14+gz5m*yz14,onec,onec,
     &             xp2-xp3-xp6,yp2-yp3-yp6,cm5,ocom,
     &             xz36,yz36,gz2m,gz2p,u2,-p2,
     &             m30_1,n5,n7,n1*n4,n3*n6,n2)

      call fefefef(u5,p5,ga5p*xa14+gz5p*xz14,
     &                                ga5m*ya14+gz5m*yz14,onec,onec,
     &            -xp1+xp4+xp5,-yp1+yp4+yp5,cm5,ocom,
     &             xe7,ye7,ga5m,ga5p,
     &             xp2-xp3-xp6,yp2-yp3-yp6,cm5,ocom,
     &             xz36,yz36,gz2m,gz2p,u2,-p2,
     &             m30_2,n5,n1*n4,n7,n3*n6,n2)

      call fefefef(u5,p5,ga5p*xa14+gz5p*xz14,
     &                                ga5m*ya14+gz5m*yz14,onec,onec,
     &            -xp1+xp4+xp5,-yp1+yp4+yp5,cm5,ocom,
     &             xz36,yz36,gz2m,gz2p,
     &             xp7,yp7,cm2,d27,xe7,ye7,ga2m,ga2p,
     &             u2,-p2,m30_3,n5,n1*n4,n3*n6,n7,n2)

      call fefef(u5,p5,ga5p*xa14g+gz5p*xz14g,
     &                                ga5m*ya14g+gz5m*yz14g,onec,onec,
     &           xp2-xp3-xp6,yp2-yp3-yp6,cm5,ocom,
     &           xz36,yz36,gz2m,gz2p,u2,-p2,m30_4,n5,n1*n4*n7,n3*n6,n2)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,xp7,yp7,cm1,d17,
     &             xz36,yz36,gz1m,gz1p,
     &             xp2-xp4-xp5,yp2-yp4-yp5,cm1,ocom,
     &             ga4p*xa52+gz4p*xz52,ga4m*ya52+gz4m*yz52,onec,onec,
     &             u4,p4,m31_1,n1,n7,n3*n6,n5*n2,n4)

      call fefefef(u1,-p1,xz36,yz36,gz1m,gz1p,
     &            -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &             xe7,ye7,ga1m,ga1p,
     &             xp2-xp4-xp5,yp2-yp4-yp5,cm1,ocom,
     &             ga4p*xa52+gz4p*xz52,ga4m*ya52+gz4m*yz52,onec,onec,
     &             u4,p4,m31_2,n1,n3*n6,n7,n5*n2,n4)

      call fefefef(u1,-p1,xz36,yz36,gz1m,gz1p,
     &            -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &             ga4p*xa52+gz4p*xz52,ga4m*ya52+gz4m*yz52,onec,onec,
     &             xp7,yp7,cm4,d47,xe7,ye7,ga4m,ga4p,
     &             u4,p4,m31_3,n1,n3*n6,n5*n2,n7,n4)

      call fefef(u1,-p1,xz36,yz36,gz1m,gz1p,
     &          -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &           ga4p*xa52g+gz4p*xz52g,ga4m*ya52g+gz4m*yz52g,onec,onec,
     &           u4,p4,m31_4,n1,n3*n6,n5*n2*n7,n4)

      call fefefef(u3,p3,xw16,yw16,wff,ocom,
     &            -xp1+xp3+xp6,-yp1+yp3+yp6,cm2,ocom,
     &             xe7,ye7,ga2m,ga2p,
     &             xp2-xp4-xp5,yp2-yp4-yp5,cm2,ocom,
     &             ga2p*xa54+gz2p*xz54,ga2m*ya54+gz2m*yz54,onec,onec,
     &                               u2,-p2,m32_1,n3,n1*n6,n7,n5*n4,n2)

      call fefefef(u3,p3,xw16,yw16,wff,ocom,
     &            -xp1+xp3+xp6,-yp1+yp3+yp6,cm2,ocom,
     &             ga2p*xa54+gz2p*xz54,ga2m*ya54+gz2m*yz54,onec,onec,
     &             xp7,yp7,cm2,d27,xe7,ye7,ga2m,ga2p,
     &                               u2,-p2,m32_2,n3,n1*n6,n5*n4,n7,n2)

      call fefef(u3,p3,xw16g,yw16g,wff,ocom,
     &           xp2-xp4-xp5,yp2-yp4-yp5,cm2,ocom,
     &           ga2p*xa54+gz2p*xz54,ga2m*ya54+gz2m*yz54,onec,onec,
     &                               u2,-p2,m32_3,n3,n1*n6*n7,n5*n4,n2)

      call fefef(u3,p3,xw16,yw16,wff,ocom,
     &          -xp1+xp3+xp6,-yp1+yp3+yp6,cm2,ocom,
     &           ga2p*xa54g+gz2p*xz54g,ga2m*ya54g+gz2m*yz54g,onec,onec,
     &                               u2,-p2,m32_4,n3,n1*n6,n5*n4*n7,n2)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,xp7,yp7,cm1,d17,
     &             ga1p*xa52+gz1p*xz52,ga1m*ya52+gz1m*yz52,onec,onec,
     &            -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &             xz36,yz36,gz4m,gz4p,u4,p4,m33_1,n1,n7,n5*n2,n3*n6,n4)

      call fefefef(u1,-p1,ga1p*xa52+gz1p*xz52,
     &                                ga1m*ya52+gz1m*yz52,onec,onec,
     &            -xp1-xp2+xp5,-yp1-yp2+yp5,cm1,ocom,
     &             xe7,ye7,ga1m,ga1p,
     &            -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &             xz36,yz36,gz4m,gz4p,u4,p4,m33_2,n1,n5*n2,n7,n3*n6,n4)

      call fefefef(u1,-p1,ga1p*xa52+gz1p*xz52,
     &                                ga1m*ya52+gz1m*yz52,onec,onec,
     &            -xp1-xp2+xp5,-yp1-yp2+yp5,cm1,ocom,
     &             xz36,yz36,gz4m,gz4p,
     &             xp7,yp7,cm4,d47,xe7,ye7,ga4m,ga4p,
     &             u4,p4,m33_3,n1,n5*n2,n3*n6,n7,n4)

      call fefef(u1,-p1,ga1p*xa52g+gz1p*xz52g,
     &                                ga1m*ya52g+gz1m*yz52g,onec,onec,
     &          -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &           xz36,yz36,gz4m,gz4p,u4,p4,m33_4,n1,n5*n2*n7,n3*n6,n4)

      call fefefef(u3,p3,xz54,yz54,gz3m,gz3p,
     &             xp3+xp4+xp5,yp3+yp4+yp5,ocom,ocom,
     &             xw16,yw16,wff,ocom,
     &             xp7,yp7,cm2,d27,xe7,ye7,ga2m,ga2p,
     &             u2,-p2,m34_1,n3,n5*n4,n1*n6,n7,n2)

      call fefef(u3,p3,xz54g,yz54g,gz3m,gz3p,
     &           xp1+xp2-xp6,yp1+yp2-yp6,ocom,ocom,
     &           xw16,yw16,wff,ocom,u2,-p2,m34_2,n3,n5*n4*n7,n1*n6,n2)

      call fefef(u3,p3,xz54,yz54,gz3m,gz3p,
     &           xp3+xp4+xp5,yp3+yp4+yp5,ocom,ocom,
     &           xw16g,yw16g,wff,ocom,u2,-p2,m34_3,n3,n5*n4,n1*n6*n7,n2)

      end if  ! iww


c The spin averaged squared matrix element:

      mat2=zero
      mat2ww=zero

      do i1=1,n1
      do i2=1,n2
      do i3=1,n3
      do i4=1,n4
      do i5=1,n5
      do i6=1,n6
      do i7=1,n7

      mat=m1_1(i1,i7,i3,i4,i5,i6,i2)
     &   +m1_2(i1,i3,i4,i5,i6,i7,i2)
     &   +m1_3(i1,i3,i4,i7,i5,i6,i2)
     &   +m1_4(i1,i3,i4,i5,i6,i7,i2)
     &   +m2_1(i5,i6,i3,i4,i1,i2,i7)
     &   +m2_2(i5,i6,i3,i4,i7,i1,i2)
     &   +m2_3(i5,i6,i7,i3,i4,i1,i2)
     &   -m2_4(i3,i4,i5,i6,i1,i2,i7) 

      mat=mat
     &   -m17_1(i1,i6,i3,i4,i5,i2,i7)
     &   -m17_2(i1,i6,i3,i4,i7,i5,i2)
     &   -m17_3(i1,i6,i7,i3,i4,i5,i2)
     &   +m17_4(i3,i4,i1,i6,i5,i2,i7)
     &   -m18_1(i5,i7,i3,i4,i1,i6,i2)
     &   -m18_2(i5,i3,i4,i1,i6,i7,i2)
     &   -m18_3(i5,i3,i4,i7,i1,i6,i2)
     &   -m18_4(i5,i3,i4,i1,i6,i7,i2)
     &   -m17_1p(i5,i6,i3,i2,i1,i4,i7)
     &   -m17_2p(i5,i6,i3,i2,i7,i1,i4)
     &   -m17_3p(i5,i6,i7,i3,i2,i1,i4)
     &   +m17_4p(i3,i2,i5,i6,i1,i4,i7)
     &   -m18_1p(i1,i7,i3,i2,i5,i6,i4)
     &   -m18_2p(i1,i3,i2,i5,i6,i7,i4)
     &   -m18_3p(i1,i3,i2,i7,i5,i6,i4)
     &   -m18_4p(i1,i3,i2,i5,i6,i7,i4)

      mat=mat
     &   +m26_1(i1,i6,i7,i3,i2,i5,i4)
     &   +m26_2(i1,i6,i3,i2,i7,i5,i4)
     &   +m26_3(i1,i6,i3,i2,i5,i4,i7)
     &   -m26_4(i3,i2,i1,i6,i5,i4,i7)
     &   +m29_1(i5,i7,i3,i2,i1,i6,i4)
     &   +m29_2(i5,i3,i2,i1,i6,i7,i4)
     &   +m29_3(i5,i3,i2,i7,i1,i6,i4)
     &   +m29_4(i5,i3,i2,i1,i6,i7,i4)


      matww=mat

      if (iww /= 1) then

      mat=mat
     &   +m3_1(i3,i1,i2,i7,i5,i6,i4)
     &   +m3_2(i3,i1,i2,i5,i6,i7,i4)
     &   +m3_3(i3,i1,i2,i5,i6,i7,i4)
     &   +m4_1(i3,i5,i6,i1,i2,i7,i4)
     &   +m4_2(i3,i5,i6,i1,i2,i7,i4)
     &   +m4_3(i3,i5,i6,i7,i1,i2,i4)
     &   +m4_4(i3,i5,i6,i7,i1,i2,i4)
     &   +m5_1(i5,i1,i2,i7,i3,i4,i6)
     &   +m5_2(i5,i7,i1,i2,i3,i4,i6)
     &   +m5_3(i5,i1,i2,i7,i3,i4,i6)
     &   +m5_4(i5,i1,i2,i3,i4,i7,i6)
      mat=mat
     &   +m6_1(i5,i3,i4,i1,i2,i7,i6)
     &   +m6_2(i5,i7,i3,i4,i1,i2,i6)
     &   +m6_3(i5,i3,i4,i7,i1,i2,i6)

      mat=mat
     &   -m7_1(i1,i7,i5,i4,i3,i6,i2)
     &   -m7_2(i1,i5,i4,i3,i6,i7,i2)
     &   -m7_3(i1,i5,i4,i7,i3,i6,i2)
     &   -m7_4(i1,i5,i4,i7,i3,i6,i2)
     &   -m7_5(i1,i5,i4,i3,i6,i7,i2)
     &   -m8_1(i1,i7,i3,i6,i5,i4,i2)
     &   -m8_2(i1,i3,i6,i5,i4,i7,i2)
     &   -m8_3(i1,i3,i6,i7,i5,i4,i2)
     &   -m8_4(i1,i3,i6,i7,i5,i4,i2)
     &   -m8_5(i1,i3,i6,i5,i4,i7,i2)
      mat=mat
     &   -m9_1(i3,i1,i2,i7,i5,i4,i6)
     &   -m9_2(i3,i1,i2,i5,i4,i7,i6)
     &   -m10_1(i3,i5,i4,i7,i1,i2,i6)
     &   -m10_2(i3,i5,i4,i1,i2,i7,i6)
      mat=mat
     &   -m11_1(i5,i7,i1,i2,i3,i6,i4)
     &   -m11_2(i5,i1,i2,i3,i6,i7,i4)
     &   -m11_3(i5,i1,i2,i7,i3,i6,i4)
     &   -m11_4(i5,i1,i2,i7,i3,i6,i4)
     &   -m11_5(i5,i1,i2,i3,i6,i7,i4)
     &   -m12_1(i5,i7,i3,i6,i1,i2,i4)
     &   -m12_2(i5,i3,i6,i1,i2,i7,i4)
     &   -m12_3(i5,i3,i6,i7,i1,i2,i4)
     &   -m12_4(i5,i3,i6,i7,i1,i2,i4)
     &   -m12_5(i5,i3,i6,i1,i2,i7,i4)


      mat=mat
     &   -m19_1(i3,i5,i2,i1,i6,i7,i4)
     &   -m19_2(i3,i5,i2,i7,i1,i6,i4)
     &   -m19_3(i3,i5,i2,i1,i6,i7,i4)
     &   -m20_1(i3,i1,i6,i5,i2,i7,i4)
     &   -m20_2(i3,i1,i6,i7,i5,i2,i4)
     &   -m20_3(i3,i1,i6,i7,i5,i2,i4)
     &   -m20_4(i3,i1,i6,i5,i2,i7,i4)
     &   -m21_1(i1,i7,i5,i2,i3,i4,i6)
     &   -m21_2(i1,i5,i2,i7,i3,i4,i6)
     &   -m21_3(i1,i5,i2,i7,i3,i4,i6)
     &   -m21_4(i1,i5,i2,i3,i4,i7,i6)
     &   -m22_1(i1,i7,i3,i4,i5,i2,i6)
     &   -m22_2(i1,i3,i4,i7,i5,i2,i6)
     &   -m22_3(i1,i3,i4,i5,i2,i7,i6)

      mat=mat
     &   -m19_1p(i5,i7,i3,i2,i1,i4,i6)
     &   -m19_2p(i5,i3,i2,i7,i1,i4,i6)
     &   -m19_3p(i5,i3,i2,i1,i4,i7,i6)
     &   -m20_1p(i5,i7,i1,i4,i3,i2,i6)
     &   -m20_2p(i5,i1,i4,i7,i3,i2,i6)
     &   -m20_3p(i5,i1,i4,i7,i3,i2,i6)
     &   -m20_4p(i5,i1,i4,i3,i2,i7,i6)
     &   -m21_1p(i3,i5,i6,i7,i1,i4,i2)
     &   -m21_2p(i3,i5,i6,i1,i4,i7,i2)
     &   -m21_3p(i3,i5,i6,i7,i1,i4,i2)
     &   -m21_4p(i3,i5,i6,i1,i4,i7,i2)
     &   -m22_1p(i3,i1,i4,i5,i6,i7,i2)
     &   -m22_2p(i3,i1,i4,i7,i5,i6,i2)
     &   -m22_3p(i3,i1,i4,i5,i6,i7,i2)
      mat=mat
     &   +m23_1(i3,i5,i2,i7,i1,i4,i6)
     &   +m23_2(i3,i5,i2,i1,i4,i7,i6)
     &   +m24_1(i3,i1,i4,i7,i5,i2,i6)
     &   +m24_2(i3,i1,i4,i5,i2,i7,i6)
     &   +m25_1(i5,i7,i3,i6,i1,i4,i2)
     &   +m25_2(i5,i3,i6,i7,i1,i4,i2)
     &   +m25_3(i5,i3,i6,i1,i4,i7,i2)
     &   +m25_4(i5,i3,i6,i1,i4,i7,i2)
     &   +m27_1(i1,i7,i5,i4,i3,i2,i6)
     &   +m27_2(i1,i5,i4,i7,i3,i2,i6)
     &   +m27_3(i1,i5,i4,i7,i3,i2,i6)
     &   +m27_4(i1,i5,i4,i3,i2,i7,i6)
      mat=mat
     &   +m28_1(i1,i7,i3,i2,i5,i4,i6)
     &   +m28_2(i1,i3,i2,i7,i5,i4,i6)
     &   +m28_3(i1,i3,i2,i5,i4,i7,i6)
     &   +m30_1(i5,i7,i1,i4,i3,i6,i2)
     &   +m30_2(i5,i1,i4,i7,i3,i6,i2)
     &   +m30_3(i5,i1,i4,i3,i6,i7,i2)
     &   +m30_4(i5,i1,i4,i7,i3,i6,i2)
     &   +m31_1(i1,i7,i3,i6,i5,i2,i4)
     &   +m31_2(i1,i3,i6,i7,i5,i2,i4)
     &   +m31_3(i1,i3,i6,i5,i2,i7,i4)
     &   +m31_4(i1,i3,i6,i5,i2,i7,i4)
      mat=mat
     &   +m32_1(i3,i1,i6,i7,i5,i4,i2)
     &   +m32_2(i3,i1,i6,i5,i4,i7,i2)
     &   +m32_3(i3,i1,i6,i7,i5,i4,i2)
     &   +m32_4(i3,i1,i6,i5,i4,i7,i2)
     &   +m33_1(i1,i7,i5,i2,i3,i6,i4)
     &   +m33_2(i1,i5,i2,i7,i3,i6,i4)
     &   +m33_3(i1,i5,i2,i3,i6,i7,i4)
     &   +m33_4(i1,i5,i2,i7,i3,i6,i4)
     &   +m34_1(i3,i5,i4,i1,i6,i7,i2)
     &   +m34_2(i3,i5,i4,i7,i1,i6,i2)
     &   +m34_3(i3,i5,i4,i1,i6,i7,i2)


      end if   ! iww                               

      mat2=mat2+(abs(mat))**2
      mat2ww=mat2ww+(abs(matww))**2

      end do
      end do
      end do
      end do
      end do
      end do
      end do

      mat2=comf2*mat2
      mat2ww=comf2*mat2ww

      end 


