      subroutine inipart(p1,p2,ps1,ps2)
c----------------------------------------------------------------------c
c Returns spinors and generalized polarization vectors of initial
c e+ e-
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 15 February, 2001
c----------------------------------------------------------------------c

      use mathprms 
      use parsm
      use parproc
      use helproc
      use inistate
      use drivec

      implicit none

      real(kind(1.d0)), dimension(0:3) :: p1,p2
      real(kind(1.d0)), dimension(0:4) :: ps1,ps2

c Initial particle momenta in the spinor representation:

      call spinr(p1,xp1,yp1)
      call spinr(p2,xp2,yp2)

c Spinors of the initial fermions:

      call spinornew(p1,ps1,m1,-1,1,n1,u1)
      call spinornew(p2,ps2,m2,1,0,n2,u2)

c Vector boson couplings sandwiched between spinors:

      call fvf(u1,n1,-p1,m1,ga1m,ga1p,zero,ma2,u2,n2,-p2,m2,
     &                                                 ea12,xa12,ya12)
      call fvf(u1,n1,-p1,m1,gz1m,gz1p,zero,mz2,u2,n2,-p2,m2,
     &                                                 ez12,xz12,yz12)

      if (irad == 2) then

      x312=ga3p*xa12+gz3p*xz12
      y312=ga3m*ya12+gz3m*yz12
      x412=ga4p*xa12+gz4p*xz12
      y412=ga4m*ya12+gz4m*yz12
      x512=ga5p*xa12+gz5p*xz12
      y512=ga5m*ya12+gz5m*yz12
      x612=ga6p*xa12+gz6p*xz12
      y612=ga6m*ya12+gz6m*yz12

      end if

      end subroutine
