      subroutine mateeeeg(p1,ps1,xp1,yp1,u1,p2,ps2,xp2,yp2,u2,
     &              p3,ps3,xp3,yp3,u3,p4,ps4,xp4,yp4,u4,
     &              p5,ps5,xp5,yp5,u5,p6,ps6,xp6,yp6,u6,
     &              p7,ps7,xp7,yp7,e7,xe7,ye7,matg)
c----------------------------------------------------------------------c
c Returns the matrix element of the t-channel diagrams of
c
c   e+(p1) + e-(p2) --> e-(p3) + e+(p4) + e-(p5) + e+(p6) + gamma(p7)
c
c for the neutral current processes not containing virtual gluons
c
c Input: pi, i=1,...,7 - external particle momenta,
c        psi, i=1,...,7 - spherical components of the external 
c                               particle momenta,
c
c The frame is defined as that p1=(E1,0,0,p), p2=(E2,0,0,-p).
c Massive vector bosons are taken in the unitary gauge and massless 
c in the Feynman gauge
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 27 September, 2000;  modified 2 November, 2001
c----------------------------------------------------------------------c

      use mathprms 
      use parsm
      use helproc
      use parproc
      use genpv12
      use genpv12g

      implicit none
      integer, parameter :: dp=kind(1.d0)

      integer i1,i2,i3,i4,i5,i6,i7,i

      real(dp), dimension(0:3) ::  p1,p2,p3,p4,p5,p6,p7
      real(dp), dimension(0:4) ::  ps1,ps2,ps3,ps4,ps5,ps6,ps7
      real(dp) srr,e7(0:3,2)

      real(dp) t52,t14
      complex(dp) d37,d47,d57,d67

      complex(dp), dimension(2,2) :: xp1,xp2,xp3,xp4,xp5,xp6,xp7,
     &                              yp1,yp2,yp3,yp4,yp5,yp6,yp7

      complex(dp), dimension(2,2,n3,n4,n5,n6,2) :: matg

      complex(dp), dimension(4,2) :: u1
      complex(dp), dimension(4,2) :: u2
      complex(dp), dimension(4,n3) :: u3
      complex(dp), dimension(4,n4) :: u4
      complex(dp), dimension(4,n5) :: u5
      complex(dp), dimension(4,n6) :: u6

      complex(dp), dimension(2,2,2) :: xe7,ye7

      complex(dp) :: mat

      complex(dp), dimension(0:3,2,n4) :: ea14,ez14
      complex(dp), dimension(0:3,2,n4,2) :: ea14g,ez14g
      complex(dp), dimension(2,2,2,n4) :: xa14,xz14,ya14,yz14,
     &                                    x514,y514,x614,y614
      complex(dp), dimension(2,2,2,n4,2) :: xa14g,xz14g,
     &                                       ya14g,yz14g
      complex(dp), dimension(0:3,n5,2) :: ea52,ez52
      complex(dp), dimension(0:3,n5,2,2) :: ea52g,ez52g
      complex(dp), dimension(2,2,n5,2) :: xa52,xz52,x152,x352,
     &                                    ya52,yz52,y152,y352
      complex(dp), dimension(2,2,n5,2,2) :: xa52g,xz52g,x152g,x352g,
     &                                       ya52g,yz52g,y152g,y352g
      complex(dp), dimension(0:3,n3,n6) :: ea36,ez36
      complex(dp), dimension(0:3,n3,n6,2) :: ea36g,ez36g
      complex(dp), dimension(2,2,n3,n6) :: xa36,xz36,x136,x236,x536,
     &                                    ya36,yz36,y136,y236,y536
      complex(dp), dimension(2,2,n3,n6,2) :: xa36g,xz36g,x136g,x536g,
     &                                       ya36g,yz36g,y136g,y536g
      complex(dp), dimension(2,2,n7) :: h00g

      complex(dp), dimension(n3,n5,2,2,2,n4,n6) :: m23_1
      complex(dp), dimension(n3,n5,2,2,n4,2,n6) :: m23_2
      complex(dp), dimension(n3,2,n5,2,2,n4,n6) :: m23_3
      complex(dp), dimension(n3,n5,2,2,2,n4,n6) :: m23_4
      complex(dp), dimension(n3,n5,2,2,n4,2,n6) :: m23_5
      complex(dp), dimension(n3,2,n4,2,n5,2,n6) :: m24_1
      complex(dp), dimension(n3,2,n4,n5,2,2,n6) :: m24_2
      complex(dp), dimension(n3,2,2,n4,n5,2,n6) :: m24_3
      complex(dp), dimension(n3,2,n4,2,n5,2,n6) :: m24_4
      complex(dp), dimension(n3,2,n4,n5,2,2,n6) :: m24_5
      complex(dp), dimension(n5,2,n3,n6,2,n4,2) :: m25_1
      complex(dp), dimension(n5,n3,n6,2,2,n4,2) :: m25_2
      complex(dp), dimension(n5,n3,n6,2,n4,2,2) :: m25_3
      complex(dp), dimension(n5,n3,n6,2,n4,2,2) :: m25_4
      complex(dp), dimension(n5,n3,n6,2,2,n4,2) :: m25_5
      complex(dp), dimension(n5,2,2,n4,n3,n6,2) :: m30_1
      complex(dp), dimension(n5,2,n4,2,n3,n6,2) :: m30_2
      complex(dp), dimension(n5,2,n4,n3,n6,2,2) :: m30_3
      complex(dp), dimension(n5,2,n4,2,n3,n6,2) :: m30_4
      complex(dp), dimension(n5,2,n4,n3,n6,2,2) :: m30_5
      complex(dp), dimension(2,2,n3,n6,n5,2,n4) :: m31_1
      complex(dp), dimension(2,n3,n6,2,n5,2,n4) :: m31_2
      complex(dp), dimension(2,n3,n6,n5,2,2,n4) :: m31_3
      complex(dp), dimension(2,n3,n6,n5,2,2,n4) :: m31_4
      complex(dp), dimension(2,n3,n6,2,n5,2,n4) :: m31_5
      complex(dp), dimension(2,2,n5,2,n3,n6,n4) :: m33_1
      complex(dp), dimension(2,n5,2,2,n3,n6,n4) :: m33_2
      complex(dp), dimension(2,n5,2,n3,n6,2,n4) :: m33_3
      complex(dp), dimension(2,n5,2,2,n3,n6,n4) :: m33_4
      complex(dp), dimension(2,n5,2,n3,n6,2,n4) :: m33_5

c Fermion denominators:

      d37=cmplx(srr(p3+p7,p3+p7),zero,dp)-cm3**2
      d47=cmplx(srr(p4+p7,p4+p7),zero,dp)-cm4**2
      d57=cmplx(srr(p5+p7,p5+p7),zero,dp)-cm5**2
      d67=cmplx(srr(p6+p7,p6+p7),zero,dp)-cm6**2

      call fvf(u3,n3,p3,m3,ga3m,ga3p,zero,ma2,u6,n6,p6,m6,
     &                                                 ea36,xa36,ya36)
      call ffvgnew(u3,n3,p3,xp3,yp3,cm3,ga3m,d37,
     &           u6,n6,p6,xp6,yp6,cm6,ga6m,d67,ga3m,ga3p,ma2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea36,ea36g,xa36g,ya36g,
     &           0,hff(3),mh2,h00g)

      call fvf(u3,n3,p3,m3,gz3m,gz3p,zero,mz2,u6,n6,p6,m6,
     &                                                 ez36,xz36,yz36)
      call ffvgnew(u3,n3,p3,xp3,yp3,cm3,ga3m,d37,
     &           u6,n6,p6,xp6,yp6,cm6,ga6m,d67,gz3m,gz3p,mz2,
     &           e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ez36,ez36g,xz36g,yz36g,
     &           0,hff(3),mh2,h00g)

       t14=-2.d0*ps1(0)*ps4(0)*(1.d0-ps4(1)
     &    +(m1*(p1(0)-p4(0))/(p1(0)*p4(0)))**2/2.d0)
       call fvf(u1,2,-p1,m1,ga1m,ga1p,t14,ma2,u4,n4,p4,m4,
     &                                                 ea14,xa14,ya14)
       call fvf(u1,2,-p1,m1,gz1m,gz1p,t14,mz2,u4,n4,p4,m4,
     &                                                 ez14,xz14,yz14)
      call ffvgnew(u1,n1,-p1,-xp1,-yp1,cm1,ga1m,d17,
     &          u4,n4,p4,xp4,yp4,cm4,ga4m,d47,ga4m,ga4p,ma2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea14,ea14g,xa14g,ya14g,
     &          0,hff(1),mh2,h00g)
      call ffvgnew(u1,n1,-p1,-xp1,-yp1,cm1,ga1m,d17,
     &          u4,n4,p4,xp4,yp4,cm4,ga4m,d47,gz4m,gz4p,mz2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ez14,ez14g,xz14g,yz14g,
     &          0,hff(1),mh2,h00g)

       t52=-2.d0*ps2(0)*ps5(0)*(1.d0+ps5(1)
     &    +(m2*(p2(0)-p5(0))/(p2(0)*p5(0)))**2/2.d0)
      call fvf(u5,n5,p5,m5,ga5m,ga5p,t52,ma2,u2,2,-p2,m2,
     &                                                 ea52,xa52,ya52)
      call fvf(u5,n5,p5,m5,gz5m,gz5p,t52,mz2,u2,2,-p2,m2,
     &                                                 ez52,xz52,yz52)
      call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &          u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,ga5m,ga5p,ma2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ea52,ea52g,xa52g,ya52g,
     &          0,hff(5),mh2,h00g)

      call ffvgnew(u5,n5,p5,xp5,yp5,cm5,ga5m,d57,
     &          u2,n2,-p2,-xp2,-yp2,cm2,ga2m,d27,gz5m,gz5p,mz2,
     &          e7,xe7,ye7,n7,p7,xp7,yp7,ocom,ez52,ez52g,xz52g,yz52g,
     &          0,hff(5),mh2,h00g)

      x136=ga1p*xa36+gz1p*xz36
      y136=ga1m*ya36+gz1m*yz36
      x136g=ga1p*xa36g+gz1p*xz36g
      y136g=ga1m*ya36g+gz1m*yz36g

      x236=ga2p*xa36+gz2p*xz36
      y236=ga2m*ya36+gz2m*yz36

      x536=ga5p*xa36+gz5p*xz36
      y536=ga5m*ya36+gz5m*yz36
      x536g=ga5p*xa36g+gz5p*xz36g
      y536g=ga5m*ya36g+gz5m*yz36g

      x152=ga1p*xa52+gz1p*xz52
      y152=ga1m*ya52+gz1m*yz52
      x352=ga3p*xa52+gz3p*xz52
      y352=ga3m*ya52+gz3m*yz52

      x152g=ga1p*xa52g+gz1p*xz52g
      y152g=ga1m*ya52g+gz1m*yz52g
      x352g=ga3p*xa52g+gz3p*xz52g
      y352g=ga3m*ya52g+gz3m*yz52g

      x514=ga5p*xa14+gz5p*xz14
      y514=ga5m*ya14+gz5m*yz14
      x614=ga6p*xa14+gz6p*xz14
      y614=ga6m*ya14+gz6m*yz14

      call fefef(u3,p3,x352g,y352g,onec,onec,
     &           xp1-xp4-xp6,yp1-yp4-yp6,cm3,ocom,
     &           x614,y614,onec,onec,u6,p6,m23_1,n3,n5*2*2,2*n4,n6)

      call fefef(u3,p3,x352,y352,onec,onec,
     &          -xp2+xp3+xp5,-yp2+yp3+yp5,cm3,ocom,
     &           ga6p*xa14g+gz6p*xz14g,ga6m*ya14g+gz6m*yz14g,onec,onec,
     &           u6,p6,m23_2,n3,n5*2,2*n4*2,n6)

      call fefef(u3,p3,
     &           ga3p*xa14g+gz3p*xz14g,ga3m*ya14g+gz3m*yz14g,onec,onec,
     &           xp2-xp5-xp6,yp2-yp5-yp6,cm3,ocom,
     &           x352,y352,onec,onec,u6,p6,m24_1,n3,2*n4*2,n5*2,n6)

      call fefef(u3,p3,x614,y614,onec,onec,
     &          -xp1+xp3+xp4,-yp1+yp3+yp4,cm3,ocom,
     &           x352g,y352g,onec,onec,u6,p6,m24_2,n3,2*n4,n5*2*2,n6)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,xp7,yp7,cm5,d57,
     &             x536,y536,onec,onec,
     &             xp1+xp2-xp4,yp1+yp2-yp4,cm5,ocom,
     &             x514,y514,onec,onec,u2,-p2,m25_1,n5,2,n3*n6,2*n4,2)

      call fefefef(u5,p5,x536,y536,onec,onec,
     &             xp3+xp5+xp6,yp3+yp5+yp6,cm5,ocom,
     &             xe7,ye7,ga5m,ga5p,
     &             xp1+xp2-xp4,yp1+yp2-yp4,cm5,ocom,
     &             x514,y514,onec,onec,u2,-p2,m25_2,n5,n3*n6,2,2*n4,2)

      call fefefef(u5,p5,x536,y536,onec,onec,
     &             xp3+xp5+xp6,yp3+yp5+yp6,cm5,ocom,
     &             x514,y514,onec,onec,
     &             xp7,yp7,cm2,d27,xe7,ye7,ga2m,ga2p,
     &                               u2,-p2,m25_3,n5,n3*n6,2*n4,2,2)

      call fefef(u5,p5,x536,y536,onec,onec,
     &           xp3+xp5+xp6,yp3+yp5+yp6,cm5,ocom,
     &           ga2p*xa14g+gz2p*xz14g,ga2m*ya14g+gz2m*yz14g,onec,onec,
     &                               u2,-p2,m25_4,n5,n3*n6,2*n4*2,2)

      call fefefef(u5,p5,xe7,ye7,ga5m,ga5p,xp7,yp7,cm5,d57,
     &             x514,y514,onec,onec,
     &             xp2-xp3-xp6,yp2-yp3-yp6,cm5,ocom,
     &             x236,y236,onec,onec,u2,-p2,
     &             m30_1,n5,2,2*n4,n3*n6,2)

      call fefefef(u5,p5,x514,y514,onec,onec,
     &            -xp1+xp4+xp5,-yp1+yp4+yp5,cm5,ocom,
     &             xe7,ye7,ga5m,ga5p,
     &             xp2-xp3-xp6,yp2-yp3-yp6,cm5,ocom,
     &             x236,y236,onec,onec,u2,-p2,
     &             m30_2,n5,2*n4,2,n3*n6,2)

      call fefefef(u5,p5,x514,y514,onec,onec,
     &            -xp1+xp4+xp5,-yp1+yp4+yp5,cm5,ocom,
     &             x236,y236,onec,onec,
     &             xp7,yp7,cm2,d27,xe7,ye7,ga2m,ga2p,
     &             u2,-p2,m30_3,n5,2*n4,n3*n6,2,2)

      call fefef(u5,p5,ga5p*xa14g+gz5p*xz14g,
     &                                ga5m*ya14g+gz5m*yz14g,onec,onec,
     &           xp2-xp3-xp6,yp2-yp3-yp6,cm5,ocom,
     &           x236,y236,onec,onec,u2,-p2,m30_4,n5,2*n4*2,n3*n6,2)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,xp7,yp7,cm1,d17,
     &             x136,y136,onec,onec,
     &             xp2-xp4-xp5,yp2-yp4-yp5,cm1,ocom,
     &             x152,y152,onec,onec,u4,p4,m31_1,2,2,n3*n6,n5*2,n4)

      call fefefef(u1,-p1,x136,y136,onec,onec,
     &            -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &             xe7,ye7,ga1m,ga1p,
     &             xp2-xp4-xp5,yp2-yp4-yp5,cm1,ocom,
     &             x152,y152,onec,onec,u4,p4,m31_2,2,n3*n6,2,n5*2,n4)

      call fefefef(u1,-p1,x136,y136,onec,onec,
     &            -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &             x152,y152,onec,onec,
     &             xp7,yp7,cm4,d47,xe7,ye7,ga4m,ga4p,
     &             u4,p4,m31_3,2,n3*n6,n5*2,2,n4)

      call fefef(u1,-p1,x136,y136,onec,onec,
     &          -xp1+xp3+xp6,-yp1+yp3+yp6,cm1,ocom,
     &           x152g,y152g,onec,onec,u4,p4,m31_4,2,n3*n6,n5*2*2,n4)

      call fefefef(u1,-p1,xe7,ye7,ga1m,ga1p,xp7,yp7,cm1,d17,
     &             x152,y152,onec,onec,
     &            -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &             x536,y536,onec,onec,u4,p4,m33_1,2,2,n5*2,n3*n6,n4)

      call fefefef(u1,-p1,x152,y152,onec,onec,
     &            -xp1-xp2+xp5,-yp1-yp2+yp5,cm1,ocom,
     &             xe7,ye7,ga1m,ga1p,
     &            -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &             x536,y536,onec,onec,u4,p4,m33_2,2,n5*2,2,n3*n6,n4)

      call fefefef(u1,-p1,x152,y152,onec,onec,
     &            -xp1-xp2+xp5,-yp1-yp2+yp5,cm1,ocom,
     &             x536,y536,onec,onec,
     &             xp7,yp7,cm4,d47,xe7,ye7,ga4m,ga4p,
     &             u4,p4,m33_3,2,n5*2,n3*n6,2,n4)

      call fefef(u1,-p1,x152g,y152g,onec,onec,
     &          -xp3-xp4-xp6,-yp3-yp4-yp6,cm1,ocom,
     &           x536,y536,onec,onec,u4,p4,m33_4,2,n5*2*2,n3*n6,n4)


      call fefefef(u3,p3,xe7,ye7,ga3m,ga3p,
     &             xp7,yp7,cm3,d37,x352,y352,onec,onec,
     &             xp1-xp4-xp6,yp1-yp4-yp6,cm6,ocom,
     &             x614,y614,onec,onec,u6,p6,
     &             m23_3,n3,2,n5*2,2*n4,n6)

      call fefefef(u3,p3,x352,y352,onec,onec,
     &            -xp2+xp3+xp5,-yp2+yp3+yp5,cm3,ocom,
     &             xe7,ye7,ga3m,ga3p,
     &             xp1-xp4-xp6,yp1-yp4-yp6,cm6,ocom,
     &             x614,y614,onec,onec,u6,p6,
     &             m23_4,n3,n5*2,2,2*n4,n6)

      call fefefef(u3,p3,x352,y352,onec,onec,
     &            -xp2+xp3+xp5,-yp2+yp3+yp5,cm3,ocom,
     &             x614,y614,onec,onec,xp7,yp7,cm6,d67,
     &             xe7,ye7,ga6m,ga6p,u6,p6,
     &             m23_5,n3,n5*2,2*n4,2,n6)

      call fefefef(u3,p3,xe7,ye7,ga3m,ga3p,
     &             xp7,yp7,cm3,d37,x614,y614,onec,onec,
     &             xp2-xp5-xp6,yp2-yp5-yp6,cm3,ocom,
     &             x352,y352,onec,onec,u6,p6,
     &             m24_3,n3,2,2*n4,n5*2,n6)

      call fefefef(u3,p3,x614,y614,onec,onec,
     &            -xp1+xp3+xp4,-yp1+yp3+yp4,cm3,ocom,
     &             xe7,ye7,ga3m,ga3p,
     &             xp2-xp5-xp6,yp2-yp5-yp6,cm6,ocom,
     &             x352,y352,onec,onec,u6,p6,
     &             m24_4,n3,2*n4,2,n5*2,n6)

      call fefefef(u3,p3,x614,y614,onec,onec,
     &            -xp1+xp3+xp4,-yp1+yp3+yp4,cm3,ocom,
     &             x352,y352,onec,onec,xp7,yp7,cm6,d67,
     &             xe7,ye7,ga6m,ga6p,u6,p6,
     &             m24_5,n3,2*n4,n5*2,2,n6)

      call fefef(u5,p5,x536g,y536g,onec,onec,
     &           xp1+xp2-xp4,yp1+yp2-yp4,cm5,ocom,
     &           x514,y514,onec,onec,u2,-p2,m25_5,n5,n3*n6*2,2*n4,2)

      call fefef(u5,p5,x514,y514,onec,onec,
     &          -xp1+xp4+xp5,-yp1+yp4+yp5,cm5,ocom,
     &           x536g,y536g,onec,onec,u2,-p2,m30_5,n5,2*n4,n3*n6*2,2)

      call fefef(u1,-p1,x136g,y136g,onec,onec,
     &           xp2-xp4-xp5,yp2-yp4-yp5,cm1,ocom,
     &           x152,y152,onec,onec,u4,p4,m31_5,2,n3*n6*2,n5*2,n4)

      call fefef(u1,-p1,x152,y152,onec,onec,
     &          -xp1-xp2+xp5,-yp1-yp2+yp5,cm1,ocom,
     &           x536g,y536g,onec,onec,u4,p4,m33_5,2,n5*2,n3*n6*2,n4)

c The spin averaged squared matrix element:


      do i1=1,2
      do i2=1,2
      do i3=1,n3
      do i4=1,n4
      do i5=1,n5
      do i6=1,n6
      do i7=1,2

       mat=
     &    +m23_1(i3,i5,i2,i7,i1,i4,i6)
     &    +m23_2(i3,i5,i2,i1,i4,i7,i6)
     &    +m23_3(i3,i7,i5,i2,i1,i4,i6)
     &    +m23_4(i3,i5,i2,i7,i1,i4,i6)
     &    +m23_5(i3,i5,i2,i1,i4,i7,i6)
     &    +m24_1(i3,i1,i4,i7,i5,i2,i6)
     &    +m24_2(i3,i1,i4,i5,i2,i7,i6)
     &    +m24_3(i3,i7,i1,i4,i5,i2,i6)
     &    +m24_4(i3,i1,i4,i7,i5,i2,i6)
     &    +m24_5(i3,i1,i4,i5,i2,i7,i6)
     &    +m25_1(i5,i7,i3,i6,i1,i4,i2)
     &    +m25_2(i5,i3,i6,i7,i1,i4,i2)
     &    +m25_3(i5,i3,i6,i1,i4,i7,i2)
     &    +m25_4(i5,i3,i6,i1,i4,i7,i2)
     &    +m25_5(i5,i3,i6,i7,i1,i4,i2)
       mat=mat
     &    +m30_1(i5,i7,i1,i4,i3,i6,i2)
     &    +m30_2(i5,i1,i4,i7,i3,i6,i2)
     &    +m30_3(i5,i1,i4,i3,i6,i7,i2)
     &    +m30_4(i5,i1,i4,i7,i3,i6,i2)
     &    +m30_5(i5,i1,i4,i3,i6,i7,i2)
     &    +m31_1(i1,i7,i3,i6,i5,i2,i4)
     &    +m31_2(i1,i3,i6,i7,i5,i2,i4)
     &    +m31_3(i1,i3,i6,i5,i2,i7,i4)
     &    +m31_4(i1,i3,i6,i5,i2,i7,i4)
     &    +m31_5(i1,i3,i6,i7,i5,i2,i4)
     &    +m33_1(i1,i7,i5,i2,i3,i6,i4)
     &    +m33_2(i1,i5,i2,i7,i3,i6,i4)
     &    +m33_3(i1,i5,i2,i3,i6,i7,i4)
     &    +m33_4(i1,i5,i2,i7,i3,i6,i4)
     &    +m33_5(i1,i5,i2,i3,i6,i7,i4)

      matg(i1,i2,i3,i4,i5,i6,i7)=mat

      end do
      end do
      end do
      end do
      end do
      end do
      end do

      end 


