      subroutine parspec
c----------------------------------------------------------------------c
c Returns paprameters of the specific e+ e- -> 4f process
c
c Karol Kolodziej, University of Silesia, kolodzie@us.edu.pl
c 17 February, 2000; modified 1 November, 2001
c----------------------------------------------------------------------c

      use inprms
      use mathprms 
      use parsm
      use parproc
      use helproc
      use drivec
      use topapprox
c      use topan
      use gaugepar

      implicit none
      integer, parameter :: dp=kind(1.d0)

      integer :: i
      real(dp) :: a,rwt,gwt,gamhsm,bth,f1,f2,f3
      complex(dp) :: cmw,cmh

c Complex masses squared:

      mw2=cmplx(mw**2,-mw*gamw,dp)
      ma2=cmplx(zero,zero,dp)
      mz2=cmplx(mz**2,-mz*gamz,dp)

      if (gamh == 0.d0) then

c The SM Higgs width:

      gamhsm=sqrt(2.d0)*gmu/(8.d0*pi)*mh
     &      *(mtau**2*(sqrt(1.d0-4.d0*(mtau/mh)**2))**3
     & +3.d0*(mc**2*(sqrt(1.d0-4.d0*(mc/mh)**2))**3
     &       +mb**2*(sqrt(1.d0-4.d0*(mb/mh)**2))**3))

      if (mh > 2.d0*mt) then
       bth=1.d0-4.d0*(mt/mh)**2
       gamhsm=gamhsm+sqrt(2.d0)*gmu/(8.d0*pi)*mh
     &      *(3.d0*(mt**2*(sqrt(bth))**3))
      end if

      if (imad == 1) then
       gamhig=gamh
      else
       gamhig=gamhsm
      end if

      else

      gamhig=gamh

      end if

      mh2=cmplx(mh**2,-mh*gamhig,dp)

c Coupling constants:

      e0=sqrt(4.d0*pi/ralp0)
      ew=sqrt(4.d0*pi/ralpw)
      gqq=cmplx(sqrt(4.d0*pi*alphas),0.d0,dp)     !    gluon-quark coupling


      if (ischeme == 1) then
        csw2=(mz2-mw2)/mz2
        cmw=sqrt(mw2)
        cmh=sqrt(mh2)
        if (ialpw == 1) then
         cralpw=4.44288293815837d0/(2.d0*csw2*gmu*mw2)
        else if (ialpw == 0) then
         cralpw=4.44288293815837d0/(2.d0*sw2*gmu*mw**2)
        else
         write(*,1010) ialpw
 1010    format('# ialpw =',i2,' is not allowed in this context')
        end if
      else if (ischeme == 0) then
        csw2=cmplx(sw2,0.d0,dp)
        cmw=cmplx(mw,0.d0,dp)
        cmh=cmplx(mh,0.d0,dp)
        cralpw=4.44288293815837d0/(2.d0*csw2*gmu*mw**2)
      else
        write(*,1000) ischeme
 1000   format('# ischeme =',i2,' is not allowed in this context')
      end if

      cew=sqrt(cmplx(4.d0*pi,0.d0,dp)/cralpw)

      call couplsma(cew,csw2,cmw,cmh,
     &              gll,guu,gdd,
     &              znnm,znnp,zllm,zllp,zuum,zuup,zddm,zddp,
     &              wff,
     &              gww,zww,
     &              ggww,gzww,zzww,wwww,
     &              csff,c3ff,chff,
     &              saw,szw,hww,hzz,
     &              ass,zss,w3s,whs,z3h,
     &              hss)


c The SM top width:

c---- total:

      gamtsm=gmu*mt**3/(8.d0*pi*sqrt(2.d0))
     &      *(1.d0-(mw/mt)**2)**2*(1.d0+2.d0*(mw/mt)**2)
     &      *(1.d0-2.d0*alphas/(3.d0*pi)*(2.d0*pi**2/3.d0-5.d0/2.d0))

c---- partial (t -> b l+ vl)

      rwt=mw/mt
      gwt=gamw/mt

      gamt3=gmu**2*mt**3*mw**2/(96.d0*pi**3)
     &     *((1.d0-3.d0*rwt**4+2.d0*rwt**6+3.d0*rwt**2*gwt**2
     &       -6.d0*rwt**4*gwt**2)*mw/gamw*(pi
     &       -atan(mt**2*gamw/(mw*(mt**2-mw**2-gamw**2))))
     &      +(3.d0*rwt**4-3.d0*rwt**6+rwt**4*gwt**2)
     &  *log(mw**2*(mw**2+gamw**2)/((mt**2-mw**2)**2+mw**2*gamw**2)))

c Initial particle masses (with masses of the doublet partner),
c corresponding widths, chiral couplings and No's of polarization states:

      m1=me
      m2=me

      gam1=game
      gam2=game

      ga1m=gll
      ga1p=gll
      gz1m=zllm
      gz1p=zllp

      ga2m=gll
      ga2p=gll
      gz2m=zllm
      gz2p=zllp

      n1=2
      n2=2
      n7=2

      aw0=zero
      aw=zero

      if (iproc == 1) then

       chproc='u d~ mu- vm~'

       m3=mu                   ! Final particle masses and widths
       m4=md
       m5=mmu
       m6=zero

       gam3=gamu               ! Final particle masses and widths
       gam4=gamd
       gam5=gammu
       gam6=zero

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=2
       n4=2
       n5=2
       n6=1

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/3.d0
       aw0(:8)=(/a,zero,zero,zero,zero,zero,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/15.d0
       aw(:5)=a
       aw(37:41)=a
       aw(43:47)=a

      else if (iproc == 2) then

       chproc='u d~ tau- vt~'

       m3=mu                   ! Final particle masses and widths
       m4=md
       m5=mtau
       m6=zero

       gam3=gamu               ! Final particle masses and widths
       gam4=gamd
       gam5=gamtau
       gam6=zero

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=2
       n4=2
       n5=2
       n6=1

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/3.d0
       aw0(:8)=(/a,zero,zero,zero,zero,zero,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/15.d0
       aw(:5)=a
       aw(37:41)=a
       aw(43:47)=a

       a=1.d0/3.d0

      else if (iproc == 3) then

       chproc='c s~ mu- vm~'

       m3=mc                   ! Final particle masses and widths
       m4=ms
       m5=mmu
       m6=zero

       gam3=gamc               ! Final particle masses and widths
       gam4=gams
       gam5=gammu
       gam6=zero

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=2
       n4=2
       n5=2
       n6=1

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/3.d0
       aw0(:8)=(/a,zero,zero,zero,zero,zero,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/15.d0
       aw(:5)=a
       aw(37:41)=a
       aw(43:47)=a

      else if (iproc == 4) then

       chproc='c s~ tau- vt~'

       m3=mc                   ! Final particle masses and widths
       m4=ms
       m5=mtau
       m6=zero

       gam3=gamc               ! Final particle masses and widths
       gam4=gams
       gam5=gamtau
       gam6=zero

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=2
       n4=2
       n5=2
       n6=1

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/3.d0
       aw0(:8)=(/a,zero,zero,zero,zero,zero,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/15.d0
       aw(:5)=a
       aw(37:41)=a
       aw(43:47)=a

      else if (iproc == 5) then

       chproc='t b~ mu- vm~'

       m3=mt                   ! Final particle masses and widths
       m4=mb
       m5=mmu
       m6=zero

       gam3=gamt               ! Final particle masses and widths
       gam4=gamb
       gam5=gammu
       gam6=zero

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=2
       n4=2
       n5=2
       n6=1

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=0.25d0
       aw0(1)=a
       aw0(7:8)=a
       aw0(19)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/17.d0
       aw(:5)=a
       aw(37:41)=a
       aw(43:47)=a
       aw(81:82)=a

      else if (iproc == 6) then

       chproc='t b~ tau- vt~'

       m3=mt                   ! Final particle masses and widths
       m4=mb
       m5=mtau
       m6=zero

       gam3=gamt               ! Final particle masses and widths
       gam4=gamb
       gam5=gamtau
       gam6=zero

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=2
       n4=2
       n5=2
       n6=1

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=0.25d0
       aw0(1)=a
       aw0(7:8)=a
       aw0(19)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/17.d0
       aw(:5)=a
       aw(37:41)=a
       aw(43:47)=a
       aw(81:82)=a

      else if (iproc == 7) then

       chproc='c s~ d u~'

       m3=mc                   ! Final particle masses and widths
       m4=ms
       m5=md
       m6=mu

       gam3=gamc               ! Final particle masses and widths
       gam4=gams
       gam5=gamd
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol**2

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/3.d0
       aw0(:8)=(/a,zero,zero,zero,zero,zero,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/18.d0
       aw(:6)=a
       aw(37:48)=a

      else if (iproc == 8) then

       chproc='t b~ d u~'

       m3=mt                   ! Final particle masses and widths
       m4=mb
       m5=md
       m6=mu

       gam3=gamt               ! Final particle masses and widths
       gam4=gamb
       gam5=gamd
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol**2

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=0.25d0
       aw0(1)=a
       aw0(7:8)=a
       aw0(19)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/17.d0
       aw(:5)=a
       aw(37:41)=a
       aw(43:47)=a
       aw(81:82)=a

      else if (iproc == 9) then

       chproc='t b~ s c~'

       m3=mt                   ! Final particle masses and widths
       m4=mb
       m5=ms
       m6=mc


       gam3=gamt               ! Final particle masses and widths
       gam4=gamb
       gam5=gams
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol**2

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=0.25d0
       aw0(1)=a
       aw0(7:8)=a
       aw0(19)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/17.d0
       aw(:5)=a
       aw(37:41)=a
       aw(43:47)=a
       aw(81:82)=a

      else if (iproc == 10) then

       chproc='vt tau+ mu- vm~'

       m3=zero                 ! Final particle masses and widths
       m4=mtau
       m5=mmu
       m6=zero

       gam3=zero               ! Final particle masses and widths
       gam4=gamtau
       gam5=gammu
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/3.d0
       aw0(:8)=(/a,zero,zero,zero,zero,zero,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/12.d0
       aw(:6)=(/a,a,zero,a,a,zero/)
       aw(37:42)=(/a,a,zero,a,a,zero/)
       aw(43:48)=(/a,a,zero,a,a,zero/)

      else if (iproc == 11) then

       chproc='u d~ d u~'

       m3=mu                 ! Final particle masses and widths
       m4=md
       m5=md
       m6=mu

       gam3=gamu               ! Final particle masses and widths
       gam4=gamd
       gam5=gamd
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/34.d0
      aw0(1:5)=a
      aw0(7:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/118.d0
      aw(1:30)=a
      aw(36:60)=a
      aw(66:80)=a
      aw(83:130)=a

      else if (iproc == 12) then

       chproc='c s~ s c~'

       m3=mc                 ! Final particle masses and widths
       m4=ms
       m5=ms
       m6=mc

       gam3=gamc               ! Final particle masses and widths
       gam4=gams
       gam5=gams
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/34.d0
      aw0(1:5)=a
      aw0(7:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/118.d0
      aw(1:30)=a
      aw(36:60)=a
      aw(66:80)=a
      aw(83:130)=a

      else if (iproc == 13) then

       chproc='t b~ b t~'

       m3=mt                 ! Final particle masses and widths
       m4=mb
       m5=mb
       m6=mt

       gam3=gamt               ! Final particle masses and widths
       gam4=gamb
       gam5=gamb
       gam6=gamt

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0


c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/39.d0
      aw0(1:5)=a
      aw0(7:10)=a
      aw0(12)=a
      aw0(17:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/120.d0
      aw(1:30)=a
      aw(36:60)=a
      aw(66:130)=a

      else if (iproc == 14) then

       chproc='vm mu+ mu- vm~'

       m3=zero                 ! Final particle masses and widths
       m4=mmu
       m5=mmu
       m6=zero

       gam3=zero               ! Final particle masses and widths
       gam4=gammu
       gam5=gammu
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/7.d0
        aw0(1)=a
        aw0(3)=a
        aw0(5)=a
        aw0(7:8)=a
        aw0(10)=a
        aw0(18)=a

        a=1.d0/24.d0
        aw(1:2)=a
        aw(4:5)=a
        aw(13:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(37:38)=a
        aw(40:41)=a
        aw(43:44)=a
        aw(46:47)=a
        aw(55:56)=a
        aw(75:76)=a
        aw(79:80)=a
       else
        a=1.d0/6.d0
        aw0(1)=a
        aw0(3)=a
        aw0(5)=a
        aw0(7:8)=a
        aw0(10)=a

        a=1.d0/20.d0
        aw(1:2)=a
        aw(4:5)=a
        aw(13:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(37:38)=a
        aw(40:41)=a
        aw(43:44)=a
        aw(46:47)=a
        aw(55:56)=a
       end if

      else if (iproc == 15) then

       chproc='vt tau+ tau- vt~'

       m3=zero                 ! Final particle masses and widths
       m4=mtau
       m5=mtau
       m6=zero

       gam3=zero               ! Final particle masses and widths
       gam4=gamtau
       gam5=gamtau
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/7.d0
        aw0(1)=a
        aw0(3)=a
        aw0(5)=a
        aw0(7:8)=a
        aw0(10)=a
        aw0(18)=a

        a=1.d0/24.d0
        aw(1:2)=a
        aw(4:5)=a
        aw(13:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(37:38)=a
        aw(40:41)=a
        aw(43:44)=a
        aw(46:47)=a
        aw(55:56)=a
        aw(75:76)=a
        aw(79:80)=a
       else
        a=1.d0/6.d0
        aw0(1)=a
        aw0(3)=a
        aw0(5)=a
        aw0(7:8)=a
        aw0(10)=a

        a=1.d0/20.d0
        aw(1:2)=a
        aw(4:5)=a
        aw(13:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(37:38)=a
        aw(40:41)=a
        aw(43:44)=a
        aw(46:47)=a
        aw(55:56)=a
       end if

      else if (iproc == 16) then

       chproc='u d~ e- ve~'

       m3=mu                   ! Final particle masses and widths
       m4=md
       m5=me
       m6=zero

       gam3=gamu               ! Final particle masses and widths
       gam4=gamd
       gam5=game
       gam6=zero

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=2
       n4=2
       n5=2
       n6=1

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=0.25d0
       aw0(:8)=(/a,zero,zero,zero,zero,a,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/20.d0
       aw(:5)=a
       aw(31:35)=a
       aw(37:41)=a
       aw(43:47)=a

      else if (iproc == 17) then

       chproc='c s~ e- ve~'

       m3=mc                   ! Final particle masses and widths
       m4=ms
       m5=me
       m6=zero

       gam3=gamc               ! Final particle masses and widths
       gam4=gams
       gam5=game
       gam6=zero

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=2
       n4=2
       n5=2
       n6=1

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=0.25d0
       aw0(:8)=(/a,zero,zero,zero,zero,a,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/20.d0
       aw(:5)=a
       aw(31:35)=a
       aw(37:41)=a
       aw(43:47)=a

      else if (iproc == 18) then

       chproc='t b~ e- ve~'

       m3=mt                   ! Final particle masses and widths
       m4=mb
       m5=me
       m6=zero

       gam3=gamt               ! Final particle masses and widths
       gam4=gamb
       gam5=game
       gam6=zero

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=2
       n4=2
       n5=2
       n6=1

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=0.2d0
       aw0(:8)=(/a,zero,zero,zero,zero,a,a,a/) 
       aw0(19)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/20.d0
       aw(:5)=a
       aw(31:35)=a
       aw(37:41)=a
       aw(43:47)=a

      else if (iproc == 19) then

       chproc='vm mu+ e- ve~'

       m3=zero                   ! Final particle masses and widths
       m4=mmu
       m5=me
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=gammu
       gam5=game
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=0.25d0
       aw0(:8)=(/a,zero,zero,zero,zero,a,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/16.d0
       aw(:6)=(/a,a,zero,a,a,zero/)
       aw(31:48)=(/a,a,zero,a,a,zero,
     &             a,a,zero,a,a,zero,
     &             a,a,zero,a,a,zero/)

      else if (iproc == 20) then

       chproc='vt tau+ e- ve~'

       m3=zero                   ! Final particle masses and widths
       m4=mtau
       m5=me
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=gamtau
       gam5=game
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=0.25d0
       aw0(:8)=(/a,zero,zero,zero,zero,a,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/16.d0
       aw(:6)=(/a,a,zero,a,a,zero/)
       aw(31:48)=(/a,a,zero,a,a,zero,
     &             a,a,zero,a,a,zero,
     &             a,a,zero,a,a,zero/)

      else if (iproc == 21) then

       chproc='ve e+ e- ve~'

       m3=zero                   ! Final particle masses and widths
       m4=me
       m5=me
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/11.d0
c                 1  2   3  4   5 6 7 8  9   
       aw0(:14)=(/a,zero,a,zero,a,a,a,a,zero,a,a,a,a,a/) 
       aw0(15:16)=(/zero,zero/)

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/32.d0
       aw(:68)=(/   a,   a,zero,   a,   a,zero,   !   1-6
     &      zero,zero,zero,zero,zero,zero,   !   7-12
     &         a,   a,zero,zero,zero,zero,   !  13-18
     &      zero,zero,zero,zero,zero,zero,   !  19-24
     &         a,   a,zero,zero,   a,   a,   !  25-30
     &         a,   a,zero,   a,   a,zero,   !  31-36
     &         a,   a,zero,   a,   a,zero,   !  37-42
     &         a,   a,zero,   a,   a,zero,   !  43-48
     &      zero,zero,zero,zero,   a,   a,   !  49-54
     &         a,   a,zero,zero,zero,zero,   !  55-60
     &         a,   a,   a,zero,zero,   a,   !  61-66
     &         a,   a/)

      else if (iproc == 101) then

       chproc='u  mu+ mu- u~ '

       m3=mu                     ! Final particle masses and widths
       m4=mmu
       m5=mmu
       m6=mu

       gam3=gamu                 ! Final particle masses and widths
       gam4=gammu
       gam5=gammu
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 102) then

       chproc='u  ta+ ta- u~ '

       m3=mu                     ! Final particle masses and widths
       m4=mtau
       m5=mtau
       m6=mu

       gam3=gamu                 ! Final particle masses and widths
       gam4=gamtau
       gam5=gamtau
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 103) then

       chproc='u  vm~ vm  u~ '

       m3=mu                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=mu

       gam3=gamu                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/3.d0

       aw0(2)=a
       aw0(5)=a
       aw0(9)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/12.d0
       aw(:68)=(/zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero/)

      else if (iproc == 104) then

       chproc='u  vt~ vt  u~ '

       m3=mu                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=mu

       gam3=gamu                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/3.d0
       aw0(:14)=(/zero,a,zero,zero,a,zero,zero,zero,a,zero,zero,
     &            zero,zero,zero/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/12.d0
       aw(:68)=(/zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero/)

      else if (iproc == 105) then

       chproc='c  mu+ mu- c~ '

       m3=mc                     ! Final particle masses and widths
       m4=mmu
       m5=mmu
       m6=mc

       gam3=gamc                 ! Final particle masses and widths
       gam4=gammu
       gam5=gammu
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 106) then

       chproc='c  ta+ ta- c~ '

       m3=mc                     ! Final particle masses and widths
       m4=mtau
       m5=mtau
       m6=mc

       gam3=gamc                 ! Final particle masses and widths
       gam4=gamtau
       gam5=gamtau
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 107) then

       chproc='c  vm~ vm  c~ '

       m3=mc                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=mc

       gam3=gamc                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/4.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a
        aw0(17)=a

        a=1.d0/16.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
        aw(69:72)=a
       else
        a=1.d0/3.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a

        a=1.d0/12.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
       end if

      else if (iproc == 108) then

       chproc='c  vt~ vt  c~ '

       m3=mc                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=mc

       gam3=gamc                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/4.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a
        aw0(17)=a

        a=1.d0/16.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
        aw(69:72)=a
       else
        a=1.d0/3.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a

        a=1.d0/12.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
       end if

      else if (iproc == 109) then

       chproc='t  mu+ mu- t~ '

       m3=mt                     ! Final particle masses and widths
       m4=mmu
       m5=mmu
       m6=mt

       gam3=gamt                 ! Final particle masses and widths
       gam4=gammu
       gam5=gammu
       gam6=gamt

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 110) then

       chproc='t  ta+ ta- t~ '

       m3=mt                     ! Final particle masses and widths
       m4=mtau
       m5=mtau
       m6=mt

       gam3=gamt                 ! Final particle masses and widths
       gam4=gamtau
       gam5=gamtau
       gam6=gamt

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 111) then

       chproc='t  vm~ vm  t~ '

       m3=mt                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=mt

       gam3=gamt                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamt

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/4.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a
        aw0(17)=a

        a=1.d0/16.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
        aw(69:72)=a
       else
        a=1.d0/3.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a

        a=1.d0/12.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
       end if

      else if (iproc == 112) then

       chproc='t  vt~ vt  t~ '

       m3=mt                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=mt

       gam3=gamt                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamt

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/4.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a
        aw0(17)=a

        a=1.d0/16.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
        aw(69:72)=a
       else
        a=1.d0/3.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a

        a=1.d0/12.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
       end if

      else if (iproc == 113) then

       chproc='d  mu+ mu- d~ '

       m3=md                     ! Final particle masses and widths
       m4=mmu
       m5=mmu
       m6=md

       gam3=gamd                 ! Final particle masses and widths
       gam4=gammu
       gam5=gammu
       gam6=gamd

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 114) then

       chproc='d  ta+ ta- d~ '

       m3=md                     ! Final particle masses and widths
       m4=mtau
       m5=mtau
       m6=md

       gam3=gamd                 ! Final particle masses and widths
       gam4=gamtau
       gam5=gamtau
       gam6=gamd

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 115) then

       chproc='d  vm~ vm  d~ '

       m3=md                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=md

       gam3=gamd                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamd

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/3.d0
       aw0(:14)=(/zero,a,zero,zero,a,zero,zero,zero,a,zero,zero,zero,
     &            zero,zero/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/12.d0
       aw(:68)=(/zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero/)

      else if (iproc == 116) then

       chproc='d  vt~ vt  d~ '

       m3=md                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=md

       gam3=gamu                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamu

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/3.d0
       aw0(:14)=(/zero,a,zero,zero,a,zero,zero,zero,a,zero,zero,zero,
     &            zero,zero/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/12.d0
       aw(:68)=(/zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,   a,   a,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero/)

      else if (iproc == 117) then

       chproc='s  mu+ mu- s~ '

       m3=ms                     ! Final particle masses and widths
       m4=mmu
       m5=mmu
       m6=ms

       gam3=gams                 ! Final particle masses and widths
       gam4=gammu
       gam5=gammu
       gam6=gams

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 118) then

       chproc='s  ta+ ta- s~ '

       m3=ms                     ! Final particle masses and widths
       m4=mtau
       m5=mtau
       m6=ms

       gam3=gams                 ! Final particle masses and widths
       gam4=gamtau
       gam5=gamtau
       gam6=gams

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 119) then

       chproc='s  vm~ vm  s~ '

       m3=ms                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=ms

       gam3=gams                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gams

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/4.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a
        aw0(17)=a

        a=1.d0/16.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
        aw(69:72)=a
       else
        a=1.d0/3.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a

        a=1.d0/12.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
       end if

      else if (iproc == 120) then

       chproc='s  vt~ vt  s~ '

       m3=ms                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=ms

       gam3=gams                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gams

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/4.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a
        aw0(17)=a

        a=1.d0/16.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
        aw(69:72)=a
       else
        a=1.d0/3.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a

        a=1.d0/12.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
       end if

      else if (iproc == 121) then

       chproc='b  mu+ mu- b~ '

       m3=mb                     ! Final particle masses and widths
       m4=mmu
       m5=mmu
       m6=mb

       gam3=gamb                 ! Final particle masses and widths
       gam4=gammu
       gam5=gammu
       gam6=gamb

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 122) then

       chproc='b  ta+ ta- b~ '

       m3=mb                     ! Final particle masses and widths
       m4=mtau
       m5=mtau
       m6=mb

       gam3=gamb                 ! Final particle masses and widths
       gam4=gamtau
       gam5=gamtau
       gam6=gamb

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 123) then

       chproc='b  vm~ vm  b~ '

       m3=mb                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=mb

       gam3=gamb                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamb

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/4.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a
        aw0(17)=a

        a=1.d0/16.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
        aw(69:72)=a
       else
        a=1.d0/3.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a

        a=1.d0/12.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
       end if

      else if (iproc == 124) then

       chproc='b  vt~ vt  b~ '

       m3=mb                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=mb

       gam3=gamb                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamb

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/4.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a
        aw0(17)=a

        a=1.d0/16.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
        aw(69:72)=a
       else
        a=1.d0/3.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a

        a=1.d0/12.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
       end if

      else if (iproc == 125) then

       chproc='mu- ta+ ta- mu+ '

       m3=mmu                     ! Final particle masses and widths
       m4=mtau
       m5=mtau
       m6=mmu

       gam3=gammu                 ! Final particle masses and widths
       gam4=gamtau
       gam5=gamtau
       gam6=gammu

       ga3p=gll
       ga3m=gll
       gz3m=zllm
       gz3p=zllp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gll
       ga6m=gll
       gz6m=zllm
       gz6p=zllp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 126) then

       chproc='mu- vt~ vt  mu+ '

       m3=mmu                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=mmu

       gam3=gammu                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gammu

       ga3p=gll
       ga3m=gll
       gz3m=zllm
       gz3p=zllp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=gll
       ga6m=gll
       gz6m=zllm
       gz6p=zllp

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/4.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a
        aw0(17)=a

        a=1.d0/16.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
        aw(69:72)=a
       else
        a=1.d0/3.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a

        a=1.d0/12.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
       end if

      else if (iproc == 127) then

       chproc='ta- vm~ vm  ta+ '

       m3=mtau                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=mtau

       gam3=gamtau                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=gamtau

       ga3p=gll
       ga3m=gll
       gz3m=zllm
       gz3p=zllp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=gll
       ga6m=gll
       gz6m=zllm
       gz6p=zllp

       n3=2
       n4=1
       n5=1
       n6=2

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=1.d0/4.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a
        aw0(17)=a

        a=1.d0/16.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
        aw(69:72)=a
       else
        a=1.d0/3.d0
        aw0(2)=a
        aw0(5)=a
        aw0(9)=a

        a=1.d0/12.d0
        aw(7:10)=a
        aw(25:28)=a
        aw(49:52)=a
       end if

      else if (iproc == 128) then

       chproc='vt  vm~ vm  vt~ '

       m3=zero                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=1
       n5=1
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0
       aw0(5)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=0.5d0
       aw(:68)=(/zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero/)

      else if (iproc == 201) then

       chproc='u e+ e- u~ '

       m3=mu                     ! Final particle masses and widths
       m4=me
       m5=me
       m6=mu

       gam3=gamu                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 202) then

       chproc='c e+ e- c~ '

       m3=mc                     ! Final particle masses and widths
       m4=me
       m5=me
       m6=mc

       gam3=gamc                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 203) then

       chproc='t e+ e- t~ '

       m3=mt                     ! Final particle masses and widths
       m4=me
       m5=me
       m6=mt

       gam3=gamt                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=gamt

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 204) then

       chproc='d e+ e- d~ '

       m3=md                     ! Final particle masses and widths
       m4=me
       m5=me
       m6=md

       gam3=gamd                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=gamd

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 205) then

       chproc='s e+ e- s~ '

       m3=ms                     ! Final particle masses and widths
       m4=me
       m5=me
       m6=ms

       gam3=gams                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=gams

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 206) then

       chproc='b e+ e- b~ '

       m3=mb                     ! Final particle masses and widths
       m4=me
       m5=me
       m6=mb

       gam3=gamb                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=gamb

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=ncol

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 207) then

       chproc='mu- e+ e-  mu+ '

       m3=mmu                     ! Final particle masses and widths
       m4=me
       m5=me
       m6=mmu

       gam3=gammu                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=gammu

       ga3p=gll
       ga3m=gll
       gz3m=zllm
       gz3p=zllp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gll
       ga6m=gll
       gz6m=zllm
       gz6p=zllp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 208) then

       chproc='ta- e+ e- ta+ '

       m3=mtau                     ! Final particle masses and widths
       m4=me
       m5=me
       m6=mtau

       gam3=gamtau                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=gamtau

       ga3p=gll
       ga3m=gll
       gz3m=zllm
       gz3p=zllp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gll
       ga6m=gll
       gz6m=zllm
       gz6p=zllp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 209) then

       chproc='vm  e+ e-  vm~ '

       m3=zero                     ! Final particle masses and widths
       m4=me
       m5=me
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/6.d0
       aw0(:14)=(/zero,zero,a,zero,a,zero,zero,zero,zero,a,zero,a,a,a/) 

       a=1.d0/14.d0
       aw(:68)=(/zero,zero,zero,zero,zero,zero,   !   1-6
     &      zero,zero,zero,zero,   a,   a,   !   7-12
     &         a,   a,zero,zero,zero,zero,   !  13-18
     &      zero,zero,zero,zero,zero,zero,   !  19-24
     &      a   ,   a,zero,zero,   a,   a,   !  25-30
     &      zero,zero,zero,zero,zero,zero,   !  31-36
     &      zero,zero,zero,zero,zero,zero,   !  37-42
     &      zero,zero,zero,zero,zero,zero,   !  43-48
     &      zero,zero,zero,zero,   a,   a,   !  49-54
     &         a,   a,zero,zero,zero,zero,   !  55-60
     &      zero,zero,zero,zero,zero,zero,   !  61-66
     &         a,   a/)

      else if (iproc == 210) then

       chproc='vt  e+ e-  vt~ '

       m3=zero                     ! Final particle masses and widths
       m4=me
       m5=me
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/6.d0
       aw0(:14)=(/zero,zero,a,zero,a,zero,zero,zero,zero,a,zero,a,a,a/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/14.d0
       aw(:68)=(/zero,zero,zero,zero,zero,zero,   !   1-6
     &      zero,zero,zero,zero,   a,   a,   !   7-12
     &         a,   a,zero,zero,zero,zero,   !  13-18
     &      zero,zero,zero,zero,zero,zero,   !  19-24
     &      a   ,   a,zero,zero,   a,   a,   !  25-30
     &      zero,zero,zero,zero,zero,zero,   !  31-36
     &      zero,zero,zero,zero,zero,zero,   !  37-42
     &      zero,zero,zero,zero,zero,zero,   !  43-48
     &      zero,zero,zero,zero,   a,   a,   !  49-54
     &         a,   a,zero,zero,zero,zero,   !  55-60
     &      zero,zero,zero,zero,zero,zero,   !  61-66
     &         a,   a/)

      else if (iproc == 211) then

       chproc='ve  u~  u  ve~ '

       m3=zero                     ! Final particle masses and widths
       m4=mu
       m5=mu
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=gamu
       gam5=gamu
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=guu
       ga4m=guu
       gz4m=zuum
       gz4p=zuup

       ga5p=guu
       ga5m=guu
       gz5m=zuum
       gz5p=zuup

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=ncol

       ckm=(/1.d0,zero,zero/)
       cmq=(/cmplx(md,-gamd/2.d0,dp),cmplx(ms,-gams/2.d0,dp),
     &                              cmplx(mb,-gamb/2.d0,dp)/)

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=0.25d0
       aw0(3)=a
       aw0(5)=a
       aw0(10)=a
       aw0(12)=a

       a=1.d0/14.d0
       aw(11:14)=a
       aw(25:26)=a
       aw(29:30)=a
       aw(53:56)=a
       aw(67:68)=a

      else if (iproc == 212) then

       chproc='ve  c~  c  ve~ '

       m3=zero                     ! Final particle masses and widths
       m4=mc
       m5=mc
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=gamc
       gam5=gamc
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=guu
       ga4m=guu
       gz4m=zuum
       gz4p=zuup

       ga5p=guu
       ga5m=guu
       gz5m=zuum
       gz5p=zuup

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=ncol

       ckm=(/zero,1.d0,zero/)
       cmq=(/cmplx(md,-gamd/2.d0,dp),cmplx(ms,-gams/2.d0,dp),
     &                              cmplx(mb,-gamb/2.d0,dp)/)

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=0.2d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a
        aw0(18)=a

        a=1.d0/18.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
        aw(75:76)=a
        aw(79:80)=a
       else
        a=0.25d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a

        a=1.d0/14.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
       end if

      else if (iproc == 213) then

       chproc='ve  t~  t  ve~ '

       m3=zero                     ! Final particle masses and widths
       m4=mt
       m5=mt
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=gamt
       gam5=gamt
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=guu
       ga4m=guu
       gz4m=zuum
       gz4p=zuup

       ga5p=guu
       ga5m=guu
       gz5m=zuum
       gz5p=zuup

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=ncol

       ckm=(/zero,zero,1.d0/)
       cmq=(/cmplx(md,-gamd/2.d0,dp),cmplx(ms,-gams/2.d0,dp),
     &                              cmplx(mb,-gamb/2.d0,dp)/)

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=0.2d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a
        aw0(18)=a

        a=1.d0/18.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
        aw(75:76)=a
        aw(79:80)=a
       else
        a=0.25d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a

        a=1.d0/14.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
       end if

      else if (iproc == 214) then

       chproc='ve  d~  d  ve~ '

       m3=zero                     ! Final particle masses and widths
       m4=md
       m5=md
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=gamd
       gam5=gamd
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=ncol

       ckm=(/1.d0,zero,zero/)
       cmq=(/cmplx(mu,-gamu/2.d0,dp),cmplx(mc,-gamc/2.d0,dp),
     &                              cmplx(mt,-gamt/2.d0,dp)/)

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=0.25d0
       aw0(3)=a
       aw0(5)=a
       aw0(10)=a
       aw0(12)=a

       a=1.d0/14.d0
       aw(11:14)=a
       aw(25:26)=a
       aw(29:30)=a
       aw(53:56)=a
       aw(67:68)=a

      else if (iproc == 215) then

       chproc='ve  s~  s  ve~ '

       m3=zero                     ! Final particle masses and widths
       m4=ms
       m5=ms
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=gams
       gam5=gams
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=ncol

       ckm=(/zero,1.d0,zero/)
       cmq=(/cmplx(mu,-gamu/2.d0,dp),cmplx(mc,-gamc/2.d0,dp),
     &                              cmplx(mt,-gamt/2.d0,dp)/)

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=0.2d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a
        aw0(18)=a

        a=1.d0/18.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
        aw(75:76)=a
        aw(79:80)=a
       else
        a=0.25d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a

        a=1.d0/14.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
       end if

      else if (iproc == 216) then

       chproc='ve  b~  b  ve~ '

       m3=zero                     ! Final particle masses and widths
       m4=mb
       m5=mb
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=gamb
       gam5=gamb
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=ncol

       ckm=(/zero,zero,1.d0/)
       cmq=(/cmplx(mu,-gamu/2.d0,dp),cmplx(mc,-gamc/2.d0,dp),
     &                              cmplx(mt,-gamt/2.d0,dp)/)

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=0.2d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a
        aw0(18)=a

        a=1.d0/18.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
        aw(75:76)=a
        aw(79:80)=a
       else
        a=0.25d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a

        a=1.d0/14.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
       end if

      else if (iproc == 217) then

       chproc='ve  mu+ mu- ve~ '

       m3=zero                     ! Final particle masses and widths
       m4=mmu
       m5=mmu
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=gammu
       gam5=gammu
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=0.2d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a
        aw0(18)=a

        a=1.d0/18.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
        aw(75:76)=a
        aw(79:80)=a
       else
        a=0.25d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a

        a=1.d0/14.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
       end if

      else if (iproc == 218) then

       chproc='ve  ta+ ta-  ve~ '

       m3=zero                     ! Final particle masses and widths
       m4=mtau
       m5=mtau
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=gamtau
       gam5=gamtau
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=2
       n5=2
       n6=1

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1
c and the hard bremsstrahlung: aw(1)+...+aw(130)=1

       if (ihiggs == 1) then
        a=0.2d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a
        aw0(18)=a

        a=1.d0/18.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
        aw(75:76)=a
        aw(79:80)=a
       else
        a=0.25d0
        aw0(3)=a
        aw0(5)=a
        aw0(10)=a
        aw0(12)=a

        a=1.d0/14.d0
        aw(11:14)=a
        aw(25:26)=a
        aw(29:30)=a
        aw(53:56)=a
        aw(67:68)=a
       end if

      else if (iproc == 219) then

       chproc='ve  vm~ vm  ve~ '

       m3=zero                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=1
       n5=1
       n6=1

       cml=cmplx(mmu,-gammu/2.d0,dp)

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/2.d0

       aw0(:14)=(/zero,zero,zero,zero,a,zero,zero,zero,zero,zero,zero,
     &                                                    a,zero,zero/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/4.d0

       aw(:68)=(/zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a/)

      else if (iproc == 220) then

       chproc='ve  vt~ vt  ve~ '

       m3=zero                     ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=zero

       gam3=zero                 ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=1
       n5=1
       n6=1

       cml=cmplx(mtau,-gamtau/2.d0,dp)

       colfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0/2.d0

       aw0(:14)=(/zero,zero,zero,zero,a,zero,zero,zero,zero,zero,zero,
     &                                                    a,zero,zero/) 

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/4.d0

       aw(:68)=(/zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &      zero,zero,zero,zero,zero,zero,
     &         a,   a/)

      else if (iproc == 301) then

       chproc='u d~ d u~'

       m3=mu                 ! Final particle masses and widths
       m4=md
       m5=md
       m6=mu

       gam3=gamu               ! Final particle masses and widths
       gam4=gamd
       gam5=gamd
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/34.d0
      aw0(1:5)=a
      aw0(7:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/118.d0
      aw(1:30)=a
      aw(36:60)=a
      aw(66:80)=a
      aw(83:130)=a

      else if (iproc == 302) then

       chproc='u  s~  s   u~ '

       m3=mu                 ! Final particle masses and widths
       m4=ms
       m5=ms
       m6=mu

       gam3=gamu               ! Final particle masses and widths
       gam4=gams
       gam5=gams
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 303) then

       chproc='u  b~  b   u~ '

       m3=mu                 ! Final particle masses and widths
       m4=mb
       m5=mb
       m6=mu

       gam3=gamu               ! Final particle masses and widths
       gam4=gamb
       gam5=gamb
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 304) then

       chproc='c  d~  d   c~ '

       m3=mc                 ! Final particle masses and widths
       m4=md
       m5=md
       m6=mc

       gam3=gamc               ! Final particle masses and widths
       gam4=gamd
       gam5=gamd
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 305) then

       chproc='c  s~  s   c~ '

       m3=mc                 ! Final particle masses and widths
       m4=ms
       m5=ms
       m6=mc

       gam3=gamc               ! Final particle masses and widths
       gam4=gams
       gam5=gams
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/34.d0
      aw0(1:5)=a
      aw0(7:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/118.d0
      aw(1:30)=a
      aw(36:60)=a
      aw(66:80)=a
      aw(83:130)=a

      else if (iproc == 306) then

       chproc='c  b~  b   c~ '

       m3=mc                 ! Final particle masses and widths
       m4=mb
       m5=mb
       m6=mc

       gam3=gamc               ! Final particle masses and widths
       gam4=gamc
       gam5=gamc
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 307) then

       chproc='t  d~  d   t~ '

       m3=mt                 ! Final particle masses and widths
       m4=md
       m5=md
       m6=mt

       gam3=gamt               ! Final particle masses and widths
       gam4=gamd
       gam5=gamd
       gam6=gamt

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 308) then

       chproc='t  s~  s   t~ '

       m3=mt                 ! Final particle masses and widths
       m4=ms
       m5=ms
       m6=mt

       gam3=gamt               ! Final particle masses and widths
       gam4=gams
       gam5=gams
       gam6=gamt

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 309) then

       chproc='t  b~  b   t~ '

       m3=mt                 ! Final particle masses and widths
       m4=mb
       m5=mb
       m6=mt

       gam3=gamt               ! Final particle masses and widths
       gam4=gamb
       gam5=gamb
       gam6=gamt

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=1.d0

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/34.d0
      aw0(1:5)=a
      aw0(7:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/118.d0
      aw(1:30)=a
      aw(36:60)=a
      aw(66:80)=a
      aw(83:130)=a

      else if (iproc == 310) then

       chproc='d  s~  s   d~ '

       m3=md                 ! Final particle masses and widths
       m4=ms
       m5=ms
       m6=md

       gam3=gamd               ! Final particle masses and widths
       gam4=gams
       gam5=gams
       gam6=gamd

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0  ! Irrelevant

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 311) then

       chproc='d  b~  b   d~ '

       m3=md                 ! Final particle masses and widths
       m4=mb
       m5=mb
       m6=md

       gam3=gamd               ! Final particle masses and widths
       gam4=gamb
       gam5=gamb
       gam6=gamd

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0  ! Irrelevant

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 312) then

       chproc='u  c~  c   u~ '

       m3=mu                 ! Final particle masses and widths
       m4=mc
       m5=mc
       m6=mu

       gam3=gamu               ! Final particle masses and widths
       gam4=gamc
       gam5=gamc
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=guu
       ga4m=guu
       gz4m=zuum
       gz4p=zuup

       ga5p=guu
       ga5m=guu
       gz5m=zuum
       gz5p=zuup

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0  ! Irrelevant

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 313) then

       chproc='u  t~  t   u~ '

       m3=mu                 ! Final particle masses and widths
       m4=mt
       m5=mt
       m6=mu

       gam3=gamu               ! Final particle masses and widths
       gam4=gamt
       gam5=gamt
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=guu
       ga4m=guu
       gz4m=zuum
       gz4p=zuup

       ga5p=guu
       ga5m=guu
       gz5m=zuum
       gz5p=zuup

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0  ! Irrelevant

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 314) then

       chproc='c  t~  t   c~ '

       m3=mc                 ! Final particle masses and widths
       m4=mt
       m5=mt
       m6=mc

       gam3=gamc               ! Final particle masses and widths
       gam4=gamt
       gam5=gamt
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=guu
       ga4m=guu
       gz4m=zuum
       gz4p=zuup

       ga5p=guu
       ga5m=guu
       gz5m=zuum
       gz5p=zuup

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=1.d0
       ckmfac=0.d0  ! Irrelevant

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 401) then

       chproc='mu- mu+ mu- mu+'

       m3=mmu                 ! Final particle masses and widths
       m4=mmu
       m5=mmu
       m6=mmu

       gam3=gammu               ! Final particle masses and widths
       gam4=gammu
       gam5=gammu
       gam6=gammu

       ga3p=gll
       ga3m=gll
       gz3m=zllm
       gz3p=zllp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gll
       ga6m=gll
       gz6m=zllm
       gz6p=zllp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 402) then

       chproc='ta- ta+ ta- ta+'

       m3=mtau                 ! Final particle masses and widths
       m4=mtau
       m5=mtau
       m6=mtau

       gam3=gamtau               ! Final particle masses and widths
       gam4=gamtau
       gam5=gamtau
       gam6=gamtau

       ga3p=gll
       ga3m=gll
       gz3m=zllm
       gz3p=zllp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gll
       ga6m=gll
       gz6m=zllm
       gz6p=zllp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 403) then

       chproc='vm vm~ vm vm~'

       m3=zero                 ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=zero

       gam3=zero               ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=1
       n5=1
       n6=1

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0
       aw0(5)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/2.d0
       aw(25:26)=a

      else if (iproc == 404) then

       chproc='vt vt~ vt vt~ '

       m3=zero                 ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=zero

       gam3=zero               ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=1
       n5=1
       n6=1

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0
       aw0(5)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/2.d0
       aw(25:26)=a

      else if (iproc == 405) then

       chproc='e- e+ e- e+'

       m3=me                 ! Final particle masses and widths
       m4=me
       m5=me
       m6=me

       gam3=game               ! Final particle masses and widths
       gam4=game
       gam5=game
       gam6=game

       ga3p=gll
       ga3m=gll
       gz3m=zllm
       gz3p=zllp

       ga4p=gll
       ga4m=gll
       gz4m=zllm
       gz4p=zllp

       ga5p=gll
       ga5m=gll
       gz5m=zllm
       gz5p=zllp

       ga6p=gll
       ga6m=gll
       gz6m=zllm
       gz6p=zllp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 406) then

       chproc='u  u~  u   u~ '

       m3=mu                 ! Final particle masses and widths
       m4=mu
       m5=mu
       m6=mu

       gam3=gamu               ! Final particle masses and widths
       gam4=gamu
       gam5=gamu
       gam6=gamu

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=guu
       ga4m=guu
       gz4m=zuum
       gz4p=zuup

       ga5p=guu
       ga5m=guu
       gz5m=zuum
       gz5p=zuup

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 407) then

       chproc='c  c~  c   c~ '

       m3=mc                 ! Final particle masses and widths
       m4=mc
       m5=mc
       m6=mc

       gam3=gamc               ! Final particle masses and widths
       gam4=gamc
       gam5=gamc
       gam6=gamc

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=guu
       ga4m=guu
       gz4m=zuum
       gz4p=zuup

       ga5p=guu
       ga5m=guu
       gz5m=zuum
       gz5p=zuup

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 408) then

       chproc='t  t~  t   t~ '

       m3=mt                 ! Final particle masses and widths
       m4=mt
       m5=mt
       m6=mt

       gam3=gamt               ! Final particle masses and widths
       gam4=gamt
       gam5=gamt
       gam6=gamt

       ga3p=guu
       ga3m=guu
       gz3m=zuum
       gz3p=zuup

       ga4p=guu
       ga4m=guu
       gz4m=zuum
       gz4p=zuup

       ga5p=guu
       ga5m=guu
       gz5m=zuum
       gz5p=zuup

       ga6p=guu
       ga6m=guu
       gz6m=zuum
       gz6p=zuup

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 409) then

       chproc='d  d~  d   d~ '

       m3=md                 ! Final particle masses and widths
       m4=md
       m5=md
       m6=md

       gam3=gamd               ! Final particle masses and widths
       gam4=gamd
       gam5=gamd
       gam6=gamd

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 410) then

       chproc='s  s~  s   s~ '

       m3=ms                 ! Final particle masses and widths
       m4=ms
       m5=ms
       m6=ms

       gam3=gams               ! Final particle masses and widths
       gam4=gams
       gam5=gams
       gam6=gams

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 411) then

       chproc='b  b~  b   b~ '

       m3=mb                 ! Final particle masses and widths
       m4=mb
       m5=mb
       m6=mb

       gam3=gamb               ! Final particle masses and widths
       gam4=gamb
       gam5=gamb
       gam6=gamb

       ga3p=gdd
       ga3m=gdd
       gz3m=zddm
       gz3p=zddp

       ga4p=gdd
       ga4m=gdd
       gz4m=zddm
       gz4p=zddp

       ga5p=gdd
       ga5m=gdd
       gz5m=zddm
       gz5p=zddp

       ga6p=gdd
       ga6m=gdd
       gz6m=zddm
       gz6p=zddp

       n3=2
       n4=2
       n5=2
       n6=2

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

      a=1.d0/31.d0
      aw0(2:5)=a
      aw0(9:10)=a
      aw0(12)=a
      aw0(17:18)=a
      aw0(24:45)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

      a=1.d0/98.d0
      aw(7:30)=a
      aw(49:60)=a
      aw(67:80)=a
      aw(83:130)=a

      else if (iproc == 412) then

       chproc='ve ve~ ve ve~ '

       m3=zero                 ! Final particle masses and widths
       m4=zero
       m5=zero
       m6=zero

       gam3=zero               ! Final particle masses and widths
       gam4=zero
       gam5=zero
       gam6=zero

       ga3p=zero
       ga3m=zero
       gz3m=znnm
       gz3p=znnp

       ga4p=zero
       ga4m=zero
       gz4m=znnm
       gz4p=znnp

       ga5p=zero
       ga5m=zero
       gz5m=znnm
       gz5p=znnp

       ga6p=zero
       ga6m=zero
       gz6m=znnm
       gz6p=znnp

       n3=1
       n4=1
       n5=1
       n6=1

       colfac=0.25d0 ! a phase factor for two pairs of idetical particles

c Arbitrary weights for the Born cross section: aw0(1)+...+aw0(45)=1

       a=1.d0
       aw0(5)=a

c Arbitrary weights for the hard bremsstrahlung: aw(1)+...+aw(130)=1

       a=1.d0/2.d0
       aw(25:26)=a

      end if

c Identical partiles, nid=4 (yes)/1 (no):

      if (iproc > 400) then
       nid=4
       aw0=aw0/dble(nid)
       aw=aw/dble(nid)
      else 
       nid=1
      end if

c Complex fermion masses:

      cm1=cmplx(m1,-gam1/2.d0,dp)
      cm2=cmplx(m2,-gam2/2.d0,dp)
      cm3=cmplx(m3,-gam3/2.d0,dp)
      cm4=cmplx(m4,-gam4/2.d0,dp)
      cm5=cmplx(m5,-gam5/2.d0,dp)
      cm6=cmplx(m6,-gam6/2.d0,dp)

c Higgs boson couplings to fermions of a given process:

      hff=chff*(/m1,m2,m3,m4,m5,m6/)

c Colour coefficients of diagrams:

      ceval43=(/7.17157287525381d0,12.8284271247462d0/)
      cevec43(1,:)=(/(0.482786869146840d0, i=1,6),
     &     (-0.792134719419879d0, i=1,6),(0.373415887810067d0, i=1,4)/)
      cevec43(2,:)=(/(-0.755820524374899d0, i=1,6),
     &    (-0.592269749231553d0, i=1,6),(-0.279198637315525d0, i=1,4)/)

      ceval64=(/8.66666666666666d0,13.3333333333333d0/)
      cevec64(1,:)=(/0.588348405414552d0,-0.588348405414552d0,
     &              -0.392232270276368d0,0.392232270276368d0/)
      cevec64(2,:)=(/-0.670820393249937d0,-0.670820393249937d0,
     &               -0.223606797749979d0,-0.223606797749979d0/)


c Numbers of helicity states of generalized polarization vectors:

      n12=n1*n2
      n36=n3*n6
      n54=n5*n4
      n127=n12*n7
      n367=n36*n7
      n547=n54*n7

c Common factors:

      comf1=colfac/dble(n1*n2)
      comf2=(abs(cmplx(e0,0.d0,dp)/cew))**2*colfac/dble(n1*n2)

c      if (iwtb == 1) then

c      f1=1.d0-3.d0*rwt**4+2.d0*rwt**6+3.d0*rwt**2*gwt**2
c     &  -6.d0*rwt**4*gwt**2
c     &  -6.d0*f2m*(2.d0*rwt**3-rwt**5-gwt-2.d0*rwt*gwt**2
c     &                                    +3.d0*rwt**3*gwt**2)
c     &  +(f2m**2+f2p**2)*(2.d0-3.d0*rwt**2+rwt**6+3.d0*gwt**2
c     &                    -6.d0*rwt**4*gwt**2+rwt**2*gwt**4)

c      f2=3.d0*rwt**4-3.d0*rwt**6+rwt**4*gwt**2
c     &  -3.d0*f2m*(rwt-4.d0*rwt**3+3.d0*rwt**5-rwt**3*gwt**2)
c     &  +(f2m**2+f2p**2)*(-1.d0+3.d0*rwt**2-2.d0*rwt**6
c     &                                   +2.d0*rwt**4*gwt**2)

c      f3=-3.d0*f2m*(3.d0-4.d0*rwt**2)
c     &  +(f2m**2+f2p**2)*(-1.d0/3.d0+rwt**2+3.d0*rwt**4-rwt**2*gwt**2)

c      gamt3=gmu**2*mt**3*mw**2/(96.d0*pi**3)
c     &     *(f1*mw/gamw*(pi
c     &       -atan(mt**2*gamw/(mw*(mt**2-mw**2-gamw**2))))
c     &      +f2
c     &  *log(mw**2*(mw**2+gamw**2)/((mt**2-mw**2)**2+mw**2*gamw**2))
c     &      +f3)

c      gamt2=gmu*mt**3/(8.d0*sqrt(2.d0)*pi)*(1.d0-rwt**2)**2
c     &    *(1.d0+2.d0*rwt**2+6.d0*f2m*rwt
c     &       +(f2m**2+f2p**2)*(2.d0+rwt**2))

c      end if

      end subroutine parspec
