      subroutine spinc(p,x,y)
c----------------------------------------------------------------------c
c Returns the contractions: 
c      x = p(0)*I - p(i)*sigma(i) and y = p(0)*I + p(i)*sigma(i), 
c where I is the 2 x 2 unit matrix and sigma(i) are the Pauli matrices
c
c Input: the complex four vector p
c
c                        Karol Kolodziej  
c                       kolodzie@us.edu.pl
c Zeuthen, 01.04.1998
c----------------------------------------------------------------------c

      implicit none
      complex(kind(1.d0)) icom,p(0:3),x(2,2),y(2,2)

      data icom/(0.d0,1.d0)/

      save


c                              x11  x21 
c                              x12  x22
      x=reshape((/ p(0)-p(3),     -p(1)-icom*p(2),
     &            -p(1)+icom*p(2), p(0)+p(3)     /),(/2,2/))

c                              y11  y21 
c                              y12  y22
      y=reshape((/ x(2,2),         p(1)+icom*p(2),
     &             p(1)-icom*p(2), x(1,1)        /),(/2,2/))

      end

